(function(){
var additionalData = [
["Pages/Page_54693503.html","1. はじめに",
"1. はじめに\n本ドキュメントは、CTR-SDK の GD ライブラリを用いたプログラミングについて説明したものです。グラフィックスの基本的な概念や一部ライブラリ（GX ライブラリなど）の使用方法については既に習得していることを前提としており、純粋に GD ライブラリに焦点を当てた内容となっています。\n本書は「3DS プログラミングマニュアル」の「グラフィックス基本編」および「グラフィックス応用編」に記載されている内容を理解していることを前提に書かれています。本書を読む前に、これらのドキュメントをご一読ください。\n",0]
,["Pages/Page_54693503.html#PageId_54693504","1.1. GD ライブラリとは",
"1.1. GD ライブラリとは\nGD ライブラリは CTR-SDK のグラフィックスライブラリの 1 つです。主に 3D コマンドの生成を行う目的で使用します。\nGPU の状態と同期する内部状態をもとにライブラリが必要な 3D コマンドのみを生成しますので、GPU の状態を意識せずにグラフィックス処理を実装することができます。また、API の構成は 3DS のグラフィックスハードウェア構成と密接に結びついており、アプリケーションで簡単に用いることが可能でありながらも、高いパフォーマンスを引き出せるように設計されています。\nGD ライブラリは DMPGL（gl 関数）との互換性はありません。コマンドリストの管理など、一部のシステム系機能については GX ライブラリ（nngx 関数）を用いる必要があります。また、C++ のインターフェースのみが提供されています。\n",0]
,["Pages/Page_54693503.html#PageId_54693505","1.1.1. コマンドリスト",
"1.1.1. コマンドリスト\n先に述べたように、GD ライブラリではコマンドリストの操作を管理しておらず、GX ライブラリで提供されている機能をそのまま使用することになります。つまり、コマンドリストをどのように準備したり、使用したり、同期を取ったりするかについては、すべてアプリケーションで実装しなければなりません。\n 補足：\n コマンドリクエストを発行する関数はアプリコア（コア 0）でのみ呼び出しが可能です。\n",0]
,["Pages/Page_54693503.html#PageId_54693506","1.1.2. イミディエート関数と非イミディエート関数",
"1.1.2. イミディエート関数と非イミディエート関数\nGD ライブラリでは、現在のコマンドリストオブジェクトで指定されている 3D コマンドバッファに 3D コマンドを書き込むタイミングの違いによって、関数をイミディエート関数と非イミディエート関数の 2 つに分類しています。\nイミディエート関数は、呼ばれたタイミングでデータを 3D コマンドバッファに直接書き込む関数のことを指します。パケットレコーディング機能（「6. パケットレコーディング」参照）を使用する場合に、記録されているパケットを直接編集することができるという利点があります。\n非イミディエート関数は 3D コマンドバッファへの書き込みを行わずに GD ライブラリの内部状態を更新します。これらの内部状態は描画関数（nn::gd::System::Draw() または nn::gd::System::DrawIndexed()）が呼び出された際に読み込まれ、必要に応じて 3D コマンドバッファにデータを書き出します。\n一部の関数はイミディエート関数と非イミディエート関数の両方の性質を持っており、3D コマンドバッファに書き込みを行いつつ GD ライブラリの内部状態を更新することもあります。\n",0]
,["Pages/Page_54693503.html#PageId_54693507","1.1.3. エラーハンドリング",
"1.1.3. エラーハンドリング\n内部で処理に失敗する可能性のある関数は nnResult 型のオブジェクトを返り値として返すように実装されています。つまり、エラーが発生した場合には内容に応じたエラー値が返されます。\nGD ライブラリでエラーをハンドリングする方法は 2 つ存在します。1 つは呼び出した GD 関数の返り値を常にチェックする方法です。もう 1 つは nn::gd::System::SetCallbackFunctionError() を呼び出してエラーハンドリング用のコールバック関数を登録する方法です。これらの方法は同時に使用することができ、コールバックを呼び出したあとで GD 関数そのものの返り値でエラーを受け取ることができます。\n コード 1-1. エラーハンドリング用のコールバック関数の設定\n typedef void (*nn::gd::System::gdCallbackfunctionErrorPtr)(\n nnResult result, const char* functionName);\nstatic void nn::gd::System::SetCallbackFunctionError(\n nn::gd::System::gdCallbackfunctionErrorPtr callbackFunctionError);\n 注意：\n GD 関数内部でのエラーチェックの詳細度は、ビルドの種類（Debug/Development/Release）によって異なります。\nまた、デバッグ用途向けに、与えられた nnResult 型のオブジェクトのエラーに対応したメッセージを nn::gd::System::GetErrorStringFromResult() で取得することができます。\n コード 1-2. エラーメッセージの取得（デバッグ用途のみ）\n static char* nn::gd::System::GetErrorStringFromResult(nnResult result);\n",0]
,["Pages/Page_54693503.html#PageId_54693508","1.2. モジュール",
"1.2. モジュール\nモジュールは 3DS のレンダリングパイプライン内で関連する処理をひとまとめにしたものです。\nGD ライブラリには、以下のモジュールが定義されています。\n 表 1-1. モジュールの一覧\n \tモジュール \t定義名\n \t頂点入力ステージ \t nn::gd::System::MODULE_VERTEX_INPUT\n \tシェーダステージ \t nn::gd::System::MODULE_SHADER\n \tラスタライザステージ \t nn::gd::System::MODULE_RASTERIZER\n \tテクスチャステージ \t nn::gd::System::MODULE_TEXTURE\n \tプロシージャルテクスチャステージ \t nn::gd::System::MODULE_TEXTURE_PROCEDURAL\n \tライティングステージ \t nn::gd::System::MODULE_LIGHTING\n \tコンバイナステージ \t nn::gd::System::MODULE_TEXTURE_COMBINER\n \tフォグステージ \t nn::gd::System::MODULE_GAS_FOG\n \tアウトプットステージ \t nn::gd::System::MODULE_OUTPUT\n 補足：\n パイプラインでの処理が段階的に分けられていることもあり、モジュールのことをステージと記述することがあります。\n",0]
,["Pages/Page_54693503.html#PageId_54693509","1.2.1. Static クラスによる定義",
"1.2.1. Static クラスによる定義\nGD ライブラリのほとんどの関数は各モジュールで定義された static なクラスを介してアクセスします。これらのクラスは static な関数のみを持ち、内部状態を持たず、インスタンス化もされていません。つまり、クラス分けは単純に機能ごとに関数定義をグルーピングするために用いられています。\nなお、各モジュールに対して 1 つ、または複数個のクラスが以下のように用意されています。\n 表 1-2. モジュールと対応するクラス\n \tモジュール \t対応するクラス \t行われる処理\n \t頂点入力ステージ \t VertexInputStage \t頂点バッファの入力\n \tシェーダステージ \t ShaderStage \tシェーダプログラムのアタッチ\n \tラスタライザステージ \t RasterizerStage \tカリング、クリッピング、ビューポート設定、シザリング、アーリーデプステスト\n \tテクスチャステージ \t TextureStage \tテクスチャユニットの設定\n \tプロシージャルテクスチャステージ \t ProceduralTextureStage \tプロシージャルテクスチャの設定\n \tライティングステージ \t LightingStage \tフラグメントライティングの設定\n \tコンバイナステージ \t CombinerStage \tテクスチャコンバイナの設定\n \tフォグステージ \t FogStage \tフォグの設定、ガスの設定\n \tアウトプットステージ \t OutputStage \tデプステスト、ステンシルテスト、アルファテスト、論理演算、ブレンディング、書き込みマスク、レンダーターゲットの設定、フラグメントオペレーションの設定\n",0]
,["Pages/Page_54693503.html#PageId_54693510","1.2.2. モジュールの状態管理",
"1.2.2. モジュールの状態管理\nいくつかのモジュールではライブラリで内部状態が管理されており、2 つのレンダリングパスで内部状態に変更がなかった場合には、そのモジュールに関するコマンドを再送しません。これにより不要なコマンドパケットが生成されず、パフォーマンスを向上させることができます。ただし、何らかの GD 関数の呼び出しによって内部状態が変更された場合、そのモジュールは「dirty」（変更あり）と見なされます。「dirty」と見なされたモジュールはすべて、次回の描画時にその内部状態を参照したコマンド送信が行われます。\nモジュールが「dirty」であるかどうかはライブラリで管理され、自動的に処理されます。そのため GD ライブラリを利用するプログラマは通常、どのモジュールが「dirty」であるかについて気にする必要はありません。しかしながら、モジュールに関連したコマンドすべてを確実に再送したいようなケースもあります。そのような場合のために、GD ライブラリでは明示的にモジュールを「dirty」にする手段を以下の関数で提供しています。\n コード 1-3. モジュールを明示的に「dirty」にする関数\n void nn::gd::System::ForceDirty(u32 moduleFlag);\n moduleFlag には、「dirty」にするモジュールを表 1-1 の定義名の論理和で指定します。\n例えば、事前に作成しておいたコマンドパケットを実行したあとや、ほかのグラフィックスライブラリ（NintendoWare や DMPGL、GR ライブラリなど）の使用によって、ハードウェア状態が更新されてしまっている状況で GD ライブラリのすべての状態を確実に反映させたい場合に有効です。\n",0]
,["Pages/Page_54693503.html#PageId_54693511","1.3. ステートオブジェクトとリソースオブジェクト",
"1.3. ステートオブジェクトとリソースオブジェクト\nステートオブジェクトは、作成後に変更されることのない不変のオブジェクトです。初期化時に作成され、実行時の必要なタイミングでそのステートをパイプラインにセットするような使われ方を想定しています。オブジェクトの作成にはメモリ確保やデータ処理を伴うため時間がかかりますが、そこで作成されたステートをあとで 3D コマンドバッファに出力する際の処理は必要最小限の単純なものだけで済みます。これらステートオブジェクトの中身に直接アクセスする方法は提供されていません。\nステートオブジェクトの作成が要求された場合、GD ライブラリはまず以前に全く同じ設定を持ったオブジェクトが作成されているかどうかを確認します。そこで同じ設定のものが見つかった場合は新たなオブジェクトを作成せず、単にそのオブジェクトへのポインタを返します。\nステートオブジェクトとして以下のものが定義されています。\n 表 1-3. ステートオブジェクト\n \tステートオブジェクト \t使用するステージ \t内包する設定\n \t CombinerState \tコンバイナステージ \tコンバイナ、コンバイナバッファ\n \t BlendState \tアウトプットステージ \t論理演算、ブレンディング\n \t DepthStencilState \tアウトプットステージ \tデプステスト、ステンシルテスト\n \t InputLayout \t頂点入力ステージ \t頂点バッファ\n \t SamplerState \tテクスチャステージ \tテクスチャパラメータ\n また、ステートオブジェクトとは別に以下のようなリソースオブジェクトがあります。作成時に必要な処理がほぼ完了しているという意味では同様の使われ方をします。\n 表 1-4. リソースオブジェクト\n \tリソースオブジェクト \t説明\n \t ShaderBinary \tシェーダバイナリの保持やロードを行います。\n \t Shader \t浮動小数点定数の GPU へのロードや入出力レジスタの設定を行います。\n \t ShaderPipeline \tシェーダパイプラインへのシェーダプログラムのアタッチを行います。\n \t VertexBufferResource \t頂点バッファのデータを保持します。\n \t Texture2DResource \tテクスチャやカラーバッファなど、幅と高さを持つリソースを保持します。\n \t Texture2D \t Texture2DResource を 2 次元テクスチャとして扱います。\n \t TextureCube \t6 つの Texture2DResource をキューブマップテクスチャとして扱います。\n \t RenderTarget \t Texture2DResource をカラーバッファとして扱います。\n \t DepthStencilTarget \t Texture2DResource をデプス（ステンシル）バッファとして扱います。\n 補足：\n ステートオブジェクトやリソースオブジェクトを作成するために必要なメモリは、GX ライブラリの初期化で指定したアロケータを介して、デバイスメモリ（NN_GX_MEM_FCRAM）からシステム用バッファ（NN_GX_MEM_SYSTEM）として確保されます。そのため、ライブラリによるメモリ使用を考慮して、デバイスメモリのサイズに余裕を持たせることを推奨します。\n 確保されるメモリのサイズについては、「9.2. 関数内で確保されるメモリのサイズ」を参照してください。\n",0]
,["Pages/Page_54693503.html#PageId_54693512","1.3.1. デスクリプタクラス",
"1.3.1. デスクリプタクラス\nステートオブジェクトやリソースオブジェクトのようなパイプライン設定用のオブジェクトを作成する際には、必要な設定を行ったデスクリプタクラスをオブジェクト作成関数に与えることになります。\nデスクリプタクラスのすべてのメンバ変数は public で定義されています。また、デスクリプタクラスには複数のメンバ変数を簡単に設定するためのメンバ関数が定義されている場合もあります。\n",0]
,["Pages/Page_54693503.html#PageId_54693513","1.4. データの流れ",
"1.4. データの流れ\n以下の図はデータの観点から GD ライブラリのパイプラインの各ステージを記述したもので、各関数がどのようにクラスに分けられているかを表しています。\n 図 1-1. GD ライブラリにおけるデータの流れ\n3D Pipeline Each stage is a class VertexInputStage ShaderStage RasterizerStage Fixed Fragment Pipeline ProceduralTextureStage TextureStage LightingStage CombinerStage FogStage OutputStage System functions System:: class Utility functions Utils:: class Memory resources Resources:: class Vertex Buffer Resource Texture Resource Memory functions Memory:: class Memory Operations fill copy filter\n",0]
,["Pages/Page_54693514.html","2. 基本的な処理の流れ",
"2. 基本的な処理の流れ\nGD ライブラリを使用してグラフィックスを表示するために最低限必要となる処理を、行うべき順番（多少前後することがあります）で示すと以下のようになります。\n \tGD ライブラリの初期化 \tフレームバッファの確保 \tシェーダプログラムのロード \t頂点データの準備 \tビューポートの設定 \t描画の実行 \t描画結果の表示 \t終了処理\n上記以外の処理については「4. 各モジュールの説明」などを参照してください。\n 補足：\n この章では関数の詳細については説明しません。関数の詳細な情報については、以降の章や関数リファレンスを参照してください。\n",0]
,["Pages/Page_54693514.html#PageId_54693515","2.1. GD ライブラリの初期化",
"2.1. GD ライブラリの初期化\nGD ライブラリの初期化は nn::gd::System::Initialize() を呼び出すことで行われます。初期化は GD ライブラリのほかの関数を呼び出す前に行われている必要があります。\nまた、nn::gd::System::Initialize() は内部での作業用メモリ確保のために nngxInitialize() 経由で与えられているアロケータを使用します。このため、GD ライブラリの初期化に先立って nngxInitialize() による GX ライブラリの初期化と、関数内で実行される 3D コマンドのためにコマンドリストの確保を行う必要があります。\n以下は GD ライブラリの初期化に必要な流れの一例です。\n コード 2-1. 初期化の例\n nngxInitialize(...);\nnngxGenCmdlists(1, &cmdListId);\nnngxBindCmdlist(cmdListId);\nnngxCmdlistStorage(0x80000, 128);\nnnResult result = nn::gd::System::Initialize();\nGD ライブラリでは、同じコマンドリストを使用した状態でも、ほかのフレームワーク（NintendoWare など）と平行して利用することができます。ただし、すでに GD ライブラリ以外でコマンドリストを確保していた場合は、GD ライブラリの初期化前にコマンドリストの確保を行わないように注意してください。\nディスプレイバッファを確保するための関数は GD ライブラリにはありません。ディスプレイバッファの確保は nngx 関数で行ってください。\n",0]
,["Pages/Page_54693514.html#PageId_54693516","2.2. フレームバッファの確保",
"2.2. フレームバッファの確保\nカラーバッファとデプス（ステンシル）バッファの確保は GD ライブラリで行います。\nデスクリプタクラスの設定に違いがあるものの、どちらのバッファも Texture2DResource オブジェクトを作成しなければならないのは同じです。バッファのクリアや描画の効率から、以下のコード例のようにカラーバッファとデプス（ステンシル）バッファは VRAM-A と VRAM-B に分散して確保することを推奨します。\n コード 2-2. フレームバッファで使用する Texture2DResource オブジェクトの作成\n static nn::gd::Texture2DResource* s_texture2DResource_ColorBuffer = 0;\nstatic nn::gd::Texture2DResource* s_texture2DResource_DepthStencilBuffer = 0;\n//Color buffer\nnn::gd::Texture2DResourceDescription Text2DResDesc_ColorBuffer =\n {nn::gx::DISPLAY0_WIDTH, nn::gx::DISPLAY0_HEIGHT, 1,\n nn::gd::Resource::NATIVE_FORMAT_RGBA_8888,\n nn::gd::Memory::LAYOUT_BLOCK_8, nn::gd::Memory::VRAMA};\nnnResult res = nn::gd::Resource::CreateTexture2DResource(\n &Text2DResDesc_ColorBuffer, 0, GD_FALSE,\n &s_texture2DResource_ColorBuffer);\nif ( GD_NNRESULT_IS_FAILURE(res) ) {NN_PANIC(\"\\n\");}\n//Depth Stencil buffer\nnn::gd::Texture2DResourceDescription Text2DResDesc_DepthStencilBuffer =\n {nn::gx::DISPLAY0_WIDTH, nn::gx::DISPLAY0_HEIGHT, 1,\n nn::gd::Resource::NATIVE_FORMAT_DEPTH_24_STENCIL_8,\n nn::gd::Memory::LAYOUT_BLOCK_8, nn::gd::Memory::VRAMB};\nres = nn::gd::Resource::CreateTexture2DResource(\n &Text2DResDesc_DepthStencilBuffer, 0, GD_FALSE,\n &s_texture2DResource_DepthStencilBuffer);\nif ( GD_NNRESULT_IS_FAILURE(res) ) {NN_PANIC(\"\\n\");}\n作成した Texture2DResource オブジェクトを使って、カラーバッファならば RenderTarget オブジェクトを、デプス（ステンシル）バッファならば DepthStencilTarget オブジェクトをそれぞれ作成します。\n コード 2-3. RenderTarget オブジェクトと DepthStencilTarget オブジェクトの作成\n static nn::gd::RenderTarget* s_RenderTarget = 0;\nstatic nn::gd::DepthStencilTarget* s_DepthStencilTarget = 0;\n//Color buffer\nnn::gd::RenderTargetDescription descRenderTarget = {0};\nres = nn::gd::OutputStage::CreateRenderTarget(\n s_texture2DResource_ColorBuffer, &descRenderTarget,\n &s_RenderTarget);\nif ( GD_NNRESULT_IS_FAILURE(res) ) {NN_PANIC(\"\\n\");}\n//Depth Stencil buffer\nnn::gd::DepthStencilTargetDescription descDepthStencilTarget = {0};\nres = nn::gd::OutputStage::CreateDepthStencilTarget(\n s_texture2DResource_DepthStencilBuffer, &descDepthStencilTarget,\n &s_DepthStencilTarget);\nif ( GD_NNRESULT_IS_FAILURE(res) ) {NN_PANIC(\"\\n\");}\nパイプラインへの設定はアウトプットステージで行い、RenderTarget オブジェクトならば SetRenderTarget() を、DepthStencilTarget オブジェクトならば SetDepthStencilTarget() をそれぞれ呼び出します。\n コード 2-4. フレームバッファのパイプラインへの設定\n //Set the color/depthstencil targets\nnn::gd::OutputStage::SetRenderTarget(s_RenderTarget);\nnn::gd::OutputStage::SetDepthStencilTarget(s_DepthStencilTarget);\n",0]
,["Pages/Page_54693514.html#PageId_54693517","2.3. シェーダプログラムのロード",
"2.3. シェーダプログラムのロード\n描画に使用するシェーダプログラムをパイプラインに反映させるまでには、以下の手順が必要です。\n \tシェーダバイナリの読み込み \t ShaderBinary オブジェクトの作成 \t Shader オブジェクトの作成 \t ShaderPipeline オブジェクトの作成 \tパイプラインへの反映\n以下のコード例では、シェーダバイナリ（rBuf に rSize バイトのファイルを読み込み済み）に含まれている頂点シェーダをパイプラインに反映させています。\n コード 2-5. シェーダプログラムのロード\n static nn::gd::ShaderBinary* shaderBinary = 0;\nstatic nn::gd::ShaderPipeline* shaderPipeline = 0;\nstatic nn::gd::Shader* vertexShader = 0;\nnnResult res;\nres = nn::gd::ShaderStage::CreateShaderBinary(rBuf, rSize, &shaderBinary);\nif ( GD_NNRESULT_IS_FAILURE(res) ) {NN_PANIC(\"\\n\");}\nres = nn::gd::ShaderStage::CreateShader(shaderBinary, 0, &vertexShader);\nif ( GD_NNRESULT_IS_FAILURE(res) ) {NN_PANIC(\"\\n\");}\nres = nn::gd::ShaderStage::CreateShaderPipeline(\n vertexShader, NULL, &shaderPipeline);\nif ( GD_NNRESULT_IS_FAILURE(res) ) {NN_PANIC(\"\\n\");}\nnn::gd::ShaderStage::SetShaderPipeline(shaderPipeline);\nシェーダプログラムで使用する各レジスタへの値の設定は、シェーダステージの GetShaderUniformLocation() の引数に ShaderPipeline オブジェクトとデータ名を指定して取得した、UniformLocation オブジェクトを介して行います。\n コード 2-6. ユニフォーム設定を介したレジスタへの値の設定\n static nn::gd::UniformLocation s_shaderVariable_proj;\nstatic nn::gd::UniformLocation s_shaderVariable_view;\ns_shaderVariable_proj = nn::gd::ShaderStage::GetShaderUniformLocation(\n shaderPipeline, \"uProjection\");\ns_shaderVariable_view = nn::gd::ShaderStage::GetShaderUniformLocation(\n shaderPipeline, \"uModelView\");\nNN_ASSERT(s_shaderVariable_proj.IsValid());\nNN_ASSERT(s_shaderVariable_view.IsValid());\nnn::math::Matrix44 proj, mv;\nnn::gd::ShaderStage::SetShaderPipelineConstantFloat(\n shaderPipeline, s_shaderVariable_proj, static_cast<f32*>(proj));\nnn::gd::ShaderStage::SetShaderPipelineConstantFloat(\n shaderPipeline, s_shaderVariable_view, static_cast<f32*>(mv));\n",0]
,["Pages/Page_54693514.html#PageId_54693518","2.4. 頂点データの準備",
"2.4. 頂点データの準備\nGD ライブラリでは、プリミティブの描画には必ず頂点バッファを使用しなければなりません。\n頂点バッファを使用するには、以下の手順が必要となります。\n \t InputLayout オブジェクトの作成 \t VertexBufferResource オブジェクトの作成 \tパイプラインへの反映（入力レイアウトと頂点バッファ）\n以下のコード例では、頂点座標と頂点カラーがインターリーブされた頂点データを使用しています。\n コード 2-7. 頂点データの準備\n u16 idxs[] = {0, 1, 2};\nnnResult res;\nfloat coords_color[] = {\n 0.5f, 0.0f, 0.f, 1.f, 1.f, 0.0f, 0.0f,\n -0.5f, 0.5f, 0.f, 1.f, 0.f, 1.0f, 0.0f,\n -0.5f,-0.5f, 0.f, 1.f, 0.f, 0.0f, 1.0f,\n};\nnn::gd::InputElementDescription descs[] =\n{\n { 0, \"aPosition\",\n nn::gd::VertexInputStage::STREAM_TYPE_FLOAT, 4, 0},\n { 0, \"aColor\",\n nn::gd::VertexInputStage::STREAM_TYPE_FLOAT, 3, sizeof(float) * 4},\n};\nu32 strides[] = { sizeof(float) * 7 };\nres = nn::gd::VertexInputStage::CreateInputLayout(\n descs, 2, strides, vertexShader, &inputLayout);\nif ( GD_NNRESULT_IS_FAILURE(res) ) {NN_PANIC(\"\\n\");}\nnn::gd::VertexBufferResourceDescription desc;\ndesc.m_ByteSize = sizeof(coords_color);\ndesc.m_MemLocation = nn::gd::Memory::FCRAM;\nres = nn::gd::Resource::CreateVertexBufferResource(\n &desc, coords_color, &bufferCoord);\nif ( GD_NNRESULT_IS_FAILURE(res) ) {NN_PANIC(\"\\n\");}\ndesc.m_ByteSize = sizeof(idxs);\nres = nn::gd::Resource::CreateVertexBufferResource(&desc, idxs, &bufferIndex);\nif ( GD_NNRESULT_IS_FAILURE(res) ) {NN_PANIC(\"\\n\");}\nnn::gd::VertexBufferResource* buffers[] = { bufferCoord };\nu32 offsets[] = { 0 };\nnn::gd::VertexInputStage::SetVertexBuffers(0, 1, buffers, offsets);\nnn::gd::VertexInputStage::SetInputLayout(inputLayout);\nnn::gd::VertexInputStage::SetIndexBuffer(\n bufferIndex, nn::gd::VertexInputStage::INDEX_FORMAT_USHORT, 0);\n",0]
,["Pages/Page_54693514.html#PageId_54693519","2.5. ビューポートの設定",
"2.5. ビューポートの設定\nビューポートの設定はラスタライザステージの SetViewport() で行います。\n以下のコード例では、アウトプットステージの GetRenderTargetProperties() で取得したレンダーターゲットの情報をビューポートの設定に利用しています。\n コード 2-8. ビューポートの設定\n nn::gd::TargetProperties renderTargetProperty;\nnn::gd::OutputStage::GetRenderTargetProperties(\n s_RenderTarget, &renderTargetProperty);\nnn::gd::Viewport viewPort(0, 0,\n renderTargetProperty.m_Width, renderTargetProperty.m_Height);\nnn::gd::RasterizerStage::SetViewport(viewPort);\n",0]
,["Pages/Page_54693514.html#PageId_54693520","2.6. 描画の実行",
"2.6. 描画の実行\n描画のために呼び出す関数は頂点インデックスを使用するかどうかで異なります。頂点インデックスを使用する場合は nn::gd::System::DrawIndexed() を、使用しない場合 nn::gd::System::Draw() を呼び出します。なお、頂点バッファリソースを使用せずに描画を行う nn::gd::System::DrawImmediate() と nn::gd::System::DrawImmediateIndexed() も用意されています。ただし、頂点バッファリソースを使用しない描画は頂点データの取り扱いが柔軟になりますが、描画の実行が遅くなります。\nフレームバッファのクリアには nn::gd::Memory::ClearTargets() を使用してください。\n以下のコード例では、フレームバッファのクリアと頂点インデックスを使用した描画を行っています。\n コード 2-9. 描画の実行\n //Clear the render buffers\nu8 clearColor[] = {25, 25, 122, 255};\nnn::gd::Memory::ClearTargets(s_RenderTarget, s_DepthStencilTarget,\n clearColor, 1.f, 0);\n//Draw\nnn::gd::System::DrawIndexed(3, 0);\n",0]
,["Pages/Page_54693514.html#PageId_54693521","2.7. 描画結果の表示",
"2.7. 描画結果の表示\nカラーバッファの内容を nn::gd::Memory::CopyTexture2DResourceBlockToLinear() でディスプレイバッファにコピーし、描画結果を LCD に表示させます。この関数は nngxTransferRenderImage() とほぼ同じ機能を有していますが、コピー先のアドレスは nngxGetDisplaybufferParameteri() などを利用してアプリケーションで取得しなければなりません。\n コード 2-10. 描画結果の表示\n //Transfer framebuffer to display buffer\nint dstAddr;\nnngxActiveDisplay(NN_GX_DISPLAY0);\nnngxGetDisplaybufferParameteri(NN_GX_DISPLAYBUFFER_ADDRESS, &dstAddr);\nnn::gd::Memory::CopyTexture2DResourceBlockToLinear(\n s_texture2DResource_ColorBuffer, //source\n 0, //sourceMipLevelIndex\n 0, //srcOffsetY\n (u8*)dstAddr, //dstAddr\n nn::gx::DISPLAY0_WIDTH, //dstWidth\n nn::gx::DISPLAY0_HEIGHT, //dstHeight\n nn::gd::Resource::NATIVE_FORMAT_RGB_888, //dstFormat\n nn::gd::Memory::DOWNSCALING_NONE, //DownScalingMode\n GD_FALSE //yFlip\n);\nnngxWaitCmdlistDone();\nnngxSwapBuffers(NN_GX_DISPLAY_BOTH);\n",0]
,["Pages/Page_54693514.html#PageId_54693522","2.8. 終了処理",
"2.8. 終了処理\nGD ライブラリの終了処理は nn::gd::System::Finalize() を呼び出すことで行われます。この関数の実行が完了したあとは GD ライブラリの関数を呼び出すことができなくなります。\n終了処理では、アプリケーションで確保したものを含めて、ライブラリが管理しているリソースなどが自動的に解放されます。しかし、アプリケーションで作成したステートやリソースなどのオブジェクトは、なるべくアプリケーションで明示的に解放することを推奨します。\n",0]
,["Pages/Page_54693523.html","3. リソースオブジェクト",
"3. リソースオブジェクト\nリソースオブジェクトを扱う関数は基本的に nn::gd::Resource クラスで定義されています。\n nn::gd::Resource クラスでは、リソースオブジェクトの作成と解放、詳細情報の取得、データを書き換えるためのデータポインタの取得を行うことができます。\n",0]
,["Pages/Page_54693523.html#PageId_54693524","3.1. テクスチャ 2D リソース",
"3.1. テクスチャ 2D リソース\nテクスチャ 2D リソースは、テクスチャイメージやカラーバッファなどのように、幅と高さを持つリソースのことです。このリソースは Texture2DResource オブジェクトを介して扱います。\n",0]
,["Pages/Page_54693523.html#PageId_54693525","3.1.1. Texture2DResource オブジェクトの作成",
"3.1.1. Texture2DResource オブジェクトの作成\n Texture2DResource オブジェクトは nn::gd::Resource::CreateTexture2DResource() で作成することができます。\n コード 3-1. Texture2DResource オブジェクトの作成\n static nnResult nn::gd::Resource::CreateTexture2DResource(\n const nn::gd::Texture2DResourceDescription* description,\n const void* initialData, gdBool autoGenerateMipMapsFromData,\n nn::gd::Texture2DResource** texture2DResource,\n gdBool copyInitialData = GD_TRUE);\nリソースの情報は description に指定するデスクリプタクラス（Texture2DResourceDescription）にあらかじめ設定しておきます。デスクリプタクラスに設定する情報の詳細は「3.1.1.2. Texture2DResource オブジェクトのデスクリプタクラス」を参照してください。\nファイルからロードされたテクスチャデータのように初期データを持つリソースを作成する場合、そのデータの先頭アドレスを initialData に指定します。copyInitialData に GD_TRUE が指定されたときは、リソースの作成時に初期データをデスクリプタクラスで指定されたメモリにコピーします。このとき、リソースデータを VRAM に確保する場合は関数内で DMA 転送のコマンドリクエストをコマンドリストに追加しますので、コマンドリストの実行が完了するまで初期データが存在するメモリ領域を書き換えたり解放したりしないでください。copyInitialData に GD_FALSE が指定されたときは、initialData に指定されたアドレスそのままをリソースで使用します。リソースにミップマップデータが含まれる場合は、すべてのデータが格納可能なサイズで確保されていなければならないことに注意してください。また、アドレスのアライメントにも注意が必要です。なお、リソースの解放時にはアプリケーションでメモリを解放しなければなりません。\n初期データを持たないリソースを作成する場合は initialData には NULL を指定してください。リソースデータを保持するために必要なサイズのメモリ領域が、デスクリプタクラスで指定されたメモリに確保されます。\n autoGenerateMipMapsFromData には、テクスチャデータのミップマップデータを初期データから自動生成する場合に GD_TRUE を指定します。自動生成する場合の注意点については、「3.1.7. ミップマップデータの自動生成」を参照してください。\n今後、作成された Texture2DResource オブジェクトへのアクセスには texture2DResource で受け取ったポインタを介して行います。\n",0]
,["Pages/Page_54693523.html#PageId_54693526","3.1.1.1. テクスチャをネイティブフォーマットに変換するヘルパー関数",
"3.1.1.1. テクスチャをネイティブフォーマットに変換するヘルパー関数\n3D モデルに貼り付けるテクスチャのテクスチャオブジェクトを作成する場合、Texture2DResource オブジェクトの作成時に指定する初期データは 3DS のネイティブフォーマットでなければなりません。そのため、Open GL などで使用される標準的なテクスチャを 3DS のネイティブフォーマットに変換するヘルパー関数が nn::gd::Resource::Helper クラスに用意されています。ただし、ヘルパー関数は処理の負荷が高く、ランタイムでの処理には向いていません。\n無圧縮テクスチャと圧縮テクスチャで変換に使用するヘルパー関数は異なりますが、対応している変換元のピクセルフォーマット以外に、引数の指定に違いはありません。\n コード 3-2. テクスチャをネイティブフォーマットに変換するヘルパー関数\n static nnResult nn::gd::Resource::Helper::ConvertTextureResourceToNativeFormat(\n nn::gd::Resource::Format format,\n u32 width, u32 height, const u8* dataSrc, u8* dataDst,\n nn::gd::Resource::NativeFormat* pnativeFormat = NULL);\nstatic nnResult nn::gd::Resource::Helper::ConvertCompressedTextureResourceToNativeFormat(\n nn::gd::Resource::CompressedFormat format,\n u32 width, u32 height, u8* dataSrc, u8* dataDst,\n nn::gd::Resource::NativeFormat* pnativeFormat = NULL);\n format には変換元のピクセルフォーマットを指定します。\n ConvertTextureResourceToNativeFormat() で指定可能なピクセルフォーマットには以下のものがあります。\n \t FORMAT_RGBA_8888 \t FORMAT_RGB_888 \t FORMAT_RGBA_5551 \t FORMAT_RGB_565 \t FORMAT_RGBA_4444 \t FORMAT_LUMINANCE_ALPHA_88 \t FORMAT_HILO_88 \t FORMAT_LUMINANCE_8 \t FORMAT_ALPHA_8 \t FORMAT_LUMINANCE_ALPHA_44 \t FORMAT_LUMINANCE_4 \t FORMAT_ALPHA_4\n ConvertCompressedTextureResourceToNativeFormat() で指定可能なピクセルフォーマットには以下のものがあります。\n \t FORMAT_ETC1_RGB8\nピクセルフォーマットによっては、デバイスメモリから変換元のデータと同じサイズのバッファを一時的に確保します。また、dataSrc と dataDst に同じアドレスを指定した場合は必ず一時的にバッファを確保します。\n標準的なテクスチャのフォーマットとネイティブフォーマットの違いについては、「3DS プログラミングマニュアル - グラフィックス基本編」を参照してください。\n",0]
,["Pages/Page_54693523.html#PageId_54693527","3.1.1.2. Texture2DResource オブジェクトのデスクリプタクラス",
"3.1.1.2. Texture2DResource オブジェクトのデスクリプタクラス\n Texture2DResource オブジェクトのデスクリプタクラス（Texture2DResourceDescription）のメンバを紹介し、設定に際しての注意点などを説明します。\n コード 3-3. Texture2DResourceDescription クラスの定義\n class nn::gd::Texture2DResourceDescription\n{\n u32 m_Width;\n u32 m_Height;\n u32 m_CountMipLevels;\n nn::gd::Resource::NativeFormat m_Format;\n nn::gd::Memory::MemoryLayout m_MemLayout;\n nn::gd::Memory::MemoryLocation m_MemLocation;\n};\n",0]
,["Pages/Page_54693523.html#Anchor_54693527_幅（m_Width）","幅（m_Width）",
"幅（m_Width）\nリソースデータの幅をピクセル数で設定します。ミップマップデータを持つテクスチャの場合は、トップレベルのテクスチャデータの幅を指定してください。\n",0]
,["Pages/Page_54693523.html#Anchor_54693527_高さ（m_Height）","高さ（m_Height）",
"高さ（m_Height）\nリソースデータの高さをピクセル数で設定します。ミップマップデータを持つテクスチャの場合は、トップレベルのテクスチャデータの高さを指定してください。\n",0]
,["Pages/Page_54693523.html#Anchor_54693527_ミップマップレベル（m_CountMipLevels）","ミップマップレベル（m_CountMipLevels）",
"ミップマップレベル（m_CountMipLevels）\nリソースデータがミップマップデータを持つ場合のミップマップレベルを設定します。ミップマップデータを持たないリソースデータの場合は 1 を指定してください。0 を指定した場合はリソースデータの幅と高さで持ち得る最大のミップマップレベルが設定されます。\n",0]
,["Pages/Page_54693523.html#Anchor_54693527_ピクセルフォーマット（m_Format）","ピクセルフォーマット（m_Format）",
"ピクセルフォーマット（m_Format）\nリソースの使用目的によって指定可能なピクセルフォーマットが異なります。\n下表では、使用目的（作成するオブジェクト）をテクスチャデータ（Texture2D オブジェクトまたは TextureCube オブジェクト）、カラーバッファ（RenderTarget オブジェクト）、デプスステンシルバッファ（DepthStencilTarget オブジェクト）に分けて指定可能なピクセルフォーマットを示しています。\n 表 3-1. 指定可能なピクセルフォーマット\n \tピクセルフォーマット \tTexture2D \tTextureCube \tRenderTarget \tDepthStencilTarget\n \t Resource::NATIVE_FORMAT_RGBA_8888 ※1 \t○ \t○ \t○ \tエラー\n \t Resource::NATIVE_FORMAT_RGB_888 ※1 \t○ \t○ \tエラー \tエラー\n \t Resource::NATIVE_FORMAT_RGBA_5551 ※1 \t○ \t○ \t○ \tエラー\n \t Resource::NATIVE_FORMAT_RGB_565 ※1 \t○ \t○ \t○ \tエラー\n \t Resource::NATIVE_FORMAT_RGBA_4444 ※1 \t○ \t○ \t○ \tエラー\n \t Resource::NATIVE_FORMAT_LUMINANCE_ALPHA_88 \t○ \t○ \tエラー \tエラー\n \t Resource::NATIVE_FORMAT_HILO_88 \t○ \t○ \tエラー \tエラー\n \t Resource::NATIVE_FORMAT_LUMINANCE_8 \t○ \t○ \tエラー \tエラー\n \t Resource::NATIVE_FORMAT_ALPHA_8 \t○ \t○ \tエラー \tエラー\n \t Resource::NATIVE_FORMAT_LUMINANCE_ALPHA_44 \t○ \t○ \tエラー \tエラー\n \t Resource::NATIVE_FORMAT_LUMINANCE_4 \t○ \t○ \tエラー \tエラー\n \t Resource::NATIVE_FORMAT_ALPHA_4 \t○ \t○ \tエラー \tエラー\n \t Resource::NATIVE_FORMAT_ETC1_RGB8 \t○ \t○ \tエラー \tエラー\n \t Resource::NATIVE_FORMAT_ETC1_A4 \t○ \t○ \tエラー \tエラー\n \t Resource::NATIVE_FORMAT_GAS ※2 \t○ \tエラー \t○ \tエラー\n \t Resource::NATIVE_FORMAT_SHADOW ※2 \t○ \t○ \t○ \tエラー\n \t Resource::NATIVE_FORMAT_DEPTH_16 \t○ \t○ \tエラー \t○\n \t Resource::NATIVE_FORMAT_DEPTH_24 \t○ \t○ \tエラー \t○\n \t Resource::NATIVE_FORMAT_DEPTH_24_STENCIL_8 \t○ \t○ \tエラー \t○\n ※1 自動ミップマップ生成に対応しています。\n※2 ミップマップに対応していません。\n",0]
,["Pages/Page_54693523.html#Anchor_54693527_メモリレイアウト（m_MemLayout）","メモリレイアウト（m_MemLayout）",
"メモリレイアウト（m_MemLayout）\n Texture2D や TextureCube のオブジェクトの作成に使用するリソースオブジェクトや初期データを指定して作成するリソースオブジェクトの場合、メモリレイアウトには Memory::LAYOUT_BLOCK_8 のみが指定可能です。\n RenderTarget や DepthStencilTarget のオブジェクトの作成に使用するリソースオブジェクトの場合、メモリレイアウトには Memory::LAYOUT_BLOCK_8 または Memory::LAYOUT_BLOCK_32 が指定可能です。\n上記以外に使用するリソースオブジェクトであれば、メモリレイアウトに Memory::LAYOUT_LINEAR を指定することができます。\n",0]
,["Pages/Page_54693523.html#Anchor_54693527_リソースデータを確保するメモリ（m_MemLocation）","リソースデータを確保するメモリ（m_MemLocation）",
"リソースデータを確保するメモリ（m_MemLocation）\nリソースデータを保持するために確保するメモリを指定します。Memory::FCRAM（デバイスメモリ）を指定して作成されたリソースオブジェクトは、RenderTarget または DepthStencilTarget のオブジェクトの作成に使用することができません。\n 表 3-2. リソースデータの確保で指定可能なメモリ\n \tリソースデータの保持に使用するメモリ \tTexture2D \tTextureCube \tRenderTarget \tDepthStencilTarget\n \t Memory::FCRAM（デバイスメモリ） \t○ \t○ \tエラー \tエラー\n \t Memory::VRAMA（VRAM-A） \t○ \t○ \t○ \t○\n \t Memory::VRAMB（VRAM-B） \t○ \t○ \t○ \t○\n",0]
,["Pages/Page_54693523.html#PageId_54693528","3.1.2. Texture2DResource オブジェクトの解放",
"3.1.2. Texture2DResource オブジェクトの解放\n Texture2DResource オブジェクトの解放は、nn::gd::Resource::ReleaseTexture2DResource() の呼び出しで行われます。オブジェクトの解放と同時に、作成時に確保されたメモリ領域も解放されます。\n コード 3-4. Texture2DResource オブジェクトの解放\n static nnResult nn::gd::Resource::ReleaseTexture2DResource(\n nn::gd::Texture2DResource* texture2DResource);\n",0]
,["Pages/Page_54693523.html#PageId_54693529","3.1.3. Texture2DResource オブジェクトの詳細情報の取得",
"3.1.3. Texture2DResource オブジェクトの詳細情報の取得\n Texture2DResource オブジェクトに格納されている詳細情報（Texture2DResourceProperties クラス）を nn::gd::Resource::GetTexture2DResourceProperties() で取得することができます。\n コード 3-5. Texture2DResource オブジェクトの詳細情報の取得\n static nnResult nn::gd::Resource::GetTexture2DResourceProperties(\n const nn::gd::Texture2DResource* texture2DResource,\n nn::gd::Texture2DResourceProperties* properties);\nこの関数は texture2DResource に指定した、Texture2DResource オブジェクトに格納されている詳細情報へのポインタを properties に返します。取得したポインタを介して、Texture2DResource オブジェクトの内容を書き換えてしまわないように注意してください。\n",0]
,["Pages/Page_54693523.html#PageId_54693530","3.1.3.1. Texture2DResource オブジェクトの詳細情報",
"3.1.3.1. Texture2DResource オブジェクトの詳細情報\n詳細情報（Texture2DResourceProperties クラス）には、オブジェクトの作成時に指定されたデスクリプタクラスの設定とほぼ同じ内容が格納されています。\n コード 3-6. Texture2DResourceProperties クラスの定義\n class nn::gd::Texture2DResourceProperties\n{\n u32 m_Width;\n u32 m_Height;\n u32 m_CountMipLevels;\n u32 m_PixelSize;\n nn::gd::Resource::NativeFormat m_Format;\n nn::gd::Memory::MemoryLayout m_MemLayout;\n nn::gd::Memory::MemoryLocation m_MemLocation;\n u8* m_MemAddr;\n nn::gd::MipmapResourceInfo GetMipmapAddress(u32 mipmapLevel);\n};\nここでは、デスクリプタクラスの設定と異なる可能性のあるメンバ変数と、このクラスにのみ存在するメンバを説明します。\n",0]
,["Pages/Page_54693523.html#Anchor_54693530_ミップマップレベル（m_CountMipLevels）","ミップマップレベル（m_CountMipLevels）",
"ミップマップレベル（m_CountMipLevels）\nデスクリプタで 0 が指定されていた場合は、リソースデータの幅と高さで持ち得る最大のミップマップレベルが設定されています。\n",0]
,["Pages/Page_54693523.html#Anchor_54693530_ピクセルサイズ（m_PixelSize）","ピクセルサイズ（m_PixelSize）",
"ピクセルサイズ（m_PixelSize）\nリソースデータのピクセルフォーマットのビット数が設定されています。\n",0]
,["Pages/Page_54693523.html#Anchor_54693530_リソースデータの先頭アドレス（m_MemAddr）","リソースデータの先頭アドレス（m_MemAddr）",
"リソースデータの先頭アドレス（m_MemAddr）\nリソースデータの先頭アドレスが物理アドレスで設定されています。\n",0]
,["Pages/Page_54693523.html#Anchor_54693530_ミップマップデータのアドレス情報の取得（GetMipmapAddress()）","ミップマップデータのアドレス情報の取得（GetMipmapAddress()）",
"ミップマップデータのアドレス情報の取得（GetMipmapAddress()）\nミップマップレベルを指定して、ミップマップデータのアドレス情報（MipmapResourceInfo クラス）を取得するヘルパー関数が定義されています。\n コード 3-7. ミップマップデータのアドレス情報の定義\n class nn::gd::MipmapResourceInfo\n{\n u32 m_Width;\n u32 m_Height;\n u8* m_MemAddr;\n};\nミップマップデータの幅（m_Width）、高さ（m_Height）、データの先頭アドレス（m_MemAddr）が定義されています。\n",0]
,["Pages/Page_54693523.html#PageId_54693531","3.1.4. Texture2DResource オブジェクトのデータポインタの取得",
"3.1.4. Texture2DResource オブジェクトのデータポインタの取得\nリソースデータにアクセスするためのデータポインタを nn::gd::Resource::MapTexture2DResource() で取得することができます。\n コード 3-8. Texture2DResource オブジェクトのデータポインタの取得\n static nnResult nn::gd::Resource::MapTexture2DResource(\n nn::gd::Texture2DResource* texture2DResource,\n s32 mipLevelIndex, nn::gd::Resource::MapUsage usage, void** data);\nstatic nnResult nn::gd::Resource::UnmapTexture2DResource(\n nn::gd::Texture2DResource* texture2DResource);\n texture2DResource に指定した Texture2DResource オブジェクトのリソースデータのうち、mipLevelIndex で指定されたミップマップレベルのテクスチャデータの先頭アドレスが data に返されます。usage には、以下のマッピング方法（リソースデータへのアクセスの種類）を指定します。\n 表 3-3. データポインタのマッピング方法\n \t定義 \tマッピング方法 \tデバイスメモリ \tVRAM\n \t Resource::MAP_READ_ONLY \t読み込みのみ \t○ \t○\n \t Resource::MAP_WRITE_ONLY \t書き込みのみ \t○ \tエラー\n \t Resource::MAP_READ_WRITE \t読み書き \t○ \tエラー\n 補足：\n マッピング方法のチェックはデータポインタの取得時にのみ行われます。MAP_READ_ONLY で取得したデバイスメモリ上のリソースデータに書き込みを行ってもエラーにはなりませんが、マッピングの解除時にキャッシュがフラッシュされません。\n VRAM 上のリソースデータに直接アクセスすることはできません。DMA 転送などで、CPU から直接アクセス可能なメモリ上にコピーしてください。\nリソースデータへのアクセスが完了したあとは、nn::gd::Resource::UnmapTexture2DResource() でマッピングを解除してください。書き込みを含むマッピング方法でデバイスメモリ上のリソースデータのデータポインタを取得していた場合は、マッピングの解除時にキャッシュのフラッシュが行われます。\n",0]
,["Pages/Page_54693523.html#PageId_54693532","3.1.5. リソースデータのクリア（Texture2DResource オブジェクト）",
"3.1.5. リソースデータのクリア（Texture2DResource オブジェクト）\n指定した値でリソースデータをクリアすることができます。また、ミップマップデータを持つリソースであれば、クリアするミップマップレベルの範囲を指定することができます。ただし、デバイスメモリ上に確保されているリソースデータはクリアできません。\n コード 3-9. リソースデータのクリア（Texture2DResource オブジェクト）\n static nnResult nn::gd::Memory::ClearTexture2DResource(\n const nn::gd::Texture2DResource* tex2DResource,\n s32 mipLevelIndexStart, s32 mipLevelIndexEnd, const u8 Components[4]);\nstatic nnResult nn::gd::Memory::ClearTexture2DResource(\n const nn::gd::Texture2DResource* tex2DResource,\n s32 mipLevelIndexStart, s32 mipLevelIndexEnd, u32 value);\n value で指定する場合はどんなリソースでもクリアしようと試みますが、Components で指定する場合は以下のピクセルフォーマットに限定されます。なお、Components の指定がどのような構成でクリアデータに反映されるかを、右のビットレイアウトに示しています。\n 図 3-1. クリアで指定可能なピクセルフォーマットとクリア時のデータの構成\nNATIVE_FORMAT_RGBA_8888 NATIVE_FORMAT_GAS NATIVE_FORMAT_SHADOW NATIVE_FORMAT_RGBA_4444 NATIVE_FORMAT_RGBA_5551 NATIVE_FORMAT_RGB_888 NATIVE_FORMAT_RGB_565 NATIVE_FORMAT_LUMINANCE_ALPHA_88 NATIVE_FORMAT_LUMINANCE_ALPHA_44 NATIVE_FORMAT_ALPHA_8 NATIVE_FORMAT_ALPHA_4 NATIVE_FORMAT_LUMINANCE_8 NATIVE_FORMAT_LUMINANCE_4 NATIVE_FORMAT_HILO_88\n",0]
,["Pages/Page_54693523.html#PageId_54693533","3.1.6. リソースデータの部分コピー（Texture2DResource オブジェクト）",
"3.1.6. リソースデータの部分コピー（Texture2DResource オブジェクト）\nミップマップレベルと矩形領域を指定して、リソースデータの部分コピーを行うことができます。この関数内で nngxAddBlockImageCopyCommand() を呼び出していますので、フォーマット変換は行われません。実際のコピー処理はコマンドリストの実行時に行われます。\n コード 3-10. リソースデータの部分コピー（Texture2DResource オブジェクト）\n static nnResult nn::gd::Memory::CopyTextureSubResource(\n const nn::gd::Texture2DResource* source,\n s32 srcMipLevelIndex, const nn::gd::Memory::Rect& rect,\n const nn::gd::Texture2DResource* dest, s32 dstMipLevelIndex,\n s32 destPosX, s32 destPosY);\nリソースデータとビューポート（LCD）では原点の位置が異なりますが、この関数ではそれを考慮していますので、矩形領域（rect）やコピー先の座標（destPosX、destPosY）はビューポートの原点を基準に指定してください。\nコピー元とコピー先のピクセルサイズが異なる場合はエラー（ResultInvalidTextureFormat()）が返されます。\n",0]
,["Pages/Page_54693523.html#PageId_54693534","3.1.7. ミップマップデータの自動生成",
"3.1.7. ミップマップデータの自動生成\n Texture2DResource オブジェクトのミップマップデータを自動生成することができます。\n コード 3-11. ミップマップデータの自動生成\n static nnResult nn::gd::Memory::GenerateMipMaps(\n const nn::gd::Texture2DResource* tex2DResource,\n u32 mipLevelSourceIndex, s32 mipLevelLastDestinationIndex);\n tex2DResource に指定される Texture2DResource オブジェクトは、生成されるミップマップレベルのリソースデータを保持することができるように作成されていなければなりません。また、以下のフォーマットで作成された Texture2DResource オブジェクトでなければ、ミップマップデータの自動生成を行うことができません。\n \t nn::gd::Resource::NATIVE_FORMAT_RGBA_8888 \t nn::gd::Resource::NATIVE_FORMAT_RGBA_5551 \t nn::gd::Resource::NATIVE_FORMAT_RGBA_4444 \t nn::gd::Resource::NATIVE_FORMAT_RGB_888 \t nn::gd::Resource::NATIVE_FORMAT_RGB_565\n上記以外のフォーマットの場合は、nn::gd::Resource::CreateTexture2DResourceCastFrom() で事前に NATIVE_FORMAT_RGBA_8888 などにフォーマット変換を行うことでミップマップデータを生成することができます。ただし、ピクセルを構成するビットに違いがあるため、この方法で生成されたミップマップデータが正常であることは保証されていません。\n mipLevelSourceIndex から mipLevelLastDestinationIndex までのミップマップレベルのデータが自動生成されます。mipLevelLastDestinationIndex に -1 を指定した場合は、そのリソースの最大のミップマップレベルを指定したことになります。\n",0]
,["Pages/Page_54693523.html#PageId_54693535","3.1.7.1. CPU によるミップマップデータの自動生成",
"3.1.7.1. CPU によるミップマップデータの自動生成\n nn::gd::Resource::Helper::GenerateMipMapsCPU() の呼び出しでも、ミップマップデータを自動生成することができます。CPU で生成するため、GPU を使用する nn::gd::Memory::GenerateMipMaps() に比べて処理速度は落ちますが、対応するフォーマットが多いことと、最小で幅および高さが 8 ピクセル（GPU を使用した場合はフォーマットにより 32 または 64 ピクセル）のミップマップデータを生成できることが長所となっています。\n コード 3-12. CPU によるミップマップデータの自動生成\n static nnResult nn::gd::Resource::Helper::GenerateMipMapsCPU(\n nn::gd::Resource::NativeFormat format,\n u32 width, u32 height, const u8* dataSrc, u8* dataDst,\n u32 countMipLevelToGenerate);\n format には、以下のフォーマットを指定することができます。\n \t nn::gd::Resource::NATIVE_FORMAT_RGBA_8888 \t nn::gd::Resource::NATIVE_FORMAT_RGBA_5551 \t nn::gd::Resource::NATIVE_FORMAT_RGBA_4444 \t nn::gd::Resource::NATIVE_FORMAT_RGB_888 \t nn::gd::Resource::NATIVE_FORMAT_RGB_565 \t nn::gd::Resource::NATIVE_FORMAT_LUMINANCE_ALPHA_88 \t nn::gd::Resource::NATIVE_FORMAT_LUMINANCE_ALPHA_44 \t nn::gd::Resource::NATIVE_FORMAT_LUMINANCE_8 \t nn::gd::Resource::NATIVE_FORMAT_ALPHA_8 \t nn::gd::Resource::NATIVE_FORMAT_HILO_88\n width と height には元となるリソースデータの幅と高さを指定します。幅および高さは 8 以上、かつ 2 の累乗でなければなりません。\n dataSrc には元となるリソースデータの先頭アドレス、dataDst にはミップマップデータの格納先アドレスを指定します。生成されるミップマップデータのすべてが格納できるだけのメモリを確保してください。\n countMipLevelToGenerate には生成するミップマップレベルの数を指定します。\n",0]
,["Pages/Page_54693523.html#PageId_54693536","3.1.8. Texture2DResource オブジェクトのフォーマット変換",
"3.1.8. Texture2DResource オブジェクトのフォーマット変換\nガステクスチャやシャドウテクスチャ、デプスバッファのように、レンダリングで使用した RenderTarget オブジェクトのリソースデータをテクスチャデータ（Texture2D オブジェクトのリソースデータ）として使用するために、以下の関数で既存の Texture2DResource オブジェクトをほかのフォーマットに変換することができます。\n コード 3-13. Texture2DResource オブジェクトのフォーマット変換\n static nnResult nn::gd::Resource::CreateTexture2DResourceCastFrom(\n const nn::gd::Texture2DResource* initialTexture2DResource,\n nn::gd::Resource::NativeFormat format,\n nn::gd::Memory::MemoryLayout layout,\n nn::gd::Texture2DResource** texture2DResource);\n initialTexture2DResource に指定した Texture2DResource オブジェクトの、ピクセルフォーマットとメモリレイアウトを format と layout に指定した情報に変更したオブジェクトが texture2DResource に返されます。変換前と変換後のピクセルフォーマットに互換性がない（ピクセルサイズが一致しない）場合はエラーが返されます。\nこの関数はフォーマットの情報が変更された Texture2DResource オブジェクトを新たに作成します。ただし、フォーマットの変換やデータのコピーは行われず、変換前のオブジェクトは変更されません。また、データが格納されている場所など、変更された情報以外は変換前の情報のままですので、この関数で作成したオブジェクトを介してリソースデータを書き換えた場合には変換前のオブジェクトのリソースデータも書き換わることになります。\n",0]
,["Pages/Page_54693523.html#PageId_54693537","3.2. 頂点バッファリソース",
"3.2. 頂点バッファリソース\n頂点バッファリソースは、頂点座標や頂点インデックスなどのように、頂点バッファとして利用するリソースのことです。このリソースは VertexBufferResource オブジェクトを介して扱います。\n",0]
,["Pages/Page_54693523.html#PageId_54693538","3.2.1. VertexBufferResource オブジェクトの作成",
"3.2.1. VertexBufferResource オブジェクトの作成\n VertexBufferResource オブジェクトは nn::gd::Resource::CreateVertexBufferResource() で作成することができます。\n コード 3-14. VertexBufferResource オブジェクトの作成\n static nnResult nn::gd::Resource::CreateVertexBufferResource(\n const nn::gd::VertexBufferResourceDescription* description,\n const void* initialData, nn::gd::VertexBufferResource** buffer,\n gdBool copyInitialData = GD_TRUE);\nリソースの情報は description に指定するデスクリプタクラス（VertexBufferResourceDescription）にあらかじめ設定しておきます。デスクリプタクラスに設定する情報の詳細は「3.2.1.1. VertexBufferResource オブジェクトのデスクリプタクラス」を参照してください。\nファイルからロードされた頂点データのように初期データを持つリソースを作成する場合、そのデータの先頭アドレスを initialData に指定します。copyInitialData に GD_TRUE が指定されたときは、リソースの作成時に初期データをデスクリプタクラスで指定されたメモリにコピーします。このとき、リソースデータを VRAM に確保する場合は関数内で DMA 転送のコマンドリクエストをコマンドリストに追加しますので、コマンドリストの実行が完了するまで初期データが存在するメモリ領域を書き換えたり解放したりしないでください。copyInitialData に GD_FALSE が指定されたときは、initialData に指定されたアドレスそのままをリソースで使用しますので、アドレスのアライメントに注意してください。なお、リソースの解放時にはアプリケーションでメモリを解放しなければなりません。\n初期データを持たないリソースを作成する場合は initialData には NULL を指定してください。リソースデータを保持するために必要なサイズのメモリ領域が、デスクリプタクラスで指定されたメモリに確保されます。\n今後、作成された VertexBufferResource オブジェクトへのアクセスには buffer で受け取ったポインタを介して行います。\n",0]
,["Pages/Page_54693523.html#PageId_54693539","3.2.1.1. VertexBufferResource オブジェクトのデスクリプタクラス",
"3.2.1.1. VertexBufferResource オブジェクトのデスクリプタクラス\n VertexBufferResource オブジェクトのデスクリプタクラス（VertexBufferResourceDescription）のメンバを紹介し、設定に際しての注意点などを説明します。\n コード 3-15. VertexBufferResourceDescription クラスの定義\n class nn::gd::VertexBufferResourceDescription\n{\n u32 m_ByteSize;\n nn::gd::Memory::MemoryLocation m_MemLocation;\n};\n",0]
,["Pages/Page_54693523.html#Anchor_54693539_頂点バッファのサイズ（m_ByteSize）","頂点バッファのサイズ（m_ByteSize）",
"頂点バッファのサイズ（m_ByteSize）\n頂点バッファ（リソースデータ）のバイトサイズを設定します。\n",0]
,["Pages/Page_54693523.html#Anchor_54693539_リソースデータを確保するメモリ（m_MemLocation）","リソースデータを確保するメモリ（m_MemLocation）",
"リソースデータを確保するメモリ（m_MemLocation）\nリソースデータを保持するために確保するメモリを指定します。\n指定するメモリは Memory::FCRAM（デバイスメモリ）、Memory::VRAMA（VRAM-A）、Memory::VRAMB（VRAM-B）から選択します。\n",0]
,["Pages/Page_54693523.html#PageId_54693540","3.2.2. VertexBufferResource オブジェクトの解放",
"3.2.2. VertexBufferResource オブジェクトの解放\n nn::gd::Resource::ReleaseVertexBufferResource() を呼び出すことで、VertexBufferResource オブジェクトの解放が行われます。オブジェクトの解放と同時に、作成時に確保されたメモリ領域も解放されます。\n コード 3-16. VertexBufferResource オブジェクトの解放\n static nnResult nn::gd::Resource::ReleaseVertexBufferResource(\n nn::gd::VertexBufferResource *buffer);\n",0]
,["Pages/Page_54693523.html#PageId_54693541","3.2.3. VertexBufferResource オブジェクトの詳細情報の取得",
"3.2.3. VertexBufferResource オブジェクトの詳細情報の取得\n VertexBufferResource オブジェクトに格納されている詳細情報（VertexBufferResourceProperties クラス）を nn::gd::Resource::GetVertexBufferResourceProperties() で取得することができます。\n コード 3-17. VertexBufferResource オブジェクトの詳細情報の取得\n static nnResult nn::gd::Resource::GetVertexBufferResourceProperties(\n const nn::gd::VertexBufferResource* buffer,\n nn::gd::VertexBufferResourceProperties* properties);\nこの関数は buffer に指定した、VertexBufferResource オブジェクトに格納されている詳細情報へのポインタを properties に返します。取得したポインタを介して、VertexBufferResource オブジェクトの内容を書き換えてしまわないように注意してください。\n",0]
,["Pages/Page_54693523.html#PageId_54693542","3.2.3.1. VertexBufferResource オブジェクトの詳細情報",
"3.2.3.1. VertexBufferResource オブジェクトの詳細情報\n詳細情報（VertexBufferResourceProperties クラス）には、オブジェクトの作成時に指定されたデスクリプタクラスの設定とほぼ同じ内容が格納されています。\n コード 3-18. VertexBufferResourceProperties クラスの定義\n class nn::gd::VertexBufferResourceProperties\n{\n u32 m_ByteSize;\n nn::gd::Memory::MemoryLocation m_MemLocation;\n u8* m_MemAddr;\n};\nここでは、このクラスにのみ存在するメンバを説明します。\n",0]
,["Pages/Page_54693523.html#Anchor_54693542_リソースデータの先頭アドレス（m_MemAddr）","リソースデータの先頭アドレス（m_MemAddr）",
"リソースデータの先頭アドレス（m_MemAddr）\nリソースデータの先頭アドレスが物理アドレスで設定されています。\n",0]
,["Pages/Page_54693523.html#PageId_54693543","3.2.4. VertexBufferResource オブジェクトのデータポインタの取得",
"3.2.4. VertexBufferResource オブジェクトのデータポインタの取得\nリソースデータにアクセスするためのデータポインタを nn::gd::Resource::MapVertexBufferResource() で取得することができます。\n コード 3-19. VertexBufferResource オブジェクトのデータポインタの取得\n static nnResult nn::gd::Resource::MapVertexBufferResource(\n nn::gd::VertexBufferResource* buffer,\n nn::gd::Resource::MapUsage usage, void** data);\nstatic nnResult nn::gd::Resource::UnmapVertexBufferResource(\n nn::gd::VertexBufferResource* buffer);\n buffer に指定した VertexBufferResource オブジェクトのリソースデータの先頭アドレスが data に返されます。usage には、以下のマッピング方法（リソースデータへのアクセスの種類）を指定します。\n 表 3-4. データポインタのマッピング方法\n \t定義 \tマッピング方法 \tデバイスメモリ \tVRAM\n \t Resource::MAP_READ_ONLY \t読み込みのみ \t○ \t○\n \t Resource::MAP_WRITE_ONLY \t書き込みのみ \t○ \tエラー\n \t Resource::MAP_READ_WRITE \t読み書き \t○ \tエラー\n 補足：\n マッピング方法のチェックはデータポインタの取得時にのみ行われます。MAP_READ_ONLY で取得したデバイスメモリ上のリソースデータに書き込みを行ってもエラーにはなりませんが、マッピングの解除時にキャッシュがフラッシュされません。\n VRAM 上のリソースデータに直接アクセスすることはできません。DMA 転送などで、CPU から直接アクセス可能なメモリ上にコピーしてください。\nリソースデータへのアクセスが完了したあとは、nn::gd::Resource::UnmapVertexBufferResource() でマッピングを解除してください。書き込みを含むマッピング方法でデバイスメモリ上のリソースデータのデータポインタを取得していた場合は、マッピングの解除時にキャッシュのフラッシュが行われます。\n",0]
,["Pages/Page_54693523.html#PageId_54693544","3.2.5. リソースデータの部分コピー（VertexBufferResource オブジェクト）",
"3.2.5. リソースデータの部分コピー（VertexBufferResource オブジェクト）\nリソースデータの部分コピーを行うことができます。この関数内で nngxAddBlockImageCopyCommand() を呼び出していますので、実際のコピー処理はコマンドリストの実行時に行われます。\n コード 3-20. リソースデータの部分コピー（VertexBufferResource オブジェクト）\n static nnResult nn::gd::Memory::CopyVertexBufferSubResource(\n const nn::gd::VertexBufferResource* source,\n u32 sourceOffset, u32 size,\n const nn::gd::VertexBufferResource* dest, u32 destOffset);\n sourceOffset 、size、destOffset のすべてが 16 の倍数で指定されていなければコピー処理は行われません。\n",0]
,["Pages/Page_54693545.html","4. 各モジュールの説明",
"4. 各モジュールの説明\n",0]
,["Pages/Page_54693545.html#PageId_54693546","4.1. シェーダステージ",
"4.1. シェーダステージ\nシェーダステージでは頂点シェーダおよびジオメトリシェーダに関する設定を行います。これらの設定を行う関数は nn::gd::ShaderStage クラスに定義されています。\n以下の図はシェーダステージで行われる設定の概要を示したものです。\n 図 4-1. シェーダステージの概要\nShaderStageクラス シェーダプログラム SetShaderPipeline() ShaderPipelineオブジェクト 頂点シェーダ ジオメトリシェーダ ユニフォーム設定 CreateShaderPipeline() Shaderオブジェクト シェーダプログラム（頂点シェーダ） CreateShader() シェーダプログラム（ジオメトリシェーダ） シェーダバイナリファイル CreateShaderBinary() ShaderBinaryオブジェクト\n頂点シェーダおよびジオメトリシェーダは、事前にコンパイルされたシェーダバイナリファイルとしてアプリケーションに読み込まれます。シェーダバイナリファイルには、1 つ以上の頂点シェーダやジオメトリシェーダのシェーダプログラムを含むことができます。\nシェーダバイナリファイルの中に記述されている特定のシェーダを参照するためには、読み込んだシェーダバイナリファイルを nn::gd::ShaderStage::CreateShaderBinary() に渡して作成された ShaderBinary オブジェクトを使用します。\n コード 4-1. ShaderBinary オブジェクトの作成\n static nnResult nn::gd::ShaderStage::CreateShaderBinary(\n const void* shaderBytecode, u32 bytecodeLength,\n nn::gd::ShaderBinary** shaderBinary);\n shaderBytecode と bytecodeLength には、読み込んだシェーダバイナリのコードが格納されているバッファの先頭アドレスとコードのバイトサイズを指定します。\n今後、作成された ShaderBinary オブジェクトへのアクセスには shaderBinary で受け取ったポインタを介して行います。\n ShaderBinary オブジェクトに含まれているシェーダプログラムにアクセスするための Shader オブジェクトは nn::gd::ShaderStage::CreateShader() で作成します。Shader オブジェクトは 1 つのシェーダコード（頂点シェーダ、ジオメトリシェーダのいずれか）を表します。\n コード 4-2. Shader オブジェクトの作成\n static nnResult nn::gd::ShaderStage::CreateShader(\n nn::gd::ShaderBinary* shaderBinary, u32 shaderBinaryIndex,\n nn::gd::Shader** shader);\n shaderBinary に指定されている ShaderBinary オブジェクトに複数のシェーダプログラムが含まれている場合は、シェーダプログラムのインデックスを shaderBinaryIndex に指定して Shader オブジェクトを作成してください。\n今後、作成された Shader オブジェクトへのアクセスには shader で受け取ったポインタを介して行います。\nシェーダプログラムをパイプラインに反映するために使用する ShaderPipeline オブジェクトは、1 つまたは 2 つの Shader オブジェクトを用いて、nn::gd::ShaderStage::CreateShaderPipeline() で作成されます。\n コード 4-3. ShaderPipeline オブジェクトの作成とパイプラインへの反映\n static nnResult nn::gd::ShaderStage::CreateShaderPipeline(\n nn::gd::Shader* vertexShader, nn::gd::Shader* geometryShader,\n nn::gd::ShaderPipeline** shaderPipeline,\n nn::gd::ShaderPipelineUnmanagedRegisters* unmanagedRegister = NULL);\nstatic nnResult nn::gd::ShaderStage::SetShaderPipeline(\n nn::gd::ShaderPipeline* shaderPipeline);\n vertexShader には、頂点シェーダとして使用する Shader オブジェクトを指定します。geometryShader には、ジオメトリシェーダとして使用する Shader オブジェクトを指定しますが、ジオメトリシェーダが不要である場合は NULL を渡してください。\n unmanagedRegister には、レジスタ設定のコマンドをライブラリが自動生成しないようにするレジスタの範囲を指定します。この設定については「4.1.2. ライブラリによるレジスタへの設定コマンドの自動生成」で説明します。\n 注意：\n GD ライブラリでは、頂点シェーダからジオメトリシェーダへと出力される頂点属性が正しいかどうかをチェックしません。頂点シェーダから出力される頂点属性とジオメトリシェーダの入力に使用する頂点属性が一致するように、正しい組み合わせの Shader オブジェクトで ShaderPipeline オブジェクトを作成してください。\n以下のコード例では、頂点シェーダのみを使用する ShaderPipeline オブジェクトを生成してパイプラインに反映しています。\n コード 4-4. シェーダステージで行われる設定のコード例\n nn::gd::ShaderBinary* shaderBinary = 0;\nnn::gd::ShaderPipeline* shaderPipeline = 0;\nnn::gd::Shader* vertexShader = 0;\nnn::gd::ShaderStage::CreateShaderBinary(\n shaderBinaryFileBuffer, bufferSize, &shaderBinary);\nnn::gd::ShaderStage::CreateShader(shaderBinary, 0, &vertexShader);\nnn::gd::ShaderStage::CreateShaderPipeline(vertexShader, NULL, &shaderPipeline);\nnn::gd::ShaderStage::SetShaderPipeline(shaderPipeline);\n",0]
,["Pages/Page_54693545.html#PageId_54693547","4.1.1. シェーダ設定レジスタへの設定",
"4.1.1. シェーダ設定レジスタへの設定\n浮動小数点定数レジスタなどのシェーダ設定レジスタへ設定される値は ShaderPipeline オブジェクトが保持しています。GD ライブラリでは、シェーダ設定レジスタへの設定値をシェーダステージの関数で変更することができます。関数で更新された変数は一旦内部状態としてオブジェクトに保存され、描画コマンドが要求されるまで 3D コマンドバッファに出力されません。\nレジスタの種類によって、値の設定に使用する関数は以下のように異なります。\n 表 4-1. レジスタの種類と呼び出す関数\n \tレジスタの種類 \t関数\n \t浮動小数点定数レジスタ \t nn::gd::ShaderStage::SetShaderPipelineConstantFloat()\n \tブールレジスタ \t nn::gd::ShaderStage::SetShaderPipelineConstantBoolean()\n \t整数レジスタ \t nn::gd::ShaderStage::SetShaderPipelineConstantInteger()\n コード 4-5. シェーダ設定レジスタへの値の設定に使用する関数\n static nnResult nn::gd::ShaderStage::SetShaderPipelineConstantFloat(\n nn::gd::ShaderPipeline* shaderPipeline,\n nn::gd::UniformLocation uniformLocation, f32* v);\nstatic nnResult nn::gd::ShaderStage::SetShaderPipelineConstantBoolean(\n nn::gd::ShaderPipeline* shaderPipeline,\n nn::gd::UniformLocation uniformLocation, u16 v, u32 count);\nstatic nnResult nn::gd::ShaderStage::SetShaderPipelineConstantInteger(\n nn::gd::ShaderPipeline* shaderPipeline,\n nn::gd::UniformLocation uniformLocation, u8* v);\nstatic nn::gd::UniformLocation nn::gd::ShaderStage::GetShaderUniformLocation(\n nn::gd::ShaderPipeline* shaderPipeline, const char* name);\n設定値を変更するレジスタの指定には nn::gd::ShaderStage::GetShaderUniformLocation() で取得した UniformLocation クラスを使用します。取得する際の name にはユニフォーム設定の名前を指定してください。正しいユニフォーム設定が取得できている場合、UniformLocation クラスの IsValid() は 1 を返します。\n",0]
,["Pages/Page_54693545.html#PageId_54693548","4.1.2. ライブラリによるレジスタへの設定コマンドの自動生成",
"4.1.2. ライブラリによるレジスタへの設定コマンドの自動生成\n通常、現在反映されているものとは別の ShaderPipeline オブジェクトをパイプラインに反映させたときには、レジスタへの設定コマンドが自動的に生成されます。しかし、場合によっては自動的に設定コマンドを生成せずに、直接レジスタに値を書き込むコマンドを生成することでパフォーマンスが向上するケースがあります。\nそのようなケースを考慮して、nn::gd::ShaderStage::SetFloatConstantBuffer() で独自にレジスタの設定値を変更することができます。\n コード 4-6. 独自にレジスタの設定値を変更する関数\n static nnResult nn::gd::ShaderStage::SetFloatConstantBuffer(\n nn::gd::ShaderStage::ShaderType shaderType,\n u32 firstRegisterIndex, u32 registerCount, f32* constantBufferSrc);\nこの関数で設定値が変更できるのは、自動的に設定コマンドを生成しない（「unmanaged」な）浮動小数点定数レジスタに限られています。「unmanaged」なレジスタの範囲は ShaderPipeline オブジェクトの作成時の引数 unmanagedRegister に渡す ShaderPipelineUnmanagedRegisters クラスで指定します。\n ShaderPipelineUnmanagedRegisters クラスは UnmanagedRegistersInterval クラスの配列とその要素数で構成され、UnmanagedRegistersInterval クラスはシェーダの種類（m_ShaderType）と「unmanaged」なレジスタの最初の番号（m_FirstUnmanagedRegister）と個数（m_RegisterCount）で構成されています。\n コード 4-7. 「unmanaged」なレジスタの指定で使用するクラス\n class nn::gd::UnmanagedRegistersInterval\n{\n nn::gd::ShaderStage::ShaderType m_ShaderType;\n u32 m_FirstUnmanagedRegister;\n u32 m_RegisterCount;\n};\nclass nn::gd::ShaderPipelineUnmanagedRegisters\n{\n nn::gd::UnmanagedRegistersInterval* m_ArrayUnmanagedRegistersInterval;\n u32 m_CountUnmanagedRegistersInterval;\n};\n以下のコード例は「unmanaged」なレジスタを含む ShaderPipeline クラスの作成例です。\n コード 4-8. 「unmanaged」なレジスタを含む ShaderPipeline クラスの作成例\n nn::gd::ShaderPipelineUnmanagedRegisters unmanagedRegs;\nnn::gd::UnmanagedRegistersInterval arrayUnmanagedRegistersInterval[] =\n{\n {nn::gd::ShaderStage::SHADER_TYPE_VERTEX, 0, 4},\n {nn::gd::ShaderStage::SHADER_TYPE_VERTEX, 4, 3},\n {nn::gd::ShaderStage::SHADER_TYPE_VERTEX, 8, 3}\n};\nunmanagedRegs.m_ArrayUnmanagedRegistersInterval =\n arrayUnmanagedRegistersInterval;\nunmanagedRegs.m_CountUnmanagedRegistersInterval = 3;\nnn::gd::ShaderStage::CreateShaderPipeline(\n s_vertexShader, NULL, &s_shaderPipeline, &unmanagedRegs);\n「unmanaged」なレジスタには、以下のようなコードで直接書き込むことになります。\n コード 4-9. 「unmanaged」なレジスタへの書き込み\n nn::gd::UniformLocation s_shaderVariable_proj =\n nn::gd::ShaderStage::GetShaderUniformLocation(\n s_shaderPipeline, \"uProjection\");\nnn::gd::ShaderStage::SetFloatConstantBuffer(\n nn::gd::ShaderStage::SHADER_TYPE_VERTEX,\n s_shaderVariable_proj.getRegister(), 4, data);\n新たに反映された ShaderPipeline オブジェクトが、現在反映されていたものとは異なる ShaderBinary オブジェクトから作成されたものである場合、描画の際に ShaderBinary オブジェクトに含まれるすべてのデータが 3D コマンドバッファに出力されます。この処理には負荷がかかるため、「unmanaged」なレジスタを利用して、出力される 3D コマンドを最小限に止めるようにすることが推奨されます。\n",0]
,["Pages/Page_54693545.html#PageId_54693549","4.2. 頂点入力ステージ",
"4.2. 頂点入力ステージ\n頂点入力ステージではパイプラインへの頂点データ（頂点属性）の入力に関する設定を行います。これらの設定を行うための関数は nn::gd::VertexInputStage クラスに定義されています。\n以下の図は頂点入力ステージで行われる設定の概要を示したものです。\n 図 4-2. 頂点入力ステージの概要\nVertexInputStageクラス 頂点バッファのスロット（12個） 頂点インデックスバッファ プリミティブの種類 ステートオブジェクト（入力レイアウト） SetVertexBuffers() SetIndexBuffer() SetPrimitiveTopology() SetInputLayout() VertexBufferResourceオブジェクト オフセット IndexFormat PrimitiveTopology InputLayoutオブジェクト Shaderオブジェクト InputElementDescriptionクラス CreateInputLayout()\n",0]
,["Pages/Page_54693545.html#PageId_54693550","4.2.1. 頂点バッファの登録",
"4.2.1. 頂点バッファの登録\n頂点バッファは頂点入力ステージに 12 個あるスロットに登録します。nn::gd::VertexInputStage::SetVertexBuffers() では VertexBufferResource オブジェクトの配列と頂点データの開始オフセットの配列を指定しますので、一度の呼び出しで連続する複数のスロットに頂点バッファを登録することができます。\n コード 4-10. 頂点バッファの登録\n static nnResult nn::gd::VertexInputStage::SetVertexBuffers(\n u32 startSlot, u32 numBuffers,\n nn::gd::VertexBufferResource** vertexBuffers, u32* offsets);\n startSlot には頂点バッファを登録する最初のスロット番号（0～11）を、numBuffers には vertexBuffers に指定された VertexBufferResource オブジェクト配列の要素数を、offsets には頂点データの開始オフセットの配列を指定します。登録される頂点バッファを構成する頂点データの要素は、「4.2.4. 入力レイアウト」で説明する InputLayout オブジェクトでの定義と一致している必要があります。\n",0]
,["Pages/Page_54693545.html#PageId_54693551","4.2.2. 頂点インデックスの使用",
"4.2.2. 頂点インデックスの使用\nプリミティブの描画に頂点インデックスを使用する場合は、頂点インデックスの配列をリソースデータに指定して作成された VertexBufferResource オブジェクトを nn::gd::VertexInputStage::SetIndexBuffer() で頂点入力ステージに登録します。\n コード 4-11. 頂点インデックスの登録\n static nnResult nn::gd::VertexInputStage::SetIndexBuffer(\n nn::gd::VertexBufferResource* indexBuffer,\n nn::gd::VertexInputStage::IndexFormat format, u32 offset);\n indexBuffer に指定されている VertexBufferResource オブジェクトが頂点入力ステージに登録されます。頂点データなどとインターリーブされている VertexBufferResource オブジェクトを登録する場合は、頂点インデックスの開始位置をバイト単位のオフセット値を offset に指定します。\n format には、頂点インデックスのフォーマットを以下から選択して指定します。\n 表 4-2. 頂点インデックスのフォーマット指定\n \t定義 \t説明\n \t INDEX_FORMAT_UBYTE \t頂点インデックスを unsigned byte の配列として扱います。\n \t INDEX_FORMAT_USHORT \t頂点インデックスを unsigned short の配列として扱います。\n",0]
,["Pages/Page_54693545.html#PageId_54693552","4.2.3. プリミティブの種類",
"4.2.3. プリミティブの種類\n描画するプリミティブの種類は nn::gd::VertexInputStage::SetPrimitiveTopology() で設定します。\n コード 4-12. 描画するプリミティブの種類の設定\n static nnResult nn::gd::VertexInputStage::SetPrimitiveTopology(\n nn::gd::VertexInputStage::PrimitiveTopology primitiveTopology);\n primitiveTopology には、プリミティブの種類を以下から選択して指定します。\n 表 4-3. プリミティブの種類\n \t定義 \t説明\n \t PRIMITIVE_TOPOLOGY_TRIANGLELIST \tTriangles（GL_TRIANGLES）\n \t PRIMITIVE_TOPOLOGY_TRIANGLESTRIP \tTriangle Strip（GL_TRIANGLE_STRIP）\n \t PRIMITIVE_TOPOLOGY_TRIANGLEFAN \tTriangle Fan（GL_TRIANGLE_FAN）\n \t PRIMITIVE_TOPOLOGY_GEOMETRY \tジオメトリシェーダ（GL_GEOMETRY_PRIMITIVE_DMP）\n",0]
,["Pages/Page_54693545.html#PageId_54693553","4.2.4. 入力レイアウト",
"4.2.4. 入力レイアウト\n入力レイアウト（InputLayout オブジェクト）には、頂点バッファと頂点シェーダの間での入力変数の接続方法を定義します。頂点バッファは単純なスカラ値またはインターリーブされたいくつかのスカラ値の配列によって構成されています。InputLayout オブジェクトは、入力要素（頂点データ）のデスクリプタクラス（InputElementDescription）の配列とシェーダステージで作成した Shader オブジェクトを引数に持つ、nn::gd::VertexInputStage::CreateInputLayout() の呼び出しで作成します。\n コード 4-13. 入力レイアウトの作成、解放、パイプラインへの設定\n static nnResult nn::gd::VertexInputStage::CreateInputLayout(\n nn::gd::InputElementDescription* inputElementDescs, u32 numElements,\n u32* strides, nn::gd::Shader* vertexShader,\n nn::gd::InputLayout** inputLayout);\nstatic nnResult nn::gd::VertexInputStage::ReleaseInputLayout(\n nn::gd::InputLayout* inputLayout);\nstatic nnResult nn::gd::VertexInputStage::SetInputLayout(\n nn::gd::InputLayout* inputLayout);\n入力要素の情報は inputElementDescs に指定するデスクリプタクラス（InputElementDescription）の配列にあらかじめ設定し、numElements には配列に含まれているデスクリプタクラスの数を渡します。デスクリプタクラスに設定する情報の詳細は「4.2.4.1. InputLayout オブジェクトのデスクリプタクラス」を参照してください。\n strides には、1 頂点あたりに使用する頂点データのサイズをスロット番号ごとの配列で指定します。すべての入力要素が 1 つの頂点バッファにインターリーブされているならば、その入力要素の合計サイズで 1 つの要素だけを持つ配列となります。インターリーブされていなければ、それぞれの入力要素のサイズで複数の要素を持つ配列となります。\n vertexShader には、頂点シェーダの Shader オブジェクトを指定します。\n作成された InputLayout オブジェクトは nn::gd::VertexInputStage::SetInputLayout() でパイプラインに反映することができます。\n不要になった InputLayout オブジェクトは nn::gd::VertexInputStage::ReleaseInputLayout() で解放してください。このとき、オブジェクトが作成されたときに内部で確保されたメモリ領域も解放されます。\n以下のコード例は、3 つの入力要素がインターリーブされた 1 つの頂点バッファを記述するデスクリプタクラスから作成された入力レイアウトをパイプライン（頂点入力ステージ）に設定するものです。\n コード 4-14. 入力レイアウトの作成例\n nn::gd::InputLayout* inputLayout = 0;\nnn::gd::InputElementDescription descs[] =\n{\n { 0, \"aPosition\",\n nn::gd::VertexInputStage::STREAM_TYPE_FLOAT, 3, 0 },\n { 0, \"aColor\",\n nn::gd::VertexInputStage::STREAM_TYPE_FLOAT, 4, sizeof(float) * 3 },\n { 0, \"aNormal\",\n nn::gd::VertexInputStage::STREAM_TYPE_FLOAT, 3, sizeof(float) * 7 },\n};\nu32 strides[] = { sizeof(float) * 10 };\nnn::gd::VertexInputStage::CreateInputLayout(\n descs, 3, strides, vertexShader, &inputLayout);\nnn::gd::VertexInputStage::SetInputLayout(inputLayout);\n",0]
,["Pages/Page_54693545.html#PageId_54693554","4.2.4.1. InputLayout オブジェクトのデスクリプタクラス",
"4.2.4.1. InputLayout オブジェクトのデスクリプタクラス\n InputLayout オブジェクトのデスクリプタクラス（InputElementDescription）のメンバを紹介し、設定に際しての注意点などを説明します。\n コード 4-15. InputElementDescription クラスの定義\n class nn::gd::InputElementDescription\n{\n u32 m_StreamSlot;\n const char* m_SemanticName;\n nn::gd::VertexInputStage::ShaderStreamFormatType m_Format;\n u32 m_Count;\n u32 m_AlignedByteOffset;\n static const u32 Append = 0x00080000;\n};\n",0]
,["Pages/Page_54693545.html#Anchor_54693554_スロット番号（m_StreamSlot）","スロット番号（m_StreamSlot）",
"スロット番号（m_StreamSlot）\n入力要素が使用するスロット番号（0～11）です。複数の入力要素が同じスロット番号を使用する場合、そのスロット番号に登録される頂点バッファはインターリーブされていなければなりません。また、スロット番号は 0 から昇順に、連番で登録されていなければなりません。\n",0]
,["Pages/Page_54693545.html#Anchor_54693554_入力変数の名前（m_SemanticName）","入力変数の名前（m_SemanticName）",
"入力変数の名前（m_SemanticName）\n頂点シェーダで定義されている入力変数の名前です。\n",0]
,["Pages/Page_54693545.html#Anchor_54693554_入力要素のデータフォーマット（m_Format）","入力要素のデータフォーマット（m_Format）",
"入力要素のデータフォーマット（m_Format）\n入力要素のデータフォーマットです。以下から選択して設定します。\n 表 4-4. 入力要素のデータフォーマット\n \t定義 \t説明\n \t VertexInputStage::STREAM_TYPE_BYTE \tbyte（GL_BYTE）\n \t VertexInputStage::STREAM_TYPE_UNSIGNED_BYTE \tunsigned byte（GL_UNSIGNED_BYTE）\n \t VertexInputStage::STREAM_TYPE_SHORT \tshort（GL_SHORT）\n \t VertexInputStage::STREAM_TYPE_FLOAT \tfloat（GL_FLOAT）\n ",0]
,["Pages/Page_54693545.html#Anchor_54693554_入力要素のサイズ（m_Count）","入力要素のサイズ（m_Count）",
"入力要素のサイズ（m_Count）\n入力要素のサイズ（コンポーネント数）です。設定可能な値の範囲は 1 ～ 4 です。入力要素のバイトサイズではないことに注意してください。\n",0]
,["Pages/Page_54693545.html#Anchor_54693554_入力要素のオフセット（m_AlignedByteOffset）","入力要素のオフセット（m_AlignedByteOffset）",
"入力要素のオフセット（m_AlignedByteOffset）\n入力要素の先頭までのオフセット（バイト単位）です。InputElementDescription::Append を指定した場合はオフセットが自動的に計算され、デスクリプタクラスの設定を簡便化することができます。\n",0]
,["Pages/Page_54693545.html#PageId_54693555","4.3. テクスチャステージ",
"4.3. テクスチャステージ\nテクスチャステージでは、テクスチャオブジェクトの作成やテクスチャユニットに関する設定を行います。これらの設定を行うための関数は nn::gd::TextureStage クラスに定義されています。\n以下の図はテクスチャステージで行われる設定の概要を示したものです。\n 図 4-3. テクスチャステージの概要\nTextureStageクラス テクスチャユニット0 テクスチャユニット1 テクスチャユニット2 テクスチャユニット3 シャドウの設定 プロジェクションテクスチャ設定 テクスチャリソース ステートオブジェクト（サンプラー設定） テクスチャ座標 バイアス値 GD_TRUE GD_FALSE TextureCubeオブジェクト TextureCubeDescriptionクラス Texture2DResourceオブジェクト Texture2Dオブジェクト Textture2DDescriptionクラス SamplerStateオブジェクト SamplerStateDescriptionクラス TextureCoordinateSourceUnit2 TextureCoordinateSourceUnit3 SetShadowZBias() SetPerspectiveShadow() SetTexture2DProjectionForUnit0() SetTextureUnit0() SetTexture() SetSamplerState() SetTextureCoordinateSourceForUnit2() SetTextureCoordinateSourceForUnit3Procedural() CreateTextureCube() CreateTexture2D() CreateSamplerState()\n",0]
,["Pages/Page_54693545.html#PageId_54693556","4.3.1. 2 次元テクスチャ",
"4.3.1. 2 次元テクスチャ\nGD ライブラリでは Texture2D オブジェクトで 2 次元テクスチャを扱います。Texture2D オブジェクトは 1 つの Texture2DResource オブジェクトとデスクリプタクラス（Texture2DDescription）から作成されます。なお、デスクリプタクラスの設定によって、Texture2DResource オブジェクトがミップマップデータを含んでいる場合に、Texture2D オブジェクトの作成にどのレベルのミップマップデータを使用するかを指定することができます。デスクリプタクラスに設定する情報の詳細は「4.3.1.1. Texture2D オブジェクトのデスクリプタクラス」を参照してください。\n Texture2D オブジェクトの作成と解放は以下の関数で行うことができます。\n コード 4-16. Texture2D オブジェクトの作成と解放\n static nnResult nn::gd::TextureStage::CreateTexture2D(\n const nn::gd::Texture2DResource* tex2DResource,\n nn::gd::Texture2DDescription* desc,\n nn::gd::Texture2D** texture2D);\nstatic nnResult nn::gd::TextureStage::ReleaseTexture2D(\n nn::gd::Texture2D* texture2D);\n Texture2D オブジェクトの解放時には管理情報のみが解放されます。Texture2DResource オブジェクトは解放されません。\n以下は Texture2DResource オブジェクトを作成し、そこから Texture2D オブジェクトを作成するコードの例です。\n コード 4-17. Texture2D オブジェクト作成のコード例\n nn::gd::Texture2DResource* texture2DResource = 0;\nnn::gd::Texture2DResourceDescription Text2DResDesc =\n {256, 256, 1, nn::gd::Resource::NATIVE_FORMAT_RGB_888,\n nn::gd::Memory::LAYOUT_BLOCK_8, nn::gd::Memory::FCRAM};\nnn::gd::Resource::CreateTexture2DResource(\n &Text2DResDesc, data, GD_FALSE, &texture2DResource);\nnn::gd::Texture2D* texture2D = 0;\nnn::gd::Texture2DDescription tex2DDesc = {0, 0};\nnn::gd::TextureStage::CreateTexture2D(\n texture2DResource, &tex2DDesc, &texture2D);\n",0]
,["Pages/Page_54693545.html#PageId_54693557","4.3.1.1. Texture2D オブジェクトのデスクリプタクラス",
"4.3.1.1. Texture2D オブジェクトのデスクリプタクラス\n Texture2D オブジェクトのデスクリプタクラス（Texture2DDescription）のメンバを紹介し、設定に際しての注意点などを説明します。\n コード 4-18. Texture2DDescription クラスの定義\n class nn::gd::Texture2DDescription\n{\n s32 m_MinMipLevelIndex;\n s32 m_MaxMipLevelIndex;\n};\n",0]
,["Pages/Page_54693545.html#Anchor_54693557_最小ミップマップレベルのインデックス（m_MinMipLevelIndex）","最小ミップマップレベルのインデックス（m_MinMipLevelIndex）",
"最小ミップマップレベルのインデックス（m_MinMipLevelIndex）\n Texture2D オブジェクトの最小ミップマップレベルに使用する Texture2DResource オブジェクトのミップマップレベルです。-1 を設定した場合は Texture2DResource オブジェクトの最大のミップマップレベルが使用されます。\n",0]
,["Pages/Page_54693545.html#Anchor_54693557_最大ミップマップレベルのインデックス（m_MaxMipLevelIndex）","最大ミップマップレベルのインデックス（m_MaxMipLevelIndex）",
"最大ミップマップレベルのインデックス（m_MaxMipLevelIndex）\n Texture2D オブジェクトの最大ミップマップレベルに使用する Texture2DResource オブジェクトのミップマップレベルです。-1 を設定した場合は Texture2DResource オブジェクトの最大のミップマップレベルが使用されます。\n",0]
,["Pages/Page_54693545.html#PageId_54693558","4.3.1.2. Texture2D オブジェクトの詳細情報の取得",
"4.3.1.2. Texture2D オブジェクトの詳細情報の取得\n詳細情報（Texture2DProperties クラス）を nn::gd::TextureStage::GetTexture2DProperties() で取得することができます。\n コード 4-19. Texture2D オブジェクトの詳細情報の取得\n static nnResult nn::gd::TextureStage::GetTexture2DProperties(\n const nn::gd::Texture2D* texture2D,\n nn::gd::Texture2DProperties* properties);\nオブジェクトの作成時に指定したミップマップレベルによって、幅や高さ、ミップマップレベル、リソースデータの先頭アドレスが変化することはありますが、基本的に Texture2DResource オブジェクトの詳細情報と同じです。\n コード 4-20. Texture2DProperties クラスの定義\n class nn::gd::Texture2DProperties\n{\n u32 m_Width;\n u32 m_Height;\n u32 m_CountMipLevels;\n u32 m_PixelSize;\n nn::gd::Resource::NativeFormat m_Format;\n nn::gd::Memory::MemoryLayout m_MemLayout;\n nn::gd::Memory::MemoryLocation m_MemLocation;\n u8* m_MemAddr;\n nn::gd::MipmapResourceInfo GetMipmapAddress(u32 mipmapLevel);\n};\n",0]
,["Pages/Page_54693545.html#PageId_54693559","4.3.2. キューブマップテクスチャ",
"4.3.2. キューブマップテクスチャ\nGD ライブラリでは TextureCube オブジェクトでキューブマップテクスチャを扱います。TextureCube オブジェクトは 6 つの Texture2DResource オブジェクトを用いて作成されます。Texture2D オブジェクトと同様に、どのミップマップレベルを使用するかを指定することができます。すべての面の Texture2DResource オブジェクトは同じフォーマット、同じ解像度（ミップマップによる）、同じミップマップレベル、同じメモリ配置場所を満たしている必要があります。\n TextureCube オブジェクトの作成と解放は以下の関数で行うことができます。\n コード 4-21. TextureCube オブジェクトの作成と解放\n static nnResult nn::gd::TextureStage::CreateTextureCube(\n nn::gd::Texture2DResource** tex2DResources,\n nn::gd::TextureCubeDescription* desc,\n nn::gd::TextureCube** textureCube);\nstatic nnResult nn::gd::TextureStage::ReleaseTextureCube(\n nn::gd::TextureCube* textureCube);\n tex2DResources には、6 面分の Texture2DResource オブジェクトの配列を指定します。配列の先頭から、+X、-X、+Y、-Y、+Z、-Z 面のテクスチャに使用されます。デスクリプタクラスでの配列の順序やキューブマップテクスチャの面を指定する際も同じです。\n TextureCube オブジェクトの解放時には管理情報のみが解放されます。Texture2DResource オブジェクトは解放されません。\n",0]
,["Pages/Page_54693545.html#PageId_54693560","4.3.2.1. TextureCube オブジェクトのデスクリプタクラス",
"4.3.2.1. TextureCube オブジェクトのデスクリプタクラス\n TextureCube オブジェクトのデスクリプタクラス（TextureCubeDescription）のメンバを紹介し、設定に際しての注意点などを説明します。\n コード 4-22. TextureCubeDescription クラスの定義\n class nn::gd::TextureCubeDescription\n{\n s32 m_MinMipLevelIndex[6];\n s32 m_MaxMipLevelIndex[6];\n TextureCubeDescription();\n TextureCubeDescription(int minMipLevelIndex, int maxMipLevelIndex);\n};\n6 面分のミップマップレベルを指定することや、それを簡便化するためのコンストラクタが用意されている点が Texture2DDescription クラスとは異なります。\n",0]
,["Pages/Page_54693545.html#Anchor_54693560_最小ミップマップレベルのインデックス（m_MinMipLevelIndex）","最小ミップマップレベルのインデックス（m_MinMipLevelIndex）",
"最小ミップマップレベルのインデックス（m_MinMipLevelIndex）\n TextureCube オブジェクトの最小ミップマップレベルに使用する Texture2DResource オブジェクトのミップマップレベルです。-1 を設定した場合は Texture2DResource オブジェクトの最大のミップマップレベルが使用されます。\n配列の先頭から、+X、-X、+Y、-Y、+Z、-Z 面の Texture2DResource オブジェクトに対応しています。\n",0]
,["Pages/Page_54693545.html#Anchor_54693560_最大ミップマップレベルのインデックス（m_MaxMipLevelIndex）","最大ミップマップレベルのインデックス（m_MaxMipLevelIndex）",
"最大ミップマップレベルのインデックス（m_MaxMipLevelIndex）\n TextureCube オブジェクトの最大ミップマップレベルに使用する Texture2DResource オブジェクトのミップマップレベルです。-1 を設定した場合は Texture2DResource オブジェクトの最大のミップマップレベルが使用されます。\n配列の先頭から、+X、-X、+Y、-Y、+Z、-Z 面の Texture2DResource オブジェクトに対応しています。\n",0]
,["Pages/Page_54693545.html#PageId_54693561","4.3.2.2. TextureCube オブジェクトの詳細情報の取得",
"4.3.2.2. TextureCube オブジェクトの詳細情報の取得\n TextureCube オブジェクトの詳細情報（TextureCubeProperties クラス）を nn::gd::TextureStage::GetTextureCubeProperties() で取得することができます。\n コード 4-23. TextureCube オブジェクトの詳細情報の取得\n static nnResult nn::gd::TextureStage::GetTextureCubeProperties(\n const nn::gd::TextureCube* TextureCube,\n nn::gd::TextureCubeProperties* properties);\n6 面分のリソースデータの先頭アドレスが保持されていることや、ミップマップデータのアドレス情報の取得で faceIndex にキューブマップ面を指定すること以外は Texture2DProperties クラスと同じです。\n コード 4-24. TextureCubeProperties クラスの定義\n class nn::gd::TextureCubeProperties\n{\n u32 m_Width;\n u32 m_Height;\n u32 m_CountMipLevels;\n u32 m_PixelSize;\n nn::gd::Resource::NativeFormat m_Format;\n nn::gd::Memory::MemoryLayout m_MemLayout;\n nn::gd::Memory::MemoryLocation m_MemLocation;\n u8* m_MemAddr[6];\n nn::gd::MipmapResourceInfo GetMipmapAddress(u32 faceIndex, u32 mipmapLevel);\n};\n",0]
,["Pages/Page_54693545.html#PageId_54693562","4.3.3. テクスチャユニット",
"4.3.3. テクスチャユニット\nGD ライブラリでは、3DS のハードウェア構成に合わせて 4 つの論理的なテクスチャユニットを提供しています。\n 表 4-5. テクスチャユニットと設定可能なテクスチャの種類\n \t定義 \t設定可能なテクスチャの種類\n \t TextureStage::TEXTURE_UNIT_0\n （テクスチャユニット 0）\n \t 2 次元テクスチャ（ガス、シャドウ含む）\n キューブマップテクスチャ（シャドウ含む）\n プロジェクションテクスチャ\n \t TextureStage::TEXTURE_UNIT_1\n （テクスチャユニット 1）\n \t2 次元テクスチャ\n \t TextureStage::TEXTURE_UNIT_2\n （テクスチャユニット 2）\n \t2 次元テクスチャ\n \t TextureStage::TEXTURE_UNIT_3_PROCEDURAL\n （テクスチャユニット 3）\n \tプロシージャルテクスチャ\n 補足：\n テクスチャ座標以外の TextureStage::TEXTURE_UNIT_3_PROCEDURAL への設定は、プロシージャルテクスチャステージで行います。\n",0]
,["Pages/Page_54693545.html#Anchor_54693562_2次元テクスチャ","2 次元テクスチャ",
"2 次元テクスチャ\n2 次元テクスチャの設定は nn::gd::TextureStage::SetTexture() で行います。設定対象となるテクスチャユニットはテクスチャユニット 0/1/2 の 3 つです。\n コード 4-25. テクスチャユニットへの 2 次元テクスチャの設定\n static nnResult nn::gd::TextureStage::SetTexture(\n nn::gd::TextureStage::TextureUnitId textureUnitId,\n nn::gd::Texture2D& texture2D);\n",0]
,["Pages/Page_54693545.html#Anchor_54693562_そのほかのテクスチャ（プロシージャルテクスチャを除く）","そのほかのテクスチャ（プロシージャルテクスチャを除く）",
"そのほかのテクスチャ（プロシージャルテクスチャを除く）\nそのほかのテクスチャ（プロシージャルテクスチャを除く）はテクスチャユニット 0 にのみ設定することができます。\n コード 4-26. そのほかのテクスチャの設定\n static nnResult nn::gd::TextureStage::SetTextureUnit0(\n nn::gd::TextureCube& textureCube);\nstatic void nn::gd::TextureStage::SetTexture2DProjectionForUnit0(gdBool value);\nstatic void nn::gd::TextureStage::SetPerspectiveShadow(gdBool v);\nstatic void nn::gd::TextureStage::SetShadowZBias(f32 zBias);\nキューブマップテクスチャの設定は nn::gd::TextureStage::SetTextureUnit0() で行います。\n nn::gd::TextureStage::SetTexture2DProjectionForUnit0() の引数に GD_TRUE を渡して呼び出すことで、テクスチャユニット 0 に設定された 2 次元テクスチャをプロジェクションテクスチャとして扱うことができます。\nシャドウテクスチャまたはシャドウキューブマップテクスチャを参照する際のテクスチャ座標の生成に透視投影を適用する場合は、 nn::gd::TextureStage::SetPerspectiveShadow() の引数に GD_TRUE を渡して呼び出してください。また、nn::gd::TextureStage::SetShadowZBias() では、シャドウテクスチャの生成時に光源までの距離から減算されるバイアス値を設定することができます。\n",0]
,["Pages/Page_54693545.html#PageId_54693566","4.3.3.1. テクスチャ座標",
"4.3.3.1. テクスチャ座標\nテクスチャユニット 2/3 に入力されるテクスチャ座標の設定は以下の関数で行われます。\n コード 4-27. テクスチャ座標の設定\n // For TextureUnit2\nstatic void nn::gd::TextureStage::SetTextureCoordinateSourceForUnit2(\n nn::gd::TextureStage::TextureCoordinateSourceUnit2 u);\n// For TextureUnit3\nstatic void nn::gd::TextureStage::SetTextureCoordinateSourceForUnit3Procedural(\n nn::gd::TextureStage::TextureCoordinateSourceUnit3Procedural u);\nそれぞれの関数には、以下の引数が指定可能です。\n 表 4-6. テクスチャユニット 2 に設定可能なテクスチャ座標\n \t定義 \t入力されるテクスチャ座標\n \t UNIT2_TEXTURE_COORDINATE_FROM_UNIT_2 \tテクスチャ座標 2（デフォルト）\n \t UNIT2_TEXTURE_COORDINATE_FROM_UNIT_1 \tテクスチャ座標 1\n 表 4-7. テクスチャユニット 3 に設定可能なテクスチャ座標\n \t定義 \t入力されるテクスチャ座標\n \t UNIT3_PROCEDURAL_TEXTURE_COORDINATE_FROM_UNIT_0 \tテクスチャ座標 0（デフォルト）\n \t UNIT3_PROCEDURAL_TEXTURE_COORDINATE_FROM_UNIT_1 \tテクスチャ座標 1\n \t UNIT3_PROCEDURAL_TEXTURE_COORDINATE_FROM_UNIT_2 \tテクスチャ座標 2\n",0]
,["Pages/Page_54693545.html#PageId_54693567","4.3.4. サンプラー設定",
"4.3.4. サンプラー設定\nテクスチャのサンプリング方法の設定（サンプラー設定）はステートオブジェクト（SamplerState オブジェクト）を作成し、それをテクスチャユニットに設定することで行われます。\n コード 4-28. サンプラー設定の作成、解放、テクスチャユニットへの設定\n static nnResult nn::gd::TextureStage::CreateSamplerState(\n const nn::gd::SamplerStateDescription* desc,\n nn::gd::SamplerState** sampler);\nstatic nnResult nn::gd::TextureStage::ReleaseSamplerState(\n nn::gd::SamplerState* sampler);\nstatic nnResult nn::gd::TextureStage::SetSamplerState(\n nn::gd::TextureStage::TextureUnitId textureUnitId,\n nn::gd::SamplerState* sampler);\nサンプラー設定の情報は desc に指定するデスクリプタクラス（SamplerStateDescription）にあらかじめ設定します。デスクリプタクラスに設定する情報の詳細は「4.3.4.1. SamplerState オブジェクトのデスクリプタクラス」を参照してください。\n作成された SamplerState オブジェクトは nn::gd::TextureStage::SetSamplerState() でテクスチャユニットに設定することができます。サンプラー設定が可能なテクスチャユニットは、テクスチャユニット 0/1/2 の 3 つです。\n不要になった SamplerState オブジェクトは nn::gd::TextureStage::ReleaseSamplerState() で解放してください。このとき、オブジェクトが作成されたときに内部で確保されたメモリ領域も解放されます。\n以下のコード例では、デフォルトの設定から縮小時と拡大時のフィルタを変更した SamplerState オブジェクトを作成し、テクスチャユニット 0 への設定を行っています。\n コード 4-29. サンプラー設定のコード例\n nn::gd::SamplerState* sampler = 0;\nnn::gd::SamplerStateDescription samplerdesc;\nsamplerdesc.ToDefault();\nsamplerdesc.m_MinFilter = nn::gd::TextureStage::SAMPLER_MIN_FILTER_LINEAR;\nsamplerdesc.m_MagFilter = nn::gd::TextureStage::SAMPLER_MAG_FILTER_LINEAR;\nnn::gd::TextureStage::CreateSamplerState(&samplerdesc, &sampler);\nnn::gd::TextureStage::SetSamplerState(\n nn::gd::TextureStage::TEXTURE_UNIT_0, sampler);\n",0]
,["Pages/Page_54693545.html#PageId_54693568","4.3.4.1. SamplerState オブジェクトのデスクリプタクラス",
"4.3.4.1. SamplerState オブジェクトのデスクリプタクラス\n SamplerState オブジェクトのデスクリプタクラス（SamplerStateDescription クラス）のメンバを紹介し、設定に際しての注意点などを説明します。\n コード 4-30. SamplerStateDescription クラスの定義\n class nn::gd::SamplerStateDescription\n{\n nn::gd::TextureStage::SamplerMinFilter m_MinFilter;\n nn::gd::TextureStage::SamplerMagFilter m_MagFilter;\n nn::gd::TextureStage::SamplerWrapMode m_WrapS;\n nn::gd::TextureStage::SamplerWrapMode m_WrapT;\n u8 m_BorderColor[4];\n u32 m_LodBias;\n u32 m_MinLod;\n u32 m_MaxLod;\n void SetMinFilter(nn::gd::TextureStage::SamplerMinFilter filter);\n void SetMagFilter(nn::gd::TextureStage::SamplerMagFilter filter);\n void SetWrapS(nn::gd::TextureStage::SamplerWrapMode wrap);\n void SetWrapT(nn::gd::TextureStage::SamplerWrapMode wrap);\n void SetBorderColor(u8 colorR, u8 colorG, u8 colorB, u8 colorA);\n void SetBorderColor(f32 colorR, f32 colorG, f32 colorB, f32 colorA);\n void SetLodBias(f32 biasValue);\n void SetMinLod(u32 lodValue);\n void SetMaxLod(u32 lodValue);\n SamplerStateDescription();\n void ToDefault();\n void SetShadow();\n void SetShadowCube();\n void SetGas();\n};\n",0]
,["Pages/Page_54693545.html#Anchor_54693568_縮小時のフィルタ（m_MinFilter）","縮小時のフィルタ（m_MinFilter）",
"縮小時のフィルタ（m_MinFilter）\nテクスチャが縮小表示される際に適用されるフィルタです。SetMinFilter() で設定することができます。\n",0]
,["Pages/Page_54693545.html#Anchor_54693568_拡大時のフィルタ（m_MagFilter）","拡大時のフィルタ（m_MagFilter）",
"拡大時のフィルタ（m_MagFilter）\nテクスチャが拡大表示される際に適用されるフィルタです。SetMagFilter() で設定することができます。\n",0]
,["Pages/Page_54693545.html#Anchor_54693568_S方向のラッピングモード（m_WrapS）","S 方向のラッピングモード（m_WrapS）",
"S 方向のラッピングモード（m_WrapS）\nS 方向へのテクスチャの繰り返しで適用されるラッピングモードです。SetWrapS() で設定することができます。\n",0]
,["Pages/Page_54693545.html#Anchor_54693568_T方向のラッピングモード（m_WrapT）","T 方向のラッピングモード（m_WrapT）",
"T 方向のラッピングモード（m_WrapT）\nT 方向へのテクスチャの繰り返しで適用されるラッピングモードです。SetWrapT() で設定することができます。\n",0]
,["Pages/Page_54693545.html#Anchor_54693568_ボーダーカラー（m_BorderColor）","ボーダーカラー（m_BorderColor）",
"ボーダーカラー（m_BorderColor）\nラッピングモードに TextureStage::SAMPLER_WRAP_CLAMP_TO_BORDER を指定したときに使用されるボーダーカラーです。SetBorderColor() で RGBA の各成分を 0～255 または 0.0～1.0 の範囲で設定することができます。\n",0]
,["Pages/Page_54693545.html#Anchor_54693568_LODのバイアス値（m_LodBias）","LOD のバイアス値（m_LodBias）",
"LOD のバイアス値（m_LodBias）\nLOD を決定する際に使用されるバイアス値です。GPU のレジスタに設定する際のフォーマットで値を設定しなければなりませんので、-16.0 ～ 16.0 の範囲の値を SetLodBias() に渡して設定してください。\nバイアス値のフォーマットは小数部 8 ビットの符号つき 13 ビット固定小数点数です。直接メンバ変数を変更する場合は、ユーティリティ関数の Utils::Float32ToFix13Fraction8() を利用してください。\n",0]
,["Pages/Page_54693545.html#Anchor_54693568_LODの最小レベル（m_MinLod）","LOD の最小レベル（m_MinLod）",
"LOD の最小レベル（m_MinLod）\nLOD で使用する最小のミップマップレベルです。LOD を使用する場合は最小のミップマップレベルを 0 以上（使用しない場合は 0）で設定してください。SetMinLod() で設定することができます。\n",0]
,["Pages/Page_54693545.html#Anchor_54693568_LODの最大レベル（m_MaxLod）","LOD の最大レベル（m_MaxLod）",
"LOD の最大レベル（m_MaxLod）\nLOD で使用する最大のミップマップレベルです。LOD を使用しない場合は 0 を、使用する場合は（テクスチャの持つ最大のミップマップレベル – 1）を設定してください。SetMaxLod() で設定することができます。\n異なるミップマップレベル数を持つテクスチャで同じサンプラー設定を使用する場合は UINT_MAX などの大きな値を設定してください。描画時に（テクスチャの持つミップマップレベル数 - 1）が設定されます。デフォルトの設定やソースから判断しています。\n",0]
,["Pages/Page_54693545.html#Anchor_54693568_デフォルトの設定（ToDefault()）","デフォルトの設定（ToDefault()）",
"デフォルトの設定（ToDefault()）\n ToDefault() で、すべてのメンバをデフォルトの値に変更することができます。この設定はコンストラクタでも行われています。\n 表 4-8. デフォルトのサンプラー設定\n \tメンバ \t設定値\n \t m_MinFilter \t TextureStage::SAMPLER_MIN_FILTER_NEAREST\n \t m_MagFilter \t TextureStage::SAMPLER_MAG_FILTER_NEAREST\n \t m_WrapS \t TextureStage::SAMPLER_WRAP_REPEAT\n \t m_WrapT \t TextureStage::SAMPLER_WRAP_REPEAT\n \t m_BorderColor \t（0, 0, 0, 0）\n \t m_LodBias \t0.0\n \t m_MinLod \t0\n \t m_MaxLod \t0xFFFFFFFF\n ",0]
,["Pages/Page_54693545.html#Anchor_54693568_シャドウテクスチャ用の設定（SetShadow()）","シャドウテクスチャ用の設定（SetShadow()）",
"シャドウテクスチャ用の設定（SetShadow()）\n SetShadow() で、すべてのメンバをシャドウテクスチャ用の値に変更することができます。\n 表 4-9. シャドウテクスチャ用のサンプラー設定\n \tメンバ \t設定値\n \t m_MinFilter \t TextureStage::SAMPLER_MIN_FILTER_LINEAR\n \t m_MagFilter \t TextureStage::SAMPLER_MAG_FILTER_LINEAR\n \t m_WrapS \t TextureStage::SAMPLER_WRAP_CLAMP_TO_BORDER\n \t m_WrapT \t TextureStage::SAMPLER_WRAP_CLAMP_TO_BORDER\n \t m_BorderColor \t（0, 0, 0, 0）\n \t m_LodBias \t0.0\n \t m_MinLod \t0\n \t m_MaxLod \t0xFFFFFFFF\n 注意：\n フィルタ、ラッピングモード、LOD の設定を変更しないでください。\n",0]
,["Pages/Page_54693545.html#Anchor_54693568_シャドウキューブテクスチャ用の設定（SetShadowCube()）","シャドウキューブテクスチャ用の設定（SetShadowCube()）",
"シャドウキューブテクスチャ用の設定（SetShadowCube()）\n SetShadowCube() で、すべてのメンバをシャドウキューブマップテクスチャ用の値に変更することができます。\n 表 4-10. シャドウキューブマップテクスチャ用のサンプラー設定\n \tメンバ \t設定値\n \t m_MinFilter \t TextureStage::SAMPLER_MIN_FILTER_LINEAR\n \t m_MagFilter \t TextureStage::SAMPLER_MIN_FILTER_LINEAR\n \t m_WrapS \t TextureStage::SAMPLER_WRAP_CLAMP_TO_EDGE\n \t m_WrapT \t TextureStage::SAMPLER_WRAP_CLAMP_TO_EDGE\n \t m_BorderColor \t（0, 0, 0, 0）\n \t m_LodBias \t0.0\n \t m_MinLod \t0\n \t m_MaxLod \t0xFFFFFFFF\n 注意：\n フィルタ、ラッピングモード、LOD の設定を変更しないでください。\n",0]
,["Pages/Page_54693545.html#Anchor_54693568_ガステクスチャ用の設定（SetGas()）","ガステクスチャ用の設定（SetGas()）",
"ガステクスチャ用の設定（SetGas()）\n SetGas() で、すべてのメンバをガステクスチャ用の値に変更することができます。\n 表 4-11. ガステクスチャ用のサンプラー設定\n \tメンバ \t設定値\n \t m_MinFilter \t TextureStage::SAMPLER_MIN_FILTER_NEAREST\n \t m_MagFilter \t TextureStage::SAMPLER_MAG_FILTER_NEAREST\n \t m_WrapS \t TextureStage::SAMPLER_WRAP_CLAMP_TO_EDGE\n \t m_WrapT \t TextureStage::SAMPLER_WRAP_CLAMP_TO_EDGE\n \t m_BorderColor \t（0, 0, 0, 0）\n \t m_LodBias \t0.0\n \t m_MinLod \t0\n \t m_MaxLod \t0xFFFFFFFF\n 注意：\n フィルタ、ラッピングモード、LOD の設定を変更しないでください。\n",0]
,["Pages/Page_54693545.html#PageId_54693569","4.4. プロシージャルテクスチャステージ",
"4.4. プロシージャルテクスチャステージ\nプロシージャルテクスチャステージでは、プロシージャルテクスチャに関する設定を行います。これらの設定を行うための関数は nn::gd::ProceduralTextureStage クラスに定義されています。\n以下の図はプロシージャルテクスチャステージで行われる設定の概要を示したものです。\n 図 4-4. プロシージャルテクスチャステージの概要\nProceduralTextureStageクラス RGBマッピング G関数 アルファマッピング アルファ独立モード テクスチャパラメータ クランプ方法 シフト方法 MINフィルタ方式 LODバイアス ノイズ 有効化 パラメータ 参照テーブル F関数（RGB） F関数（アルファ） ノイズ変調関数 カラー参照 参照のオフセット 参照テーブルの幅 SetRgbMap() SetAlphaSeparate() SetAlphaMap() SetClampUV() SetShiftUV() SetMinFilter() SetTexBias() SetNoiseEnable() SetNoiseUV() UploadLookUpTableRgbMap UploadLookUpTableAlphaMap UploadLookUpTableNoiseMap UploadLookUpTableColorMap SetTexOffset() SetTexWidth() UvMap GD_TRUE GD_FALSE Clamp Shift MinFilter LODバイアス値 ノイズのパラメータ カラー参照テーブルのオフセット値 カラー参照テーブルの幅\n",0]
,["Pages/Page_54693545.html#PageId_54693570","4.4.1. プロシージャルテクスチャのパラメータ設定",
"4.4.1. プロシージャルテクスチャのパラメータ設定\nプロシージャルテクスチャの各パラメータに対する設定を行う関数が用意されています。\n コード 4-31. プロシージャルテクスチャのパラメータ設定関数\n class nn::gd::ProceduralTextureStage\n{\n static void SetRgbMap(UvMap rgbMap);\n static void SetAlphaSeparate(gdBool alphaSeparate);\n static void SetAlphaMap(UvMap alphaMap);\n static void SetClampUV(Clamp u, Clamp v);\n static void SetShiftUV(Shift u, Shift v);\n static void SetMinFilter(MinFilter minFilter);\n static void SetTexBias(f32 texBias);\n static void SetNoiseEnable(gdBool noiseEnable);\n static void SetNoiseUV(f32 noiseU[3], f32 noiseV[3]);\n static void SetTexWidth(u8 texWidth);\n static void SetTexOffset(u8 texOffset);\n};\n下表に、それぞれの関数で設定が行われるパラメータを示します。引数の指定方法やパラメータの影響については関数リファレンスなどを参照してください。\n 表 4-12. プロシージャルテクスチャステージの関数で設定が行われるパラメータ\n \t関数 \tパラメータ\n \t SetRgbMap() \tRGB マッピングの G 関数（デフォルト：UV_MAP_U）\n \t SetAlphaSeparate() \tアルファ独立モードの有効化（デフォルト：GD_FALSE）\n \t SetAlphaMap() \tアルファマッピングの G 関数（デフォルト：UV_MAP_U）\n \t SetClampUV() \tクランプモード（デフォルト：CLAMP_TO_ZERO）\n \t SetShiftUV() \tシフトモード（デフォルト：SHIFT_NONE）\n \t SetMinFilter() \t縮小時のフィルタモード（デフォルト：MIN_FILTER_LINEAR）\n \t SetTexBias() \tLOD バイアス（デフォルト：0.5）\n \t SetNoiseEnable() \tノイズの有効化（デフォルト：GD_FALSE）\n \t SetNoiseUV() \tノイズのパラメータ（デフォルト：U, V ともに F=0.0, P=0.0, A=0.0）\n \t SetTexWidth() \tカラー参照テーブルの幅（デフォルト：0）\n \t SetTexOffset() \tカラー参照テーブルのオフセット（デフォルト：0）\n 補足：\n SetTexBias() と SetNoiseUV() では、引数で渡された値を関数内で GPU のレジスタに設定する際のフォーマットに変換しています。\n",0]
,["Pages/Page_54693545.html#PageId_54693571","4.4.2. プロシージャルテクスチャステージで使用する参照テーブルのロード",
"4.4.2. プロシージャルテクスチャステージで使用する参照テーブルのロード\nF 関数（RGB マッピング、アルファマッピング）やノイズ変調データ、カラー参照テーブルといった、プロシージャルテクスチャで使用する参照テーブルをロードする関数には、浮動小数点数の配列で指定するもの（～Float()）と、GPU のレジスタにそのまま書き込むデータの配列で指定するもの（～Native()）が用意されています。なお、参照テーブルのロード関数はイミディエート関数ですので、実行時に 3D コマンドバッファにデータが書き込まれます。\n コード 4-32. プロシージャルテクスチャステージで使用する参照テーブルのロード関数\n class nn::gd::ProceduralTextureStage\n{\n static nnResult UploadLookUpTableRgbMapFloat(\n u32 index, f32* Map, f32* MapDelta, u32 lutSize);\n static nnResult UploadLookUpTableRgbMapNative(\n u32 index, u32* Map, u32 lutSize);\n static nnResult UploadLookUpTableAlphaMapFloat(\n u32 index, f32* Map, f32* MapDelta, u32 lutSize);\n static nnResult UploadLookUpTableAlphaMapNative(\n u32 index, u32* Map, u32 lutSize);\n static nnResult UploadLookUpTableNoiseMapFloat(\n u32 index, f32* Map, f32* MapDelta, u32 lutSize);\n static nnResult UploadLookUpTableNoiseMapNative(\n u32 index, u32* Map, u32 lutSize);\n static nnResult UploadLookUpTableColorMapFloat(\n u32 index, f32** Map, f32** MapDelta, u32 lutSize);\n static nnResult UploadLookUpTableColorMapNative(\n u32 index, u32* Map, u32* MapDelta, u32 lutSize);\n};\n index と lutSize の指定によって、参照テーブルを部分的に書き換えることができます。ただし、その合計が下表で示されている要素の最大値を超えるような指定ではエラーが発生します。\n浮動小数点数の配列で参照テーブルをロードする場合、データ（Map）と差分値（MapDelta）の 2 つの配列を用意する必要があります。ただし、カラー参照テーブルをロードする場合は 4 つのカラー成分それぞれで用意するため、8 つの配列が必要です。\nネイティブフォーマットに変換された配列で参照テーブルをロードする場合、カラー参照テーブル以外はデータと差分値が 1 つの要素にまとめられているため、用意する配列は 1 つだけです。\n下表は、ロードする参照テーブル、配列のフォーマット、配列の要素の最大値を関数ごとに示したものです。\n 表 4-13. プロシージャルテクスチャステージで使用する参照テーブルのロード関数の一覧\n \t関数 \t参照テーブル \tフォーマット \t要素数の最大値\n \t UploadLookUpTableRgbMapFloat() \tRGB マッピング \t浮動小数点数 \t128\n \t UploadLookUpTableRgbMapNative() \tRGB マッピング \tネイティブ \t128\n \t UploadLookUpTableAlphaMapFloat() \tアルファマッピング \t浮動小数点数 \t128\n \t UploadLookUpTableAlphaMapNative() \tアルファマッピング \tネイティブ \t128\n \t UploadLookUpTableNoiseMapFloat() \tノイズ変調テーブル \t浮動小数点数 \t128\n \t UploadLookUpTableNoiseMapNative() \tノイズ変調テーブル \tネイティブ \t128\n \t UploadLookUpTableColorMapFloat() \tカラー参照テーブル \t浮動小数点数 \t256\n \t UploadLookUpTableColorMapNative() \tカラー参照テーブル \tネイティブ \t256\n ",0]
,["Pages/Page_54693545.html#PageId_54693572","4.4.2.1. 参照テーブルのロードのヘルパー関数",
"4.4.2.1. 参照テーブルのロードのヘルパー関数\n浮動小数点数の配列をネイティブフォーマットに変換するヘルパー関数が用意されています。浮動小数点数の配列から参照テーブルをロードする関数は、内部でネイティブへのフォーマット変換が行われるために負荷が高く、ランタイムでの実行には向いていません。そのため、あらかじめネイティブフォーマットに変換されたデータを用意するか、初回ロード時にヘルパー関数でフォーマット変換を行っておくなどの実装を推奨します。\n コード 4-33. 参照テーブルのロードのヘルパー関数\n class nn::gd::ProceduralTextureStage::Helper\n{\n static nnResult ConvertLookUpTableDataFloatToNative(\n f32* valueData, f32* deltaData, u32 lutSize, u32* destination);\n static nnResult ConvertColorLookUpTableDataFloatToNative(\n f32** refArray, f32** deltaArray, u32 lutSize,\n u32* destRef, u32* destDelta);\n};\nカラー参照テーブル以外は、データと差分値の組み合わせから 1 つのデータ（destination）が生成されます。生成されるデータは、ビット [23 : 12] が差分値を小数部 11 ビットの符号つき 12 ビット固定小数点数（負の値は 2 の補数表現）に変換した値、ビット [11 : 0] がデータを小数部 12 ビットの符号なし 12 ビット固定小数点数に変換した値です。\nカラー参照テーブルは、RGBA 各成分のデータと差分値の組み合わせ（合計 8 つの配列）から 1 つのカラー値と差分値の組み合わせ（destRef と destDelta）が生成されます。生成されるカラー値、差分値ともに、各成分を変換した値がアルファ成分、青成分、緑成分、赤成分の順に上位ビットから 8 ビットずつ配置されていますが、値の変換方法が異なります。カラー値は 0.0 ～ 1.0 の範囲を 0 ～ 255 にマップしたときの符号なし 8 ビット整数に、差分値は -1.0 ～ 1.0 の範囲を小数部 7 ビットの符号つき 8 ビット固定小数点数（負の値は 2 の補数表現）に、それぞれ変換しています。\n 補足：\n 変換方法の詳細は「3DS プログラミングマニュアル - グラフィックス応用編」を参照してください。\n また、GD ライブラリには変換のためのユーティリティ関数が用意されています。\n",0]
,["Pages/Page_54693545.html#PageId_54693573","4.5. ライティングステージ",
"4.5. ライティングステージ\nライティングステージでは、グローバルライティング環境の設定と個別のライト設定を行います。これらの設定を行う関数は nn::gd::LightingStage クラスに定義されています。なお、ライティング環境の有効/無効をアプリケーションで設定する必要はありません。ライティングの設定はライブラリで管理されており、コンバイナ設定でライティングの結果が必要な場合にだけライティング環境が有効となるように実装されています。\n以下の図はライティングステージで行われる設定の概要（個別のライトを除く）を示したものです。\n 図 4-5. ライティングステージの概要（個別のライトを除く）\nLightingStageクラス グローバル設定 環境光 鏡面光のクランプ フレネルファクタ シャドウ 使用するテクスチャユニット シャドウ減衰（プライマリ） シャドウ減衰（セカンダリ） シャドウ減衰（アルファ成分） 反転 バンプマッピング バンプモード 参照テーブル レイヤコンフィグレーション D0/D1/SP/FR/RB/RG/RR 入力値の種類 入力値の絶対値化 出力値のスケール D0の有効化 D1の有効化 反射（RR/RG/RB）の有効化 SetGlobalColorAmbient() SetClampHighlight() SetFresnelSelector() SetShadowSelectorTexture() SetShadowPrimary() SetShadowSecondary() SetShadowAlpha() SetInvertShadow() SetBumpMode() SetBumpSelectorTexture() SetLayerConfiguration() UploadLookUpTable SetLookUpTableInputValue() SetLookUpTableAbsInput() SetLookUpTableOutputScaling() EnableLookUpTableD0() EnableLookUpTableD1() EnableLookUpTableReflection() カラー値 GD_TRUE GD_FALSE TextureStage::TextureUnitId BumpMode LayerConfiguration LookUpTableInputValue LookUpTableOutputScaleValue\n",0]
,["Pages/Page_54693545.html#PageId_54693574","4.5.1. グローバルライティング環境の設定",
"4.5.1. グローバルライティング環境の設定\nグローバルライティング環境の各パラメータに対する設定を行う関数が用意されています。\n コード 4-34. グローバルライティング環境のパラメータ設定関数\n class nn::gd::LightingStage\n{\n static void SetGlobalColorAmbient(u8 R, u8 G, u8 B);\n static void SetClampHightlight(gdBool value);\n static void SetFresnelSelector(FresnelSelectorType fresnelSelectorType);\n static void SetShadowSelectorTexture(\n nn::gd::TextureStage::TextureUnitId textureUnit);\n static void SetShadowPrimary(gdBool value);\n static void SetShadowSecondary(gdBool value);\n static void SetShadowAlpha(gdBool value);\n static void SetInvertShadow(gdBool value);\n static void SetBumpMode(BumpMode bumpMode, gdBool bumpRenorm);\n static void SetBumpSelectorTexture(\n nn::gd::TextureStage::TextureUnitId textureUnit);\n};\n下表に、それぞれの関数で設定が行われるパラメータを示します。引数の指定方法やパラメータの影響については関数リファレンスなどを参照してください。\n 表 4-14. ライティングステージの関数で設定が行われるパラメータ\n \t関数 \tパラメータ\n \t SetGlobalColorAmbient() \tグローバル環境光の光源色（デフォルト：（10, 10, 10））\n \t SetClampHightlight() \t鏡面光のクランプ（デフォルト：GD_TRUE）\n \t SetFresnelSelector() \tフレネルファクタ（デフォルト：FRESNEL_SELECTOR_TYPE_NO_FRESNEL）\n \t SetShadowSelectorTexture() \tシャドウで使用するテクスチャユニット（デフォルト：TEXTURE_UNIT_0）\n \t SetShadowPrimary() \tプライマリカラーへのシャドウの影響（デフォルト：GD_FALSE）\n \t SetShadowSecondary() \tセカンダリカラーへのシャドウの影響（デフォルト：GD_FALSE）\n \t SetShadowAlpha() \tアルファ成分へのシャドウの影響（デフォルト：GD_FALSE）\n \t SetInvertShadow() \tシャドウ項の反転（デフォルト：GD_FALSE）\n \t SetBumpMode() \tバンプマッピングの摂動モードと法線の第 3 成分の再生成（デフォルト：BUMPMODE_NOT_USED, GD_FALSE）\n \t SetBumpSelectorTexture() \tバンプマッピングで使用するテクスチャユニット（デフォルト：TEXTURE_UNIT_0）\n 補足：\n SetGlobalColorAmbient() はイミディエート関数です。\n",0]
,["Pages/Page_54693545.html#PageId_54693575","4.5.2. レイヤコンフィグレーションと参照テーブルの設定",
"4.5.2. レイヤコンフィグレーションと参照テーブルの設定\nライティングで使用される参照テーブルを決定するレイヤコンフィグレーション、参照テーブルへの入力値、参照テーブルからの出力値のスケーリング、ディストリビューションファクタ、反射を設定する関数が用意されています。\n コード 4-35. 参照テーブルに関係するパラメータの設定関数\n class nn::gd::LightingStage\n{\n static void SetLayerConfiguration(LayerConfiguration layerConfiguration);\n static void SetLookUpTableInputValue(\n LookUpTableId lutId, LookUpTableInputValue lutInputValue);\n static void SetLookUpTableAbsInput(LookUpTableId lutId, gdBool value);\n static void SetLookUpTableOutputScaling(\n LookUpTableId lutId, LookUpTableOutputScaleValue outputScalingValue);\n static void EnableLookUpTableD0(gdBool value);\n static void EnableLookUpTableD1(gdBool value);\n static void EnableLookUpTableReflection(gdBool value);\n};\n下表に、それぞれの関数で設定が行われるパラメータを示します。引数の指定方法やパラメータの影響については関数リファレンスなどを参照してください。\n 表 4-15. ライティングステージの関数で設定が行われる参照テーブルに関するパラメータ\n \t関数 \tパラメータ\n \t SetLayerConfiguration() \tレイヤコンフィグレーション（デフォルト：LAYER_CONFIGURATION_0）\n \t SetLookUpTableInputValue() \t参照テーブルへの入力値（デフォルト：参照テーブルすべて INPUT_VALUE_NH）\n \t SetLookUpTableAbsInput() \t参照テーブルへの入力値の絶対値化（デフォルト：参照テーブルすべて GD_FALSE）\n \t SetLookUpTableOutputScaling() \t参照テーブルからの出力値のスケーリング（デフォルト：参照テーブルすべて OUTPUT_SCALE_VALUE_1）\n \t EnableLookUpTableD0() \tディストリビューションファクタ 0 への参照テーブルの適用（デフォルト：GD_FALSE）\n \t EnableLookUpTableD1() \tディストリビューションファクタ 1 への参照テーブルの適用（デフォルト：GD_FALSE）\n \t EnableLookUpTableReflection() \t反射への参照テーブルの適用（デフォルト：GD_FALSE）\n",0]
,["Pages/Page_54693545.html#PageId_54693576","4.5.3. ライティングステージで使用する参照テーブルのロード",
"4.5.3. ライティングステージで使用する参照テーブルのロード\nライティングで使用する参照テーブルをロードする関数には、浮動小数点数の配列で指定するもの（UploadLookUpTableFloat()）と、GPU のレジスタにそのまま書き込むデータの配列で指定するもの（UploadLookUpTableNative()）が用意されています。なお、参照テーブルのロード関数はイミディエート関数ですので、実行時に 3D コマンドバッファにデータが書き込まれます。\n コード 4-36. ライティングステージで使用する参照テーブルのロード関数\n class nn::gd::LightingStage\n{\n static nnResult UploadLookUpTableFloat(\n LookUpTableUploadId lutID, u32 lutStartIndex,\n const f32* valueData, const f32* deltaData, u32 dataCount);\n static nnResult UploadLookUpTableNative(\n LookUpTableUploadId lutID, u32 lutStartIndex,\n const u32* data, u32 dataCount);\n class Helper\n {\n static nnResult ConvertLookUpTableDataFloatToNative(\n const f32* valueData, const f32* deltaData, u32 dataCount,\n u32* __restrict destination);\n };\n};\nライティングで使用する参照テーブルの要素数は 256 固定です。lutStartIndex と dataCount の指定によって、参照テーブルを部分的に書き換えることができますが、その合計が 256 を超えるような指定ではエラーが発生します。\nなお、参照テーブルへの入力値が絶対値化されるかどうかによって、参照テーブルの構成が異なります。絶対値化しない（入力値の範囲が -1.0～1.0）場合は、参照テーブルの 128 番目と 129 番目の要素に対応する入力値が不連続になる（0.9922 から -1.0 にジャンプする）ことに注意してください。\n浮動小数点数の配列で参照テーブルをロードする場合、データ（valueData）と差分値（deltaData）の 2 つの配列を用意する必要があります。\nネイティブフォーマットに変換された配列で参照テーブルをロードする場合、参照テーブルにロードするデータはデータと差分値が 1 つの要素にまとめられているため、用意する配列は 1 つだけです。\n浮動小数点数の配列をネイティブフォーマットに変換するヘルパー関数が用意されています。ヘルパー関数では、データと差分値の組み合わせから 1 つのデータ（destination）を生成します。生成されるデータは、ビット [23 : 12] が差分値を小数部 11 ビットの符号つき 12 ビット固定小数点数（小数部は絶対値）に変換した値、ビット [11 : 0] がデータを小数部 12 ビットの符号なし 12 ビット固定小数点数に変換した値です。\n 補足：\n 変換方法の詳細は「3DS プログラミングマニュアル - グラフィックス応用編」を参照してください。\n また、GD ライブラリには変換のためのユーティリティ関数が用意されています。\n",0]
,["Pages/Page_54693545.html#PageId_54693577","4.5.4. ライト",
"4.5.4. ライト\n3DS のハードウェアは 8 個のライトによるライティングに対応しています。GD ライブラリでは、個々のライトを nn::gd::Light クラスの個別のインスタンスとして表現し、nn::gd::LightingStage クラスに内包するようにして 8 個分の Light オブジェクトがライブラリの初期化時に作成されます。そのため、アプリケーションで Light オブジェクトを作成する必要はなく、nn::gd::LightingStage::light[0].EnableLight(GD_TRUE) のように、ライティングステージに定義されたメンバとしてアクセスします。\n以下の図は Light オブジェクトで行われる設定の概要を示したものです。\n 図 4-6. Light オブジェクトの概要\nLightクラス 設定 ライトの有効化 ライトの種類 両面ライティング シャドウ減衰 ジオメトリファクタ0の有効化 ジオメトリファクタ1の有効化 光源色 環境光 拡散光 鏡面光0 鏡面光1 位置/方向 光源の位置 光源の方向 スポットライト/距離減衰 SP/DA スポットライト（SP）の有効化 スポットライトの方向 距離減衰（DA）の有効化 距離減衰のスケール、バイアス EnableLight() SetLightType() EnableToSideDiffuse() EnableShadowed() EnableGeomFactor0() EnableGeomFactor1() SetColorAmbient() SetColorDiffuse() SetColorSpecular0() SetColorSpecular1() SetPosition() SetDirection() UploadLookUpTable EnableSpotLight() SetSpotDirection() EnableDistanceAttenuation() SetDistanceAttenuationScaleBias() GD_TRUE GD_FALSE SourceType カラー値 座標値 方向ベクトル 参照テーブル スケール、バイアス\n",0]
,["Pages/Page_54693545.html#PageId_54693578","4.5.4.1. ライトの設定",
"4.5.4.1. ライトの設定\nライトの各パラメータに対する設定を行う関数が用意されています。\n コード 4-37. ライトのパラメータ設定関数\n class nn::gd::Light\n{\n void EnableLight(gdBool value);\n void SetLightType(SourceType sourceType);\n void EnableTwoSideDiffuse(gdBool value);\n void EnableShadowed(gdBool value);\n void EnableGeomFactor0(gdBool value);\n void EnableGeomFactor1(gdBool value);\n void SetColorAmbient(u8 R, u8 G, u8 B);\n void SetColorDiffuse(u8 R, u8 G, u8 B);\n void SetColorSpecular0(u8 R, u8 G, u8 B);\n void SetColorSpecular1(u8 R, u8 G, u8 B);\n void SetPosition(f32 X, f32 Y, f32 Z);\n void SetDirection(f32 X, f32 Y, f32 Z);\n void EnableSpotLight(gdBool value);\n void SetSpotDirection(f32 X, f32 Y, f32 Z);\n void EnableDistanceAttenuation(gdBool value);\n void SetDistanceAttenuationScaleBias(\n f32 attenuationScale, f32 attenuationBias);\n nnResult UploadLookUpTableFloat(\n LightLookUpTableUploadId lightLutID, u32 lutStartIndex,\n const f32* valueData, const f32* deltaData, u32 dataCount);\n nnResult UploadLookUpTableNative(\n LightLookUpTableUploadId lightLutID, u32 lutStartIndex,\n const u32* data, u32 dataCount);\n};\n下表に、それぞれの関数で設定が行われるパラメータを示します。引数の指定方法やパラメータの影響については関数リファレンスなどを参照してください。\n 表 4-16. Light オブジェクトの関数で設定が行われるパラメータ\n \t関数 \tパラメータ\n \t EnableLight() \tライトの有効化（デフォルト：GD_FALSE）\n \t SetLightType() \t光源の種類（デフォルト：SOURCE_TYPE_POINT（点光源））\n \t EnableTwoSideDiffuse() \t両面ライティングの有効化（デフォルト：GD_FALSE）\n \t EnableShadowed() \tシャドウ減衰の有効化（デフォルト：GD_FALSE）\n \t EnableGeomFactor0() \tジオメトリファクタ 0 の有効化（デフォルト：GD_FALSE）\n \t EnableGeomFactor1() \tジオメトリファクタ 1 の有効化（デフォルト：GD_FALSE）\n \t SetColorAmbient() \t環境光の色（デフォルト：（0, 0, 0））\n \t SetColorDiffuse() \t拡散光の色（デフォルト：（255, 255, 255））\n \t SetColorSpecular0() \t鏡面光 0 の色（デフォルト：（255, 255, 255））\n \t SetColorSpecular1() \t鏡面光 1 の色（デフォルト：（255, 255, 255））\n \t SetPosition() \t点光源の位置（デフォルト：（0.0, 0.0, 0.0））\n \t SetDirection() \t平行光源の方向（デフォルト設定なし）\n \t EnableSpotLight() \tスポットライトの有効化（デフォルト：GD_FALSE）\n \t SetSpotDirection() \tスポットライトの方向（デフォルト：（0.0, 0.0, 0.0））\n \t EnableDistanceAttenuation() \t距離減衰の有効化（デフォルト：GD_FALSE）\n \t SetDistanceAttenuationScaleBias() \t 距離減衰のスケールとバイアス（デフォルト：0.0, 0.0）\n 開始距離と終了距離から設定値を求めるユーティリティ関数（Utils::ConvertStartEndToScaleBias()）が用意されています。\n 参照テーブルの指定を除いて、参照テーブルのロード方法はライティングステージでの参照テーブルのロード方法と同じです。なお、距離減衰（DA）で使用する参照テーブルは入力値の範囲が 0.0～1.0 であることを想定して作成されていなければなりません。\n 補足：\n ライトの設定を行う関数は、EnableLight()、EnableShadowed()、EnableSpotLight()、EnableDistanceAttenuation() を除いて、すべてイミディエート関数です。\n",0]
,["Pages/Page_54693545.html#PageId_54693579","4.6. ラスタライザステージ",
"4.6. ラスタライザステージ\nラスタライザステージでは、フラグメントパイプラインに出力されるピクセルのラスタライズ処理の設定を行います。これらの設定を行う関数は nn::gd::RasterizerStage クラスに定義されています。\n以下の図はラスタライザステージで行われる設定の概要を示したものです。\n 図 4-7. ラスタライザステージの概要\nRasterizerStageクラス カリング カリングモード ビューポート クリッピング 有効化 クリッピング面 シザーテスト シザーボックス アーリーデプステスト 設定 バッファのクリア SetCulling() SetViewport() EnableClippingPlane() SetClippingPlane() EnableScissor() SetScissor() SetEarlyDepthTest() ClearEarlyDepth() Culling Viewportクラス GD_TRUE GD_FALSE クリッピング面のパラメータ EarlyDepthFunction クリアに使用するデプス値\n",0]
,["Pages/Page_54693545.html#PageId_54693580","4.6.1. カリングの設定",
"4.6.1. カリングの設定\nカリングの設定は nn::gd::RasterizerStage::SetCulling() で行います。\n コード 4-38. カリングの設定関数\n static void nn::gd::RasterizerStage::SetCulling(\n nn::gd::RasterizerStage::Culling culling);\n culling にカリングの方法を指定します。デフォルトでは時計回り（CULLING_CLOCKWISE）が指定されています。\n",0]
,["Pages/Page_54693545.html#PageId_54693581","4.6.2. ビューポートの設定",
"4.6.2. ビューポートの設定\nビューポートの設定は nn::gd::RasterizerStage::SetViewport() で行います。\n コード 4-39. ビューポートの設定関数\n class nn::gd::Viewport\n{\n u32 m_X;\n u32 m_Y;\n u32 m_Width;\n u32 m_Height;\n Viewport();\n Viewport(u32 x, u32 y, u32 width, u32 height);\n void Set(u32 x, u32 y, u32 width, u32 height);\n};\nstatic void nn::gd::RasterizerStage::SetViewport(\n nn::gd::Viewport& viewport);\nビューポートの領域は nn::gd::Viewport クラスで定義します。ビューポートの方向は LCD の配置方向と異なることに注意してください。デフォルトでは Viewport(0, 0, 240, 320) が設定されています。\n",0]
,["Pages/Page_54693545.html#PageId_54693582","4.6.3. クリッピングの設定",
"4.6.3. クリッピングの設定\nクリッピングの設定は以下の関数で行います。\n コード 4-40. クリッピングの設定関数\n static void nn::gd::RasterizerStage::EnableClippingPlane(gdBool value);\nstatic void nn::gd::RasterizerStage::SetClippingPlane(\n f32 param1, f32 param2, f32 param3, f32 param4);\nデフォルトではクリッピングは無効（GD_FALSE）で、パラメータはすべて 0 に設定されています。\n",0]
,["Pages/Page_54693545.html#PageId_54693583","4.6.4. シザーテストの設定",
"4.6.4. シザーテストの設定\nシザーテストの設定は以下の関数で行います。\n コード 4-41. シザーテストの設定関数\n static void nn::gd::RasterizerStage::EnableScissor(gdBool value);\nstatic void nn::gd::RasterizerStage::SetScissor(\n nn::gd::Viewport& area);\nデフォルトではシザーテストは無効（GD_FALSE）で、シザーボックスには Viewport(0, 0, 0, 0) が設定されています。\n",0]
,["Pages/Page_54693545.html#PageId_54693584","4.6.5. アーリーデプステストの設定",
"4.6.5. アーリーデプステストの設定\nアーリーデプステストの設定は以下の関数で行います。\n コード 4-42. アーリーデプステストの設定関数\n static void nn::gd::RasterizerStage::SetEarlyDepthTest(\n gdBool enable, nn::gd::RasterizerStage::EarlyDepthFunction func);\nstatic void nn::gd::RasterizerStage::ClearEarlyDepth(f32 depthClearValue);\nデフォルトではアーリーデプステストは無効（GD_FALSE, EARLYDEPTH_FUNCTION_LESS）で、クリアに使用するデプス値には 1.0 が設定されています。\nアーリーデプステストを使用する場合は、ブロックモードがブロック 32 モードに設定されていなければなりません。詳しくは「3DS プログラミングマニュアル - グラフィックス応用編」の「ブロックモードの設定」を参照してください。\n",0]
,["Pages/Page_54693545.html#PageId_54693585","4.7. コンバイナステージ",
"4.7. コンバイナステージ\nコンバイナステージでは、（テクスチャ）コンバイナとコンバイナバッファの設定を行います。これらの設定を行う関数は nn::gd::CombinerStage クラスに定義されています。\n以下の図はコンバイナステージで行われる設定の概要を示したものです。\n 図 4-8. コンバイナステージの概要\nCombinerStageクラス 定数カラー（ユニット0～5） ステートオブジェクト（コンバイナ設定） SetTextureCombinerUnitConstantColor() SetTextureCombinerState() CreateTextureCombinerState() カラー値 CombinerStateオブジェクト CombinerDescriptionクラス\n",0]
,["Pages/Page_54693545.html#PageId_54693586","4.7.1. コンバイナ設定",
"4.7.1. コンバイナ設定\nコンバイナステージでは、すべてのコンバイナとコンバイナバッファの設定をひとまとめにしたステートオブジェクト（CombinerState オブジェクト）を作成し、CombinerState オブジェクトを切り替えることで定数カラー以外のコンバイナに関する設定を一括で変更することができます。\n CombinerState オブジェクトはオペランドなどの設定が定義されたデスクリプタクラス（CombinerDescription）から作成します。\n コード 4-43. コンバイナ設定の作成、解放、パイプラインへの設定\n static nnResult nn::gd::CombinerStage::CreateTextureCombinerState(\n const nn::gd::CombinerDescription* description,\n nn::gd::CombinerState** textureCombinerState);\nstatic nnResult nn::gd::CombinerStage::ReleaseTextureCombinerState(\n nn::gd::CombinerState* textureCombinerState);\nstatic nnResult nn::gd::CombinerStage::SetTextureCombinerState(\n nn::gd::CombinerState* textureCombinerState);\nコンバイナへの設定は description に指定するデスクリプタクラス（CombinerDescription）にあらかじめ設定します。デスクリプタクラスに設定する情報の詳細は後述します。\n作成された CombinerState オブジェクトは nn::gd::CombinerStage::SetTextureCombinerState() でコンバイナステージに設定することができます。\n不要になったステートオブジェクトは nn::gd::CombinerStage::ReleaseTextureCombinerState() で解放してください。このとき、オブジェクトが作成されたときに内部で確保されたメモリ領域も解放されます。\nコンバイナへの設定のうち、定数カラーの設定だけは以下の関数で行います。デフォルトの定数カラーは不定値ですので、コンバイナ設定で定数カラーを使用する場合は必ず設定を行ってください。\n コード 4-44. 定数カラーの設定\n static nnResult nn::gd::CombinerStage::SetTextureCombinerUnitConstantColor(\n nn::gd::CombinerStage::UnitId unit,\n u8 colorR, u8 colorG, u8 colorB, u8 colorA);\nこの関数はイミディエート関数ですので、実行と同時にコマンドバッファへの 3D コマンドの蓄積を行います。\n",0]
,["Pages/Page_54693545.html#PageId_54693587","4.7.1.1. CombinerState オブジェクトのデスクリプタクラス",
"4.7.1.1. CombinerState オブジェクトのデスクリプタクラス\n CombinerState オブジェクトのデスクリプタクラス（CombinerDescription クラス）のメンバを紹介し、設定に際しての注意点などを説明します。\n CombinerDescription クラスは 6 つのコンバイナユニットの設定を内包しています。必ずしもすべてのユニットに対して設定を行うことがないため、ユニットを指定してメンバ変数への設定を行うメンバ関数を呼び出すように設計されています。\n コード 4-45. CombinerDescription クラスの定義\n class nn::gd::CombinerDescription\n{\n struct BufferInput\n {\n nn::gd::CombinerStage::BufferInput m_Rgb1;\n nn::gd::CombinerStage::BufferInput m_Rgb2;\n nn::gd::CombinerStage::BufferInput m_Rgb3;\n nn::gd::CombinerStage::BufferInput m_Rgb4;\n nn::gd::CombinerStage::BufferInput m_Alpha1;\n nn::gd::CombinerStage::BufferInput m_Alpha2;\n nn::gd::CombinerStage::BufferInput m_Alpha3;\n nn::gd::CombinerStage::BufferInput m_Alpha4;\n };\n struct BufferInput m_BufferInput;\n void SetSourceRGB(\n nn::gd::CombinerStage::UnitId unit,\n nn::gd::CombinerStage::Source sourceRGB1,\n nn::gd::CombinerStage::Source sourceRGB2,\n nn::gd::CombinerStage::Source sourceRGB3);\n void SetOperandRGB(\n nn::gd::CombinerStage::UnitId unit,\n nn::gd::CombinerStage::OperandRgb opRGB1,\n nn::gd::CombinerStage::OperandRgb opRGB2,\n nn::gd::CombinerStage::OperandRgb opRGB3);\n void SetSourceAlpha(\n nn::gd::CombinerStage::UnitId unit,\n nn::gd::CombinerStage::Source sourceA1,\n nn::gd::CombinerStage::Source sourceA2,\n nn::gd::CombinerStage::Source sourceA3);\n void SetOperandAlpha(\n nn::gd::CombinerStage::UnitId unit,\n nn::gd::CombinerStage::OperandAlpha opA1,\n nn::gd::CombinerStage::OperandAlpha opA2,\n nn::gd::CombinerStage::OperandAlpha opA3);\n void SetCombineRGB(\n nn::gd::CombinerStage::UnitId unit,\n nn::gd::CombinerStage::CombineRgb combineRgb);\n void SetCombineAlpha(\n nn::gd::CombinerStage::UnitId unit,\n nn::gd::CombinerStage::CombineAlpha combineAlpha);\n void SetScaleRGB(\n nn::gd::CombinerStage::UnitId unit,\n nn::gd::CombinerStage::Scale scaleRgb);\n void SetScaleAlpha(\n nn::gd::CombinerStage::UnitId unit,\n nn::gd::CombinerStage::Scale scaleAlpha);\n void SetBufferColor(u8 colorR, u8 colorG, u8 colorB, u8 colorA);\n void SetCombinerInUse(nn::gd::CombinerStage::UnitId unit, gdBool mode);\n CombinerDescription();\n void ToDefault();\n};\n",0]
,["Pages/Page_54693545.html#Anchor_54693587_入力ソースの設定（SetSourceRGB()、SetSourceAlpha()）","入力ソースの設定（SetSourceRGB()、SetSourceAlpha()）",
"入力ソースの設定（SetSourceRGB()、SetSourceAlpha()）\n指定されたコンバイナユニットの入力ソース 0～2 を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693587_オペランドの設定（SetOperandRGB()、SetOperandAlpha()）","オペランドの設定（SetOperandRGB()、SetOperandAlpha()）",
"オペランドの設定（SetOperandRGB()、SetOperandAlpha()）\n指定されたコンバイナユニットのオペランド 0～2 を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693587_コンバイナ関数の設定（SetCombineRGB()、SetCombineAlpha()）","コンバイナ関数の設定（SetCombineRGB()、SetCombineAlpha()）",
"コンバイナ関数の設定（SetCombineRGB()、SetCombineAlpha()）\n指定されたコンバイナユニットのコンバイナ関数を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693587_スケーリング値の設定（SetScaleRGB()、SetScaleAlpha()）","スケーリング値の設定（SetScaleRGB()、SetScaleAlpha()）",
"スケーリング値の設定（SetScaleRGB()、SetScaleAlpha()）\n指定されたコンバイナユニットのスケーリング値を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693587_コンバイナバッファ0の定数カラーの設定（SetBufferColor()）","コンバイナバッファ 0 の定数カラーの設定（SetBufferColor()）",
"コンバイナバッファ 0 の定数カラーの設定（SetBufferColor()）\nコンバイナバッファ 0 の定数カラーを設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693587_コンバイナバッファの入力ソース（m_BufferInput）","コンバイナバッファの入力ソース（m_BufferInput）",
"コンバイナバッファの入力ソース（m_BufferInput）\nコンバイナバッファ 1～4 の入力ソースを設定します。設定用の関数は用意されていません。\n",0]
,["Pages/Page_54693545.html#Anchor_54693587_コンバイナユニットの使用設定（SetCombinerInUse()）","コンバイナユニットの使用設定（SetCombinerInUse()）",
"コンバイナユニットの使用設定（SetCombinerInUse()）\n指定されたコンバイナユニットの設定内容を有効（GD_TRUE）または無効（GD_FALSE）に設定します。設定内容を有効にしなければ、そのユニットの設定はデフォルトの設定になります。\n",0]
,["Pages/Page_54693545.html#Anchor_54693587_デフォルトの設定（ToDefault()）","デフォルトの設定（ToDefault()）",
"デフォルトの設定（ToDefault()）\n ToDefault() で、すべてのメンバをデフォルトの値に変更することができます。この設定はコンストラクタでも行われています。\n 表 4-17. デフォルトのコンバイナ設定\n \tメンバ \tデフォルトの設定内容\n \t SetSourceRGB()\n SetSourceAlpha()\n \t SOURCE_CONSTANT（ユニット 0 のすべての入力ソース）\n SOURCE_PREVIOUS（ユニット 1～5 のすべての入力ソース）\n \t SetOperandRGB() \t OPERAND_RGB_SRC_COLOR（すべてのオペランド）\n \t SetOperandAlpha() \t OPERAND_ALPHA_SRC_ALPHA（すべてのオペランド）\n \t SetCombineRGB() \t COMBINE_RGB_REPLACE（すべてのユニット）\n \t SetCombineAlpha() \t COMBINE_ALPHA_REPLACE（すべてのユニット）\n \t SetScaleRGB()\n SetScaleAlpha()\n \t SCALE_1（すべてのユニット）\n \t SetBufferColor() \t(0, 0, 0, 0)\n \t m_BufferInput \t INPUT_PREVIOUS_BUFFER（すべての入力）\n \t SetCombinerInUse() \t GD_FALSE（すべてのユニット）\n",0]
,["Pages/Page_54693545.html#PageId_54693588","4.8. フォグステージ",
"4.8. フォグステージ\nフォグステージでは、フォグとガスの描画に関連するすべての設定を行います。これらの設定を行うための関数は nn::gd::FogStage クラスに定義されています。\n以下の図はフォグステージで行われる設定の概要を示したものです。\n 図 4-9. フォグステージの概要\nFogStageクラス モード設定 フォグモード フォグ フォグカラー 入力値の反転 フォグ参照テーブル ガス シェーディング密度情報 密度の減衰 密度の最大値 密度の自動更新 平面シェーディング強度の設定 視線シェーディング強度の設定 デプス方向の減衰 参照テーブルの入力値 シェーディング参照テーブル SetGasFogMode() SetFogColor() setFogZFlip() UploadFogLookUpTable SetGasShadingDensity() SetGasAttenuation() SetGasAccumulationMax() SetGasAutoAccumulation() SetGasLightXY() SetGasLightZ() SetGasDeltaZ() SetGasLightColorLutInput() UploadGasLookUpTable Mode カラー値 GD_TRUE GD_FALSE 参照テーブル GasShadingDensitySource 係数 最大値 最小値 減衰 方向 GasColorLookUpTableInput\n",0]
,["Pages/Page_54693545.html#PageId_54693589","4.8.1. フォグモード",
"4.8.1. フォグモード\nGPU のフォグ機能のモード切り替えは nn::gd::FogStage::SetGasFogMode() で行います。\n コード 4-46. フォグモードの切り替え\n static void nn::gd::FogStage::SetGasFogMode(nn::gd::FogStage::Mode mode);\n mode に指定する値は以下のものから選択します。\n 表 4-18. フォグモードの指定\n \t定義 \t説明\n \t FogStage::MODE_NONE \tフォグ機能を使用しません。（デフォルト）\n \t FogStage::MODE_FOG \tフォグ機能を通常のフォグモードで使用します。\n \t FogStage::MODE_GAS \tフォグ機能をガスモードで使用します。\n",0]
,["Pages/Page_54693545.html#PageId_54693590","4.8.2. フォグの設定",
"4.8.2. フォグの設定\nフォグの各パラメータに対する設定を行う関数が用意されています。\n コード 4-47. フォグのパラメータ設定関数\n class nn::gd::FogStage\n{\n static void SetFogColor(u8 R, u8 G, u8 B);\n static void SetFogZFlip(gdBool zFlip);\n};\n下表に、それぞれの関数で設定が行われるパラメータを示します。引数の指定方法やパラメータの影響については関数リファレンスなどを参照してください。\n 表 4-19. フォグステージの関数で設定が行われるフォグのパラメータ\n \t関数 \tパラメータ\n \t SetFogColor() \tフォグカラー（デフォルト：（0, 0, 0））\n \t SetFogZFlip() \t入力デプス値の反転（デフォルト：GD_FALSE）\n 補足：\n 参照テーブルのロード方法については「4.8.4. フォグステージで使用する参照テーブルのロード」を参照してください。\n",0]
,["Pages/Page_54693545.html#PageId_54693591","4.8.3. ガスの設定",
"4.8.3. ガスの設定\nガスの各パラメータに対する設定を行う関数が用意されています。\n コード 4-48. ガスのパラメータ設定関数\n class nn::gd::FogStage\n{\n static void SetGasShadingDensity(\n GasShadingDensitySource shadingDensitySrc);\n static void SetGasAttenuation(f32 attenuation);\n static void SetGasAccumulationMax(f32 maxAccumulation);\n static void SetGasAutoAccumulation(gdBool enableAutoAccumulation);\n static void SetGasLightXY(\n u8 lightMinimum, u8 lightMaximum, u8 lightAttenuation);\n static void SetGasLightZ(\n u8 scattMinimum, u8 scattMaximum, u8 scattAttenuation, u8 lz);\n static void SetGasDeltaZ(f32 deltaZ);\n static void SetGasLightColorLutInput(\n GasColorLookUpTableInput colorLutInput);\n};\n下表に、それぞれの関数で設定が行われるパラメータを示します。引数の指定方法やパラメータの影響については関数リファレンスなどを参照してください。\n 表 4-20. フォグステージの関数で設定が行われるガスのパラメータ\n \t関数 \tパラメータ\n \t SetGasShadingDensity() \tシェーディングで使用する密度情報（デフォルト：GAS_SHADING_DENSITY_SOURCE_PLAIN）\n \t SetGasAttenuation() \tシェーディングのアルファ値の計算で使用する密度減衰の係数（デフォルト：1.0）\n \t SetGasAccumulationMax() \t密度情報の最大値の逆数（デフォルト：1.0）\n \t SetGasAutoAccumulation() \t密度情報の最大値の逆数を自動的に計算するかどうか（デフォルト：GD_FALSE）\n \t SetGasLightXY() \t平面シェーディングの制御に使用する最小強度、最大強度、密度の減衰（デフォルト：(0, 0, 0)）\n \t SetGasLightZ() \t視線シェーディングの制御に使用する最小強度、最大強度、密度の減衰、視線方向の影響（デフォルト：(0, 0, 0, 0)）\n \t SetGasDeltaZ() \tデプス方向の減衰係数（デフォルト：10.0）\n \t SetGasLightColorLutInput() \tシェーディング参照テーブルへの入力値（デフォルト：GAS_COLOR_INPUT_LIGHT_FACTOR）\n 補足：\n 参照テーブルのロード方法については「4.8.4. フォグステージで使用する参照テーブルのロード」を参照してください。\n",0]
,["Pages/Page_54693545.html#PageId_54693592","4.8.4. フォグステージで使用する参照テーブルのロード",
"4.8.4. フォグステージで使用する参照テーブルのロード\nフォグステージで使用するフォグ係数の参照テーブルとシェーディング参照テーブルをロードする関数には、浮動小数点数の配列で指定するもの（～Float()）と、GPU のレジスタにそのまま書き込むデータの配列で指定するもの（～Native()）が用意されています。なお、参照テーブルのロード関数はイミディエート関数ですので、実行時に 3D コマンドバッファにデータが書き込まれます。\n コード 4-49. フォグステージで使用する参照テーブルのロード関数\n class nn::gd::FogStage\n{\n static nnResult UploadFogLookUpTableNative(\n u32 lutStartIndex, u32* data, u32 countData);\n static nnResult UploadFogLookUpTableFloat(\n u32 lutStartIndex, const f32* dataValue, const f32* dataDelta,\n u32 countData);\n static nnResult UploadGasLookUpTableNative(\n u32 lutStartIndex, u32* data, u32 countData);\n static nnResult UploadGasLookUpTableFloat(\n u32 lutStartIndex, f32* dataValue, f32* dataDelta, u32 countData);\n};\n lutStartindex と countData の指定によって、参照テーブルを部分的に書き換えることができます。ただし、その合計が下表で示されている要素の最大値を超えるような指定ではエラーが発生します。\n浮動小数点数の配列で参照テーブルをロードする場合、データ（dataValue）と差分値（dataDelta）の 2 つの配列を用意する必要があります。ただし、シェーディング参照テーブルは 3 要素（カラー成分を RGB の順番で格納）から 1 つのデータが生成されるため、要素数が（countData * 3）の配列を指定しなければならないことに注意してください。\nネイティブフォーマットに変換された配列で参照テーブルをロードする場合、データと差分値が 1 つの要素にまとめられているため、用意する配列は 1 つだけです。ただし、シェーディング参照テーブルのロードで用意する配列の要素数の最大値が、ネイティブの配列と浮動小数点数の配列とで異なることに注意してください。\n下表は、ロードする参照テーブル、配列のフォーマット、配列の要素の最大値を関数ごとに示したものです。\n 表 4-21. フォグステージで使用する参照テーブルのロード関数の一覧\n \t関数 \t参照テーブル \tフォーマット \t要素数の最大値\n \t UploadFogLookUpTableFloat() \tフォグ係数 \t浮動小数点数 \t128\n \t UploadFogLookUpTableNative() \tフォグ係数 \tネイティブ \t128\n \t UploadGasLookUpTableFloat() \tシェーディング \t浮動小数点数 \t8\n \t UploadGasLookUpTableNative() \tシェーディング \tネイティブ \t16\n ",0]
,["Pages/Page_54693545.html#PageId_54693593","4.8.4.1. 参照テーブルのロードのヘルパー関数",
"4.8.4.1. 参照テーブルのロードのヘルパー関数\n浮動小数点数の配列をネイティブフォーマットに変換するヘルパー関数が用意されています。浮動小数点数の配列から参照テーブルをロードする関数は、内部でネイティブへのフォーマット変換が行われるために負荷が高く、ランタイムでの実行には向いていません。そのため、あらかじめネイティブフォーマットに変換されたデータを用意するか、初回ロード時にヘルパー関数でフォーマット変換を行っておくなどの実装を推奨します。\n コード 4-50. 参照テーブルのロードのヘルパー関数\n class nn::gd::FogStage::Helper\n{\n static nnResult ConvertFogLookUpTableDataFloatToNative(\n const f32* dataValue, const f32* dataDelta, u32 countData,\n u32 *__restrict dest);\n static nnResult ConvertGasLookUpTableDataFloatToNative(\n const f32* dataValue, const f32* dataDelta, u32 countData,\n u32 *__restrict dest);\n};\nフォグステージで用意されているヘルパー関数は、いずれもデータと差分値の組み合わせから 1 つのデータ（dest）を生成します。\nフォグ係数の参照テーブル用に生成されるデータは、ビット [23 : 13] がデータを小数部 11 ビットの符号なし 11 ビット固定小数点数に変換した値、ビット [12 : 0] が差分値を小数部 11 ビットの符号つき 13 ビット固定小数点数（負の値は 2 の補数表現）に変換した値です。\nシェーディング参照テーブル用に生成されるデータは特殊です。特に変換元の配列の 3 要素（R、G、B の順）から 1 つのデータを生成することと、変換後の配列では 1 つのデータの中にデータと差分値が変換されるのではなく、配列の前半 8 つと後半 8 つそれぞれにデータと差分値が変換されることに注意してください。\n前半の 8 つは差分値から生成されます。生成されるデータは、RGB 各成分の差分値を符号つき 8 ビット整数に変換したものを、ビット [23 : 16] に B 成分、ビット [15 : 8] に G 成分、ビット [7 : 0] に R 成分をパッキングしたものです。\n後半の 8 つはデータから生成されます。生成されるデータは、RGB 各成分のデータを小数部 0 ビットの符号なし 8 ビット固定小数点数に変換したものを、ビット [23 : 16] に B 成分、ビット [15 : 8] に G 成分、ビット [7 : 0] に R 成分をパッキングしたものです。\n 補足：\n 変換方法の詳細は「3DS プログラミングマニュアル - グラフィックス応用編」を参照してください。\n また、GD ライブラリには変換のためのユーティリティ関数が用意されています。\n",0]
,["Pages/Page_54693545.html#PageId_54693594","4.9. アウトプットステージ",
"4.9. アウトプットステージ\nアウトプットステージでは、ブレンディングやデプステスト、ステンシルテスト、ターゲットバッファの設定など、ピクセル出力に関するすべての設定を行います。これらの設定を行う関数は nn::gd::OutputStage クラスに定義されています。\n以下の図はアウトプットステージで行われる設定の概要を示したものです。\n 図 4-10. アウトプットステージの概要\nOutputStageクラス フレームバッファ レンダーターゲット デプスステンシルターゲット 書き込みマスク フラグメント オペレーションモード デプスバッファのモード ソフトシャドウの設定 デプステスト、ステンシルテスト ステートオブジェクト（デプスステンシルテスト設定） アルファテスト アルファテストの設定 論理演算、ブレンディング ステートオブジェクト（ブレンディング設定） 定数カラー SetRenderTarget() SetDepthStencilTarget() SetColorWriteMask() SetFragOpMode() SetDepthRangeMode() SetPenumbraScaleBias() SetDepthStencilState() SetAlphaTest() SetBlendState() SetBlendColor() RenderTagetオブジェクト DepthStencilTargetオブジェクト ColorWriteMask FragmentOperationMode DepthBufferType スケール、バイアス DepthStencilStateオブジェクト 比較方法、参照値 BlendStateオブジェクト カラー値\n",0]
,["Pages/Page_54693545.html#PageId_54693595","4.9.1. フラグメントオペレーションモード",
"4.9.1. フラグメントオペレーションモード\nフラグメントオペレーションモードの切り替えは nn::gd::OutputStage::SetFragOpMode() で行います。\n コード 4-51. フラグメントオペレーションモードの設定関数\n static void nn::gd::OutputStage::SetFragOpMode(\n nn::gd::OutputStage::FragmentOperationMode fragOpMode);\n fragOpMode に指定する値は以下のものから選択します。\n 表 4-22. フラグメントオペレーションモード\n \t定義 \t説明\n \t FRAGMENT_OPERATION_MODE_FRAGMENT_COLOR \t標準のフラグメント処理（デフォルト）\n \t FRAGMENT_OPERATION_MODE_GAS_ACCUMULATION \tシャドウ累積パス用のフラグメント処理\n \t FRAGMENT_OPERATION_MODE_SHADOW_MAP \tガスの密度情報描画用のフラグメント処理\n",0]
,["Pages/Page_54693545.html#PageId_54693596","4.9.2. フレームバッファ",
"4.9.2. フレームバッファ\nGD ライブラリでは RenderTarget オブジェクトと DepthStencilTarget オブジェクトでフレームバッファ（カラーバッファとデプスステンシルバッファ）を扱います。どちらのオブジェクトも 1 つの Texture2DResource オブジェクトとそれぞれのデスクリプタクラス（RenderTargetDescription と DepthStencilTargetDescription）から作成されます。なお、デスクリプタクラスの設定によって、Texture2DResource オブジェクトがミップマップデータを含んでいる場合に、オブジェクトの作成にどのレベルのミップマップデータを使用するかを指定することができます。\nフレームバッファオブジェクト（RenderTarget オブジェクトおよび DepthStencilTarget オブジェクト）の作成と解放、パイプラインへの設定は以下の関数で行うことができます。\n コード 4-52. フレームバッファオブジェクトの作成、解放、パイプラインへの設定\n static nnResult nn::gd::OutputStage::CreateRenderTarget(\n const nn::gd::Texture2DResource* texture2DResource,\n const nn::gd::RenderTargetDescription* desc,\n nn::gd::RenderTarget** renderTarget);\nstatic nnResult nn::gd::OutputStage::ReleaseRenderTarget(\n nn::gd::RenderTarget* renderTarget);\nstatic nnResult nn::gd::OutputStage::SetRenderTarget(\n const nn::gd::RenderTarget* renderTarget);\nstatic nnResult nn::gd::OutputStage::CreateDepthStencilTarget(\n const nn::gd::Texture2DResource* texture2DResource,\n const nn::gd::DepthStencilTargetDescription* desc,\n nn::gd::DepthStencilTarget** depthStencil);\nstatic nnResult nn::gd::OutputStage::ReleaseDepthStencilTarget(\n nn::gd::DepthStencilTarget* depthStencil);\nstatic nnResult nn::gd::OutputStage::SetDepthStencilTarget(\n const nn::gd::DepthStencilTarget* depthStencil);\n関数名が～RenderTarget() のものはカラーバッファに対して、～DepthStencilTarget() のものはデプス（ステンシル）バッファに対して処理を行う関数です。\nフレームバッファの設定は desc に指定するそれぞれのデスクリプタクラス（RenderTargetDescription または DepthStencilTargetDescription）にあらかじめ設定します。デスクリプタクラスに設定する情報の詳細は「4.9.2.1. フレームバッファオブジェクトのデスクリプタクラス」を参照してください。\nフレームバッファに使用することのできる Texture2DResource オブジェクトのピクセルフォーマットは制限されています。詳しくは「3.1.1. Texture2DResource オブジェクトの作成」を参照してください。\n作成されたフレームバッファオブジェクトは nn::gd::OutputStage::Set～() でフレームバッファに設定することができます。\n不要になったフレームバッファオブジェクトは nn::gd::OutputStage::Release～() で解放してください。このとき、フレームバッファオブジェクトの管理情報のみが解放されます。Texture2DResource オブジェクトは解放されません。\n",0]
,["Pages/Page_54693545.html#PageId_54693597","4.9.2.1. フレームバッファオブジェクトのデスクリプタクラス",
"4.9.2.1. フレームバッファオブジェクトのデスクリプタクラス\nフレームバッファオブジェクト（RenderTarget オブジェクトと DepthStencilTarget オブジェクト）のデスクリプタクラス（RenderTargetDescription クラスと DepthStencilTargetDescription クラス）のメンバを紹介し、設定に際しての注意点などを説明します。\n コード 4-53. フレームバッファオブジェクトのデスクリプタクラスの定義\n class nn::gd::RenderTargetDescription\n{\n u32 m_MipLevelIndex;\n};\nclass nn::gd::DepthStencilTargetDescription\n{\n u32 m_MipLevelIndex;\n};\n",0]
,["Pages/Page_54693545.html#Anchor_54693597_ミップマップレベルのインデックス（m_MipLevelIndex）","ミップマップレベルのインデックス（m_MipLevelIndex）",
"ミップマップレベルのインデックス（m_MipLevelIndex）\nフレームバッファオブジェクトの作成に使用する Texture2DResource オブジェクトのミップマップレベルです。\n",0]
,["Pages/Page_54693545.html#PageId_54693598","4.9.2.2. フレームバッファオブジェクトの詳細情報の取得",
"4.9.2.2. フレームバッファオブジェクトの詳細情報の取得\n詳細情報（TargetProperties クラス）には、作成時に指定された Texture2DResource オブジェクトの内容を元にしたフレームバッファに関する情報が格納されています。\n詳細情報の取得で使用する関数は RenderTarget オブジェクトと DepthStencilTarget オブジェクトで異なりますが、取得するのは同じ TargetProperties クラスです。\n コード 4-54. フレームバッファオブジェクトの詳細情報の取得\n static nnResult nn::gd::OutputStage::GetRenderTargetProperties(\n const nn::gd::RenderTarget* renderTarget,\n nn::gd::TargetProperties* properties);\nstatic nnResult nn::gd::OutputStage::GetDepthStencilTargetProperties(\n const nn::gd::DepthStencilTarget* depthStencil,\n nn::gd::TargetProperties* properties);\nオブジェクトの作成時に指定したミップマップレベルによって、幅や高さ、ミップマップレベル、リソースデータの先頭アドレスが変化することはありますが、基本的に Texture2DResource オブジェクトの詳細情報と同じです。\n コード 4-55. TargetProperties クラスの定義\n class nn::gd::TargetProperties\n{\n u32 m_Width;\n u32 m_Height;\n u32 m_PixelSize;\n nn::gd::Resource::NativeFormat m_Format;\n nn::gd::Memory::MemoryLayout m_MemLayout;\n nn::gd::Memory::MemoryLocation m_MemLocation;\n u8* m_MemAddr;\n};\n",0]
,["Pages/Page_54693545.html#PageId_54693599","4.9.2.3. フレームバッファのクリア",
"4.9.2.3. フレームバッファのクリア\n指定した値でカラーバッファとデプス（ステンシル）バッファをクリアすることができます。\n コード 4-56. フレームバッファのクリア\n static nnResult nn::gd::Memory::ClearTargets(\n const nn::gd::RenderTarget* renderTarget,\n const nn::gd::DepthStencilTarget* depthStencilTarget,\n const u8 ColorRGBA[4], float depth, u8 stencil);\nこの関数内で nngxAddMemoryFillCommand() を呼び出していますので、実際の処理はコマンドリストの実行時に行われます。\n",0]
,["Pages/Page_54693545.html#PageId_54693600","4.9.2.4. カラーマスク",
"4.9.2.4. カラーマスク\n nn::gd::OutputStage::SetColorWriteMask() でカラーマスクの設定を変更し、カラーバッファへの書き込みを制御することができます。\n コード 4-57. カラーマスクの設定関数\n static void nn::gd::OutputStage::SetColorWriteMask(u32 mask);\n mask には、以下のフラグの論理和を指定します。\n 表 4-23. カラーマスクのフラグ\n \t定義 \t説明\n \t COLOR_WRITE_MASK_ENABLE_RED \t赤成分の書き込みを有効に設定\n \t COLOR_WRITE_MASK_ENABLE_GREEN \t緑成分の書き込みを有効に設定\n \t COLOR_WRITE_MASK_ENABLE_BLUE \t青成分の書き込みを有効に設定\n \t COLOR_WRITE_MASK_ENABLE_ALPHA \tアルファ成分の書き込みを有効に設定\n \t COLOR_WRITE_MASK_ENABLE_ALL \tすべての成分の書き込みを有効に設定（デフォルト）\n",0]
,["Pages/Page_54693545.html#PageId_54693601","4.9.3. デプステスト、ステンシルテスト",
"4.9.3. デプステスト、ステンシルテスト\nデプステストとステンシルテストの設定はステートオブジェクト（DepthStencilState オブジェクト）を作成し、アウトプットステージに設定する DepthStencilState オブジェクトを切り替えることでデプステストとステンシルテストに関する設定を一括で変更することができます。\n DepthStencilState オブジェクトの作成と解放、パイプラインへの設定は以下の関数で行うことができます。\n コード 4-58. DepthStencilState オブジェクトの作成、解放、パイプラインへの設定\n static nnResult nn::gd::OutputStage::CreateDepthStencilState(\n const nn::gd::DepthStencilStateDescription* desc,\n nn::gd::DepthStencilState** DepthStencilState);\nstatic nnResult nn::gd::OutputStage::ReleaseDepthStencilState(\n nn::gd::DepthStencilState* DepthStencilState);\nstatic nnResult nn::gd::OutputStage::SetDepthStencilState(\n const nn::gd::DepthStencilState* state, u8 stencilRef);\nデプスとステンシルのテストの設定は desc に指定するデスクリプタクラス（DepthStencilStateDescription）にあらかじめ設定します。デスクリプタクラスに設定する情報の詳細は「4.9.3.1. DepthStencilState オブジェクトのデスクリプタクラス」を参照してください。\n作成されたステートオブジェクトは nn::gd::OutputStage::SetDepthStencilState() でパイプラインに設定することができます。stencilRef には、ステンシルテストで使用する参照値を指定します。\n不要になったステートオブジェクトは nn::gd::OutputStage::ReleaseDepthStencilState() で解放してください。このとき、ステートオブジェクトとして作成されたときに内部で確保されたメモリ領域も解放されます。\n",0]
,["Pages/Page_54693545.html#PageId_54693602","4.9.3.1. DepthStencilState オブジェクトのデスクリプタクラス",
"4.9.3.1. DepthStencilState オブジェクトのデスクリプタクラス\n DepthStencilState オブジェクトのデスクリプタクラス（DepthStencilStateDescription クラス）のメンバを紹介し、設定に際しての注意点などを説明します。\n コード 4-59. DepthStencilStateDescription クラスの定義\n class nn::gd::DepthStencilStateDescription\n{\n gdBool m_DepthEnable;\n gdBool m_StencilEnable;\n u8 m_StencilWriteMask;\n u8 m_StencilReadMask;\n nn::gd::OutputStage::DepthWriteMask m_DepthMask;\n nn::gd::OutputStage::DepthFunction m_DepthFunc;\n nn::gd::OutputStage::StencilFunction m_StencilFunc;\n nn::gd::OutputStage::StencilOperation m_StencilFail;\n nn::gd::OutputStage::StencilOperation m_StencilZFail;\n nn::gd::OutputStage::StencilOperation m_StencilZPass;\n DepthStencilStateDescription();\n void ToDefault();\n};\n",0]
,["Pages/Page_54693545.html#Anchor_54693602_デプステストの有効化（m_DepthEnable）","デプステストの有効化（m_DepthEnable）",
"デプステストの有効化（m_DepthEnable）\nデプステストを有効にする場合は GD_TRUE を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693602_デプステストのライトマスク（m_DepthMask）","デプステストのライトマスク（m_DepthMask）",
"デプステストのライトマスク（m_DepthMask）\nデプステストのライトマスクを設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693602_デプステストの比較関数（m_DepthFunc）","デプステストの比較関数（m_DepthFunc）",
"デプステストの比較関数（m_DepthFunc）\nデプステストの比較関数を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693602_ステンシルテストの有効化（m_StencilEnable）","ステンシルテストの有効化（m_StencilEnable）",
"ステンシルテストの有効化（m_StencilEnable）\nステンシルテストを有効にする場合は GD_TRUE を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693602_ステンシルテストのライトマスク（m_StencilWriteMask）","ステンシルテストのライトマスク（m_StencilWriteMask）",
"ステンシルテストのライトマスク（m_StencilWriteMask）\nステンシルテストのライトマスクを設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693602_ステンシルテストのリードマスク（m_StencilReadMask）","ステンシルテストのリードマスク（m_StencilReadMask）",
"ステンシルテストのリードマスク（m_StencilReadMask）\nステンシルテストのリードマスクを設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693602_ステンシルテストの比較関数（m_StencilFunc）","ステンシルテストの比較関数（m_StencilFunc）",
"ステンシルテストの比較関数（m_StencilFunc）\nステンシルテストの比較関数を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693602_ステンシルテストの失敗時の処理（m_StencilFail）","ステンシルテストの失敗時の処理（m_StencilFail）",
"ステンシルテストの失敗時の処理（m_StencilFail）\nステンシルテストの失敗時の処理を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693602_ステンシルテストの成功時の処理（m_StencilZFail）","ステンシルテストの成功時の処理（m_StencilZFail）",
"ステンシルテストの成功時の処理（m_StencilZFail）\nステンシルテストに成功したが、デプステストに失敗したときの処理を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693602_ステンシルテストとデプステストの成功時の処理（m_StencilZPass）","ステンシルテストとデプステストの成功時の処理（m_StencilZPass）",
"ステンシルテストとデプステストの成功時の処理（m_StencilZPass）\nステンシルテストとデプステストの両方が成功したときの処理を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693602_デフォルトの設定（ToDefault()）","デフォルトの設定（ToDefault()）",
"デフォルトの設定（ToDefault()）\n ToDefault() で、すべてのメンバをデフォルトの値に変更することができます。この設定はコンストラクタでも行われています。\n 表 4-24. DepthStencilStateDescription クラスのデフォルト設定\n \tメンバ \tデフォルトの設定内容\n \t m_DepthEnable \t GD_FALSE\n \t m_DepthMask \t DEPTH_WRITE_MASK_ALL\n \t m_DepthFunc \t DEPTH_FUNCTION_LESS\n \t m_StencilEnable \t GD_FALSE\n \t m_StencilWriteMask\n m_StencilReadMask\n \t 0xFF\n \t m_StencilFunc \t STENCIL_FUNCTION_NEVER\n \t m_StencilFail\n m_StencilZFail\n m_StencilZPass\n \t STENCIL_OPERATION_KEEP\n",0]
,["Pages/Page_54693545.html#PageId_54693603","4.9.4. アルファテスト",
"4.9.4. アルファテスト\nアルファテストの設定は nn::gd::OutputStage::SetAlphaTest() で行います。\n コード 4-60. アルファテストの設定\n static void nn::gd::OutputStage::SetAlphaTest(\n gdBool enable, nn::gd::OutputStage::AlphaFunction func, u8 alphaRef);\nアルファテストを有効にする場合は enable に GD_TRUE、func に比較関数、alphaRef に参照値を指定してください。デフォルトの設定は、引数の順に GD_FALSE、ALPHA_FUNCTION_NEVER、0 です。\n",0]
,["Pages/Page_54693545.html#PageId_54693604","4.9.5. 論理演算、ブレンディング",
"4.9.5. 論理演算、ブレンディング\n論理演算とブレンディングの設定はステートオブジェクト（BlendState オブジェクト）を作成し、アウトプットステージに設定する BlendState オブジェクトを切り替えることで論理演算とブレンディングに関する設定を一括で変更することができます。\n BlendState オブジェクトの作成と解放、パイプラインへの設定は以下の関数で行うことができます。\n コード 4-61. BlendState オブジェクトの作成、解放、パイプラインへの設定\n static nnResult nn::gd::OutputStage::CreateBlendState(\n const nn::gd::BlendStateDescription* desc,\n nn::gd::BlendState** blendState);\nstatic nnResult nn::gd::OutputStage::ReleaseBlendState(\n nn::gd::BlendState* blendState);\nstatic nnResult nn::gd::OutputStage::SetBlendState(\n const nn::gd::BlendState* blendState);\n論理演算とブレンディングの設定は desc に指定するデスクリプタクラス（BlendStateDescription）にあらかじめ設定します。デスクリプタクラスに設定する情報の詳細は後述します。\n作成された BlendState オブジェクトは nn::gd::OutputStage::SetBlendState() でパイプラインに設定することができます。\n不要になったステートオブジェクトは nn::gd::OutputStage::ReleaseBlendState() で解放してください。このとき、ステートオブジェクトとして作成されたときに内部で確保されたメモリ領域も解放されます。\nブレンディングの設定のうち、ブレンドカラーの設定だけは以下の関数で行います。デフォルトのブレンドカラーは（0, 0, 0, 0）です。\n コード 4-62. ブレンドカラーの設定\n static void nn::gd::OutputStage::SetBlendColor(u8 R, u8 G, u8 B, u8 A);\n",0]
,["Pages/Page_54693545.html#PageId_54693605","4.9.5.1. BlendState オブジェクトのデスクリプタクラス",
"4.9.5.1. BlendState オブジェクトのデスクリプタクラス\n BlendState オブジェクトのデスクリプタクラス（BlendStateDescription クラス）のメンバを紹介し、設定に際しての注意点などを説明します。\n コード 4-63. BlendStateDescription クラスの定義\n class nn::gd::BlendStateDescription\n{\n nn::gd::OutputStage::BlendType m_BlendType;\n nn::gd::OutputStage::LogicOperator m_LogicOp;\n nn::gd::OutputStage::BlendFunction m_SrcRgb;\n nn::gd::OutputStage::BlendFunction m_DstRgb;\n nn::gd::OutputStage::BlendFunction m_SrcAlpha;\n nn::gd::OutputStage::BlendFunction m_DstAlpha;\n nn::gd::OutputStage::BlendEquation m_EqRgb;\n nn::gd::OutputStage::BlendEquation m_EqAlpha;\n BlendStateDescription();\n void ToDefault();\n void SetBlendFunc(\n nn::gd::OutputStage::BlendFunction src,\n nn::gd::OutputStage::BlendFunction dst,\n nn::gd::OutputStage::BlendEquation eq);\n void SetBlendFunc(\n nn::gd::OutputStage::BlendFunction srcRgb,\n nn::gd::OutputStage::BlendFunction dstRgb,\n nn::gd::OutputStage::BlendFunction srcAlpha,\n nn::gd::OutputStage::BlendFunction dstAlpha,\n nn::gd::OutputStage::BlendEquation eqRgb,\n nn::gd::OutputStage::BlendEquation eqAlpha);\n void SetBlendMode_DefaultBlending();\n void SetBlendMode_NoBlend();\n void SetLogicOperatorMode(nn::gd::OutputStage::LogicOperator logicOp);\n void SetLogicOperatorMode_Default();\n};\n",0]
,["Pages/Page_54693545.html#Anchor_54693605_論理演算とブレンディングの選択（m_BlendType）","論理演算とブレンディングの選択（m_BlendType）",
"論理演算とブレンディングの選択（m_BlendType）\n論理演算を使用する場合は BLEND_TYPE_LOGICOP、ブレンディングを使用する場合は BLEND_TYPE_BLENDING を設定します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693605_論理演算の演算方法（m_LogicOp）","論理演算の演算方法（m_LogicOp）",
"論理演算の演算方法（m_LogicOp）\n論理演算使用時の演算方法です。SetLogicOperatorMode() で設定することができます。\n SetLogicOperatorMode_Default() で設定した場合は LOGIC_OPERATOR_COPY が設定されます。\n",0]
,["Pages/Page_54693545.html#Anchor_54693605_ブレンディングの重み係数（m_SrcRgb、m_DstRgb、m_SrcAlpha、m_DstAlpha）","ブレンディングの重み係数（m_SrcRgb、m_DstRgb、m_SrcAlpha、m_DstAlpha）",
"ブレンディングの重み係数（m_SrcRgb、m_DstRgb、m_SrcAlpha、m_DstAlpha）\nブレンディングの重み係数です。ソースとデスティネーションそれぞれに RGB 成分とアルファ成分の設定が存在します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693605_ブレンディングの計算式（m_EqRgb、m_EqAlpha）","ブレンディングの計算式（m_EqRgb、m_EqAlpha）",
"ブレンディングの計算式（m_EqRgb、m_EqAlpha）\nブレンディングの計算式です。RGB 成分とアルファ成分の設定が存在します。\n",0]
,["Pages/Page_54693545.html#Anchor_54693605_ブレンディングの一括設定（SetBlendFunc()、SetBlendMode_NoBlend()）","ブレンディングの一括設定（SetBlendFunc()、SetBlendMode_NoBlend()）",
"ブレンディングの一括設定（SetBlendFunc()、SetBlendMode_NoBlend()）\n SetBlendFunc() はブレンディングの設定を一括して行います。RGB 成分とアルファ成分を同じまたは個別に設定することができます。\n SetBlendMode_NoBlend() はブレンディングが行われない（ソースそのままを出力する）設定に変更します。\n 表 4-25. SetBlendMode_NoBlend() によるブレンディング設定の変更\n \tメンバ \t設定\n \t m_SrcRgb、m_SrcAlpha \t BLEND_FUNCTION_ONE\n \t m_DstRgb、m_DstAlpha \t BLEND_FUNCTION_ZERO\n \t m_EqRgb、m_EqAlpha \t BLEND_EQUATION_ADD\n ",0]
,["Pages/Page_54693545.html#Anchor_54693605_デフォルトの設定（ToDefault()）","デフォルトの設定（ToDefault()）",
"デフォルトの設定（ToDefault()）\n ToDefault() で、すべてのメンバをデフォルトの値に変更することができます。この設定はコンストラクタでも行われています。\nデフォルトの設定ではブレンディングを使用し、ブレンディングの設定は SetBlendMode_NoBlend() で行われる設定と同じです。\n",0]
,["Pages/Page_54693545.html#PageId_54693606","4.9.6. w バッファ、ポリゴンオフセット",
"4.9.6. w バッファ、ポリゴンオフセット\nw バッファとポリゴンオフセットの設定は nn::gd::OutputStage::SetDepthRangeMode() で行います。\n コード 4-64. w バッファとポリゴンオフセットの設定\n static void nn::gd::OutputStage::SetDepthRangeMode(\n nn::gd::OutputStage::DepthBufferType type,\n f32 depthRangeNear, f32 depthRangeFar, s32 offset);\n type には、w バッファの機能を使用する場合は DEPTHBUFFER_LINEAR を指定し、w バッファの機能を使用せずに通常のデプス値の範囲を使用する場合は DEPTHBUFFER_RECIPROCAL_FUNCTION を指定します。\n depthRangeNear と depthRangeFar には、w バッファの機能を使用しない場合はデプスのニア値とファー値を指定します。w バッファの機能を使用する場合は depthRangeNear に 0、depthRangeFar にスケール値を指定します。\nポリゴンオフセット機能を使用する場合は、offset にポリゴンオフセットのオフセット値を指定します。\n",0]
,["Pages/Page_54693545.html#PageId_54693607","4.9.7. ソフトシャドウ",
"4.9.7. ソフトシャドウ\nソフトシャドウのスケールとバイアスの設定は nn::gd::OutputStage::SetPenumbraScaleBias() で行います。この関数はイミディエート関数ですので、実行と同時にコマンドバッファへの 3D コマンドの蓄積を行います。\n コード 4-65. ソフトシャドウの設定\n static void nn::gd::OutputStage::SetPenumbraScaleBias(f32 Scale, f32 Bias);\n",0]
,["Pages/Page_54693608.html","5. レイアウト変換",
"5. レイアウト変換\nブロックフォーマットとリニアフォーマット間のレイアウト変換を行う関数は nn::gd::Memory クラスに定義されています。\n",0]
,["Pages/Page_54693608.html#PageId_54693609","5.1. ブロックフォーマットからリニアフォーマットへの変換",
"5.1. ブロックフォーマットからリニアフォーマットへの変換\nブロックフォーマットからリニアフォーマットへの変換を行うための関数が用意されています。.\n コード 5-1. ブロックフォーマットからリニアフォーマットへの変換関数\n static nnResult nn::gd::Memory::CopyTexture2DResourceBlockToLinear(\n const nn::gd::Texture2DResource* source,\n s32 srcMipLevelIndex, u32 srcOffsetY, s32 srcCountRow,\n const nn::gd::Texture2DResource* dest,\n s32 dstMipLevelIndex, u32 dstOffsetY,\n nn::gd::Memory::DownScalingMode downScalingMode, gdBool yFlip);\nstatic nnResult nn::gd::Memory::CopyTexture2DResourceBlockToLinear(\n const nn::gd::Texture2DResource* source,\n s32 srcMipLevelIndex, u32 srcOffsetY,\n u8* dstAddr, u32 dstWidth, u32 dstHeight, u32 dstFormat,\n nn::gd::Memory::DownScalingMode downScalingMode, gdBool yFlip);\n source に指定された Texture2DResource オブジェクトのリソースデータが、ブロックフォーマットからリニアフォーマットに変換されて転送されます。また、変換するミップマップレベルを srcMipLevelIndex に指定することができます。-1 を指定した場合は Texture2DResource オブジェクトの最大のミップマップレベルが使用されます。\n srcOffsetY には変換を開始する Y 座標値を指定します。アドレッシングの違いを関数内で吸収しますので、リソースデータの座標値そのままを指定してください。\n転送先に Texture2DResource オブジェクトを指定する関数では、srcCountRow に変換するライン数を指定します。-1 を指定した場合は Texture2DResource オブジェクトの高さが使用されます。dstMipLevelIndex や dstOffsetY には、転送先のミップマップレベルと転送開始位置の Y 座標値を指定します。\n転送先にアドレスを指定する関数では、dstAddr に先頭アドレス、dstWidth に幅、dstHeight に高さ、dstFormat にピクセルフォーマットを指定します。\n downScalingMode にはアンチエイリアスの指定を、yFlip には縦方向のフリップを有効にする場合に GD_TRUE を指定します。\nこれらの関数は内部で nngxAddB2LTransferCommand() を呼び出していますので、実際の変換処理はコマンドリストの実行時に行われます。\nブロックフォーマットからリニアフォーマットへの変換関数は、主にカラーバッファからディスプレイバッファへの転送時に使用します。コードの例は「2.7. 描画結果の表示」にあります。\n",0]
,["Pages/Page_54693608.html#PageId_54693610","5.2. リニアフォーマットからブロックフォーマットへの変換",
"5.2. リニアフォーマットからブロックフォーマットへの変換\nリニアフォーマットからブロックフォーマットへの変換を行うための関数が用意されています。\n コード 5-2. リニアフォーマットからブロックフォーマットへの変換関数\n static nnResult nn::gd::Memory::CopyTexture2DResourceLinearToBlock(\n const nn::gd::Texture2DResource* source,\n s32 srcMipLevelIndex, u32 srcOffsetY, s32 srcCountRow,\n const nn::gd::Texture2DResource* dest,\n s32 dstMipLevelIndex, u32 dstOffsetY);\nstatic nnResult nn::gd::Memory::CopyTexture2DResourceLinearToBlock(\n u8* srcAddr, u32 width, u32 height,\n const nn::gd::Texture2DResource* dest,\n s32 dstMipLevelIndex, u32 dstOffsetY);\n dest に指定された Texture2DResource オブジェクトに、転送元のデータがリニアフォーマットからブロックフォーマットに変換されて転送されます。また、変換されたデータを受け取るミップマップレベルを dstMipLevelIndex に指定することができます。-1 を指定した場合は Texture2DResource オブジェクトの最大のミップマップレベルが使用されます。また、dstOffsetY にはデータの受け取りを開始する Y 座標値を指定します。アドレッシングの違いを関数内で吸収しますので、リソースデータの座標値そのままを指定してください。\n転送元に Texture2DResource オブジェクトを指定する関数では、srcCountRow に変換するライン数を指定します。-1 を指定した場合は Texture2DResource オブジェクトの高さが使用されます。srcMipLevelIndex と srcOffsetY には、転送元のミップマップレベルと転送開始位置の Y 座標値を指定します。\n転送元にアドレスを指定する関数では、srcAddr に先頭アドレス、width に幅、height に高さを指定します。\nこれらの関数は内部で nngxAddL2BTransferCommand() を呼び出していますので、実際の変換処理はコマンドリストの実行時に行われます。\n",0]
,["Pages/Page_54693611.html","6. パケットレコーディング",
"6. パケットレコーディング\nパケットレコーディング機能を用いると、ひとまとまりのコマンドパケットを記録しておき、あとで再生するような使い方が可能です。この機能は、カメラやライトの設定を除いた大部分が同じシーンを 2 回描画する立体視表示のように、繰り返し同じ描画を行う処理で有効に活用することができます。\nパケットレコーディング機能は以下の関数を用いて制御します。\n コード 6-1. パケットレコーディング機能の制御に使用する関数\n nn::gd::System::StartRecordingPackets(\n u32* forceDirtyModuleFlag,\n nn::gd::RecordingPacketUsage usage = RECORD_COMMAND_LIST_COPY);\nnn::gd::System::StopRecordingPackets(nn::gd::RecordedPacketId** packetId);\nnn::gd::System::ReplayPackets(nn::gd::RecordedPacketId* packetId,\n u32* forceDirtyModuleFlag);\nnn::gd::System::ReleasePackets(nn::gd::RecordedPacketId* packetId);\n3D コマンドバッファに出力される 3D コマンドと、リクエストバッファに出力されるコマンドリクエスト（「7.1. nngx 関数の内部使用」を参照）の両方が記録対象となります。\n不要になったコマンドパケットは nn::gd::System::ReleasePackets() で解放することができます。\n",0]
,["Pages/Page_54693611.html#Anchor_54693611_出力される3Dコマンドへの内部状態の影響","出力される 3D コマンドへの内部状態の影響",
"出力される 3D コマンドへの内部状態の影響\nGD ライブラリの内部状態によっては呼び出された関数が必ずしも 3D コマンドを出力するとは限らず、コマンドパケットの記録時に期待した通りの挙動にならないことがあります。再生時でも同じように、GPU の状態と GD ライブラリの内部状態が食い違ってしまうことがあります。この問題を回避するため、nn::gd::System::StartRecordingPackets() と nn::gd::System::ReplayRecordingPackets() はそれぞれフラグを引数として与えるようになっており、関数を実行する前にどのモジュールを「dirty」として扱うべきかを指示することができます。\n最も安全なフラグの設定は MODULE_ALL を指定して、すべてのモジュールを「dirty」として扱うことです。この指定ではすべての 3D コマンドが出力され、状態が破壊されることは絶対にありません。もし、どのモジュールの状態が記録／再生の対象になっているか、状態が衝突するかどうかについて利用する側で分かっていれば、それに合わせて必要最小限のモジュールのみを「dirty」に設定することで性能を改善することができます。\n",0]
,["Pages/Page_54693611.html#Anchor_54693611_コマンドパケットの編集","コマンドパケットの編集",
"コマンドパケットの編集\n記録されたコマンドパケットを再生前に編集することができます。3D コマンドバッファの更新位置は、パケットの記録中に（nn::gd::System::StartRecordingPackets() を呼び出して nn::gd::System::StopRecordingPackets() を呼び出すまでの間に）nn::gd::System::GetCommandBufferOffset() で取得した 3D コマンドバッファの出力先のオフセット値と、記録完了後に nn::gd::System::GetCommandBufferBaseAddress() で取得する 3D コマンドバッファのベースアドレスを組み合わせて算出します。ただし、3D コマンドの書き換えに実際に使用することができるのは、呼び出しと同時に 3D コマンドを 3D コマンドバッファに出力するイミディエート関数だけです。\n",0]
,["Pages/Page_54693611.html#Anchor_54693611_引数usageによる3Dコマンドバッファのコピー指定","引数 usage による 3D コマンドバッファのコピー指定",
"引数 usage による 3D コマンドバッファのコピー指定\n nn::gd::System::StartRecordingPackets() の usage に RECORD_COMMAND_LIST_COPY を指定したときは、引数が追加される以前と同様に、3D コマンドバッファのコピーを作成します。そのため、記録されたコマンドパケットの 3D コマンドを書き換えることができます。\n一方、usage に RECORD_COMMAND_LIST_NO_COPY を指定したときは、3D コマンドバッファのコピーが作成されないため、処理時間が短くなりますが 3D コマンドを書き換えることができません。また、コピー元の 3D コマンドバッファをクリアすると、コマンドパケットの実行ができなくなります。\n usage に RECORD_3D_COMMAND_BUFFER_FOR_JUMP を指定してパケットの記録を開始した場合、nn::gd::System::ReplyPackets() は 3D コマンドバッファのコピーを作成し、nngxAddSubroutineCommand() によるジャンプコマンドの挿入とジャンプによる実行を行います。\n",0]
,["Pages/Page_54693615.html","7. GX ライブラリとの関係",
"7. GX ライブラリとの関係\nライブラリの関数内で呼び出している nngx 関数や、nngx 関数との関係で注意が必要となる特殊なケースを説明します。\n",0]
,["Pages/Page_54693615.html#PageId_54693616","7.1. nngx 関数の内部使用",
"7.1. nngx 関数の内部使用\nGD ライブラリの関数の中には、内部で nngx 関数を呼び出すものが存在します。以下の表に記されている関数は、「条件」欄にある条件が満たされてエラーも発生していないときに、内部で nngx 関数を呼び出します。ただし、同一の関数でも条件によって異なる nngx 関数が呼び出されることがあります。\n条件が「常に」と記載されているものは、エラーが発生した場合を除いて、示された nngx 関数が常に呼び出されます。\n 表 7-1. 内部で nngx 関数を呼び出す GD ライブラリの関数\n \tGD 関数 \t条件 \tnngx 関数\n \t System::\nStartRecordingPackets() \t常に \t nngxStartCmdlistSave()\n \t System::\nStopRecordingPackets() \t常に \t nngxSplitDrawCmdlist()\n nngxStopCmdlistSave()\n nngxExportCmdlist()\n \t System::ReplayPackets() \t常に \t nngxImportCmdlist()\n \t System::\nExecute3DCommandList() \t常に \t nngxSplitDrawCmdlist()\n \t Resource::\nCreateTexture2DResource() \t初期データがあり、VRAM に確保したメモリにコピー \t nngxAddVramDmaCommand()\n \t初期データがあり、デバイスメモリに確保したメモリにコピー \t nngxUpdateBuffer()\n \t初期データがあり、ミップマップを自動生成 \t nngxFilterBlockImage()\n \t Memory::GenerateMipMaps() \t常に \t nngxFilterBlockImage()\n \t描画依存関係がある \t nngxSplitDrawCmdlist()\n \t Resource::\nCreateVertexBufferResource() \t初期データがあり、VRAM に確保したメモリにコピー \t nngxAddVramDmaCommand()\n \t初期データがあり、デバイスメモリに確保したメモリにコピー \t nngxUpdateBuffer()\n \t Memory::\nCopyTextureSubResource() \t常に \t nngxAddBlockImageCopyCommand()\n \t描画依存関係がある \t nngxSplitDrawCmdlist()\n \t Memory::\nCopyVertexBufferSubResource() \t常に \t nngxAddBlockImageCopyCommand()\n \t Memory::\nCopyTexture2DResource\nBlockToLinear() \t常に \t nngxAddB2LTransferCommand()\n \t描画依存関係がある \t nngxSplitDrawCmdlist()\n \t Memory::\nCopyTexture2DResource\nLinearToBlock() \t常に \t nngxAddL2BTransferCommand()\n \t描画依存関係がある \t nngxSplitDrawCmdlist()\n \t Memory::ClearTargets() \t常に \t nngxAddMemoryFillCommand()\n \t描画依存関係がある \t nngxSplitDrawCmdlist()\n \t Memory::\nClearTexture2DResource() \t常に \t nngxAddMemoryFillCommand()\n \t描画依存関係がある \t nngxSplitDrawCmdlist()\n \t Resource::\nUnmapTexture2DResource \tデバイスメモリにあるリソースを書き込みありでマッピング \t nngxUpdateBuffer()\n \t Resource::\nUnmapVertexBufferResource \tデバイスメモリにあるリソースを書き込みありでマッピング \t nngxUpdateBuffer()\n",0]
,["Pages/Page_54693615.html#PageId_54693617","7.2. nngx 関数との相互作用",
"7.2. nngx 関数との相互作用\nGD ライブラリを利用する上で、nngx 関数との関係に注意が必要となる特殊なケースを示します。\n",0]
,["Pages/Page_54693615.html#PageId_54693618","7.2.1. 初期データを持つテクスチャを VRAM 上に作成",
"7.2.1. 初期データを持つテクスチャを VRAM 上に作成\n初期データを用いて VRAM 上にリソースを作成することになるため、初期データをメインメモリから VRAM に転送する DMA 転送コマンドがコマンドリクエストキューに追加されます。GD ライブラリではコマンドリクエストの実行を管理していないため、初期データを解放する前に DMA 転送の完了をアプリケーションで確認する必要があります。\n以下のコード例のように、nngxWaitCmdlistDone() を呼べばすべてのコマンドリクエストの完了を待つことができます。ただしコマンドリストをダブルバッファ化している場合は、現在のコマンドリクエストキューに追加された DMA 転送コマンドが次のフレームまで実行されないことに注意してください。\n コード 7-1. 初期データを持つテクスチャを VRAM 上に作成\n nn::gd::Texture2DResource* texture2DResource = 0;\nnn::gd::Texture2DResourceDescription Text2DResDesc =\n{\n width, height, 1, nn::gd::Resource::NATIVE_FORMAT_RGB_888,\n nn::gd::Memory::LAYOUT_BLOCK_8, nn::gd::Memory::VRAMA\n};\nnn::gd::Resource::CreateTexture2DResource(\n &Text2DResDesc, data, GD_TRUE, &texture2DResource);\n// リソースはVRAM上に作成されるため、解放前にDMA転送の完了を確認しなければならない\nnngxWaitCmdlistDone();\nfree(data);\n",0]
,["Pages/Page_54693615.html#PageId_54693619","7.2.2. 描画結果へのアクセス",
"7.2.2. 描画結果へのアクセス\nレンダリング後にカラーバッファやデプス（ステンシル）バッファ、テクスチャの内容にアクセスして描画結果を直接書き換えたい場合、CPU から直接 VRAM 上のデータにアクセスすることはできませんので、以下のような手順が必要となります。\n \t一時的なリソースをデバイスメモリに確保する \tVRAM 上にあるリソースを一時的なリソースにコピーする（VRAM からのデータ転送） \t一時的なリソースを書き換える \tVRAM 上にあるリソースに一時的なリソースの内容を書き戻す（VRAM へのデータ転送）\nVRAM からのデータ転送と VRAM へのデータ転送はコマンドリクエストによって実行されます。そのため、リソースを書き換える前や一時的に確保したリソースを解放する前に、コマンドリクエストの実行が完了するのを待たなければなりません。\n実際のコードでは以下のような流れになります。\n コード 7-2. 描画結果へのアクセス\n // デバイスメモリ(FCRAM)上に一時的なリソースを確保\nnn::gd::Texture2DResource* tmpResource= 0;\nnn::gd::Texture2DResourceDescription tmpResourceDesc =\n{\n s_RenderTextureWidth, s_RenderTextureHeight, 1,\n nn::gd::Resource::NATIVE_FORMAT_RGBA_8888,\n nn::gd::Memory::LAYOUT_BLOCK_8,\n nn::gd::Memory::FCRAM\n};\nres = nn::gd::Resource::CreateTexture2DResource(\n &tmpResourceDesc, 0, GD_FALSE, &tmpResource);\n// VRAM 上のリソースを一時的なリソースにコピー\nnn::gd::Memory::Rect memRect(0, 0, -1, -1);\nres = nn::gd::Memory::CopyTextureSubResource(\n s_texture2DResource_ColorBuffer, 0, memRect, tmpResource, 0, 0, 0);\n// アクセスするためにリソースをマップする\nu8* data;\nnn::gd::Resource::MapTexture2DResource(\n tmpResource, 0, nn::gd::Resource::MAP_READ_WRITE, (void**)&data);\n// データにアクセスする前にコマンドの実行完了待ちが必要\nnngxWaitCmdlistDone();\n// ここでマップしたリソースに書き込む\nfor (int y=0; y<s_RenderTextureHeight*s_RenderTextureWidth>>1; y++)\n{\n data[k+] = 255; data[k] = 255; data[k] = 255; data[k+] = 255;\n}\n// マッピング解除時に一時的なリソースへの変更が確定される\nnn::gd::Resource::UnmapTexture2DResource(tmpResource);\n// 一時的なリソースから VRAM 上のリソースにコピー\nnn::gd::Memory::CopyTextureSubResource(\n tmpResource, 0, memRect, s_texture2DResource_ColorBuffer, 0, 0, 0);\n",0]
,["Pages/Page_54693620.html","8. ほかのライブラリやフレームワークとの連携",
"8. ほかのライブラリやフレームワークとの連携\nほかのグラフィックス関連のライブラリやフレームワークと平行して、GD ライブラリを利用する際の注意点を説明します。\n",0]
,["Pages/Page_54693620.html#PageId_54693621","8.1. 初期化時の注意点",
"8.1. 初期化時の注意点\nほかのフレームワーク（NintendoWare など）と同じコマンドリストを使用する場合は、コマンドリストの初期化を複数回呼ぶことがないように注意してください。\n コード 2-1 で示したコードを例にすると、NintendoWare でコマンドリスト関連の初期化を済ませていた場合は GD ライブラリの初期化関数（nn::gd::System::Initialize()）のみを呼び出します。\n",0]
,["Pages/Page_54693620.html#PageId_54693622","8.2. nn::gd::System::ForceDirty() の利用",
"8.2. nn::gd::System::ForceDirty() の利用\nGD ライブラリの関数以外で 3D コマンドを 3D コマンドバッファに書き込んだ場合、GD ライブラリの内部状態と GPU との同期が取れなくなる可能性があります。そのような場合には、nn::gd::System::ForceDirty() を呼び出していくつかのモジュールを「dirty」にし、対応するモジュールのすべての 3D コマンドが再送されるようにします。\n ForceDirty() によって「dirty」となったモジュールは、描画コマンドが実行されたタイミングで 3D コマンドを生成します。すぐに 3D コマンドを生成する場合は、nn::gd::System::FlushDirtyModule() を呼び出してください。\nイミディエート関数で設定されたレジスタの内容は GD ライブラリ内では保持していません。そのため、イミディエート関数でレジスタの内容を書き換えていた場合は、3D コマンドが生成されたあとにイミディエート関数を呼び出して、再度レジスタの内容を設定する必要があります。\n内部状態については「1.2.2. モジュールの状態管理」を参照してください。\n",0]
,["Pages/Page_54693620.html#PageId_54693623","8.3. コマンドリストの二重化",
"8.3. コマンドリストの二重化\nGD ライブラリの関数の中には、コマンドリクエストをキューイングするものがあります。コマンドリストが実行されるまでキューイングされたコマンドリクエストは実行されることはありませんので、そのコマンドリストが実行される前にコマンドリクエストで扱ったリソースを書き換えたり削除したりしないように特に注意してください。\n2 つのコマンドリストを利用しているフレームワークでも同様の注意が必要です。これは、コマンドリストを二重化している場合に、次のフレームの作成に使用するコマンドリストにコマンドリクエストがキューイングされるためです。\n",0]
,["Pages/Page_54693620.html#PageId_54693624","8.4. ダミーコマンドの挿入",
"8.4. ダミーコマンドの挿入\n nn::gd::System::AddDummyCommands() を呼び出して、GPU に命令として認識されないダミーコマンドをコマンドバッファに追加することができます。ダミーコマンドは、次に実行するコマンドまで Wait しなければならないときや、コマンドバッファのサイズ調整に利用します。\n",0]
,["Pages/Page_54693625.html","9. 付録",
"9. 付録\n",0]
,["Pages/Page_54693625.html#PageId_54693626","9.1. イミディエート関数一覧",
"9.1. イミディエート関数一覧\nイミディエート関数の一覧を以下に示します。\n 表 9-1. イミディエート関数一覧\n \tクラス \t関数\n \t nn::gd::CombinerStage \t SetTextureCombinerUnitConstantColor()\n \t nn::gd::FogStage \t UploadFogLookUpTableFloat()\n \t UploadFogLookUpTableNative()\n \t UploadGasLookUpTableFloat()\n \t UploadGasLookUpTableNative()\n \t nn::gd::LightingStage \t SetGlobalColorAmbient()\n \t UploadLookUpTableFloat()\n \t UploadLookUpTableNative()\n \t nn::gd::Light \t SetColorAmbient()\n \t SetColorDiffuse()\n \t SetColorSpecular0()\n \t SetColorSpecular1()\n \t SetPosition()\n \t SetDirection()\n \t SetSpotDirection()\n \t SetLightType()\n \t SetDistanceAttenuationScaleBias()\n \t EnableTwoSideDiffuse()\n \t EnableGeomFactor0()\n \t EnableGeomFactor1()\n \t UploadLookUpTableFloat()\n \t UploadLookUpTableNative()\n \t nn::gd::ProceduralTextureStage \t UploadLookUpTableRgbMapFloat()\n \t UploadLookUpTableRgbMapNative()\n \t UploadLookUpTableAlphaMapFloat()\n \t UploadLookUpTableAlphaMapNative()\n \t UploadLookUpTableNoiseMapFloat()\n \t UploadLookUpTableNoiseMapNative()\n \t UploadLookUpTableColorMapFloat()\n \t UploadLookUpTableColorMapNative()\n \t nn::gd::ShaderStage \t SetFloatConstantBuffer()\n \t nn::gd::OutputStage \t SetPenumbraScaleBias()\n \t nn::gd::RasterizerStage \t SetCulling()\n \t SetViewport()\n \t EnableClippingPlane()\n \t SetClippingPlane()\n \t EnableScissor()\n \t SetScissor()\n",0]
,["Pages/Page_54693625.html#PageId_54693627","9.2. 関数内で確保されるメモリのサイズ",
"9.2. 関数内で確保されるメモリのサイズ\n下記のサイズは GX ライブラリの初期化時に指定したアロケータへ渡される値です。\n備考欄に記載されていない限り、用途は NN_GX_MEM_SYSTEM、メモリの指定は NN_GX_MEM_FCRAM です。\n 表 9-2. 関数内で確保されるメモリ\n \t関数 \tサイズ \t備考\n \t System::Initialize() \t24 Byte \t管理情報\n \t12 Byte \t管理情報\n \t12 Byte \t管理情報\n \t28 Byte \t管理情報\n \t12 Byte \t管理情報\n \t1536 Byte \t管理情報\n \t52 Byte \t管理情報\n \t28 Byte \t管理情報\n \t12 Byte \t管理情報\n \t1664 Byte \t管理情報\n \t56 Byte \t管理情報\n \t28 Byte \t管理情報\n \t12 Byte \t管理情報\n \t2688 Byte \t管理情報\n \t28 Byte \t管理情報\n \t12 Byte \t管理情報\n \t14208 Byte \t管理情報\n \t616 Byte \t管理情報\n \t28 Byte \t管理情報\n \t12 Byte \t管理情報\n \t1664 Byte \t管理情報\n \t60 Byte \t管理情報\n \t28 Byte \t管理情報\n \t12 Byte \t管理情報\n \t640 Byte \t管理情報\n \t328 Byte \t3D コマンド\n（ジオメトリシェーダを使用する設定に共用プロセッサを変更する）\n \t328 Byte \t3D コマンド\n（ジオメトリシェーダを使用しない設定に共用プロセッサを変更する）\n \t Resource::CreateTexture2DResource() \t52 Byte \t管理情報\n \t16 Byte \t管理情報\n \tデータによる \t初期データあり、かつコピーなしでなければ、指定されたメモリに NN_GX_MEM_TEXTURE で確保されます\n \t Resource::\nCreateTexture2DResourceCastFrom() \t64 Byte \t管理情報\n \t Resource::Helper::\nConvertTextureResourceToNativeFormat() \tデータによる \t変換で使用する一時的なバッファのため、関数の終了時に解放されます\n \t Resource::Helper::ConvertCompressed\nTextureResourceToNativeFormat() \tデータによる \t変換で使用する一時的なバッファのため、関数の終了時に解放されます\n \t Resource::CreateRenderTarget() \t48 Byte \t管理情報\n \t Resource::CreateDepthStecilTarget() \t52 Byte \t管理情報\n \t TextureStage::CreateTexture2D() \t64 Byte \t管理情報\n \t TextureStage::CreateTextureCube() \t112 Byte \t管理情報\n \t ShaderStage::CreateShaderBinary() \t28 Byte \t管理情報\n \tデータによる \t管理情報\n \tデータによる \t管理情報\n \tデータによる \t管理情報\n \tデータによる \t管理情報\n \tデータによる \t管理情報\n \tデータによる \t管理情報\n \t20 Byte \t管理情報\n \tデータによる \t3D コマンド\n \tデータによる \t3D コマンド\n \t ShaderStage::CreateShader() \t20 Byte \t管理情報\n \tデータによる \t3D コマンド\n \t ShaderStage::CreateShaderPipeline() \t148 Byte \t管理情報\n \tデータによる \t3D コマンド\n \tデータによる \tユニフォーム設定の値\n（頂点シェーダ）\n \tデータによる \tユニフォーム設定の値\n（ジオメトリシェーダ）\n \t VertexInputStage::CreateInputLayout() \t204 Byte \t管理情報\n \tデータによる \t InputElementDescription クラス（複数の場合あり）\n \t Resource::CreateVertexBufferResource() \t24 Byte \t管理情報\n \tデータによる \t初期データあり、かつコピーなしでなければ、指定されたメモリに NN_GX_MEM_VERTEXBUFFER で確保されます\n \t CombinerStage::\nCreateTextureCombinerState() \t616 Byte \t管理情報\n \t92 Byte \t管理情報\n \t TextureStage::CreateSamplerState() \t60 Byte \t管理情報\n \t OutputStage::CreateDepthStecilState() \t52 Byte \t管理情報\n \t OutputStage::CreateBlendState() \t56 Byte \t管理情報\n \t System::StartRecordingPackets() \t36 Byte \t管理情報\n \t System::StopRecordingPackets() \tデータによる \t記録された 3D コマンド\n",0]
,["Pages/Page_54693625.html#PageId_54693628","9.3. デバッグサポート機能",
"9.3. デバッグサポート機能\nGD ライブラリでは、描画時の動作を変更するフィルタ機能など、デバッグに便利な機能を用意しています。\n",0]
,["Pages/Page_54693625.html#PageId_54693629","9.3.1. フィルタ機能",
"9.3.1. フィルタ機能\nフィルタ機能では、フラグ指定で描画時の動作を変更することができます。フィルタ機能は、Debug または Development でコンパイルされたときのみ有効です。\n コード 9-1. フィルタ機能の指定関数\n static nnResult nn::gd::System::Debug::SetFilter(\n u32 filterFlag, u32 drawStartIndex, s32 drawCount);\n drawStartIndex で指定された回数の描画が行われたあと、drawCount で指定された回数の描画が行われるまでフィルタ機能が有効になります。\n filterFlag には、以下のフラグから有効にする機能を論理和で指定します。\n 表 9-3. フィルタ機能のフラグ\n \tフラグ \t説明\n \t FILTER_NONE \t単独で指定するとフィルタ機能が無効になります。\n \t FILTER_TEXTURE_8X8 \t描画に使用するテクスチャすべてを固定の 8x8 テクスチャに変更します。\n \t FILTER_TEXTURE_CUSTOM \t描画に使用するテクスチャすべてを SetCustomTexture() で指定されたカスタムテクスチャに変更します。カスタムテクスチャが指定されていない場合は、固定の 8×8 テクスチャが使用されます。\n \t FILTER_SAMPLER_STATE_FILTER_\nNEAREST_MIPMAP_NEAREST \tテクスチャの縮小時フィルタの設定を、強制的に GL_NEAREST_MIPMAP_NEAREST に設定します。\n \t FILTER_SAMPLER_STATE_FILTER_\nLINEAR_MIPMAP_NEAREST \tテクスチャの縮小時フィルタの設定を、強制的に GL_LINEAR_MIPMAP_NEAREST に設定します。\n \t FILTER_VIEWPORT_1X1 \tビューポートの設定を 1×1 に変更します。\n \t FILTER_SIMPLE_COMBINER \tコンバイナの設定を変更し、すべてのピクセルが緑で出力されます。\n \t FILTER_DISABLE_BLENDING \tブレンディングを無効にします。\n \t FILTER_DISABLE_DEPTH_STENCIL_TEST \tデプス、ステンシルのテストを無効にします。\n \t FILTER_DISABLE_ALPHA_TEST \tアルファテストを無効にします。\n \t FILTER_LIGHTING_STAGE_1_LIGHT_MAX \tライティングの最大数を 1 に変更します。複数のライトを有効に設定した場合は、最初に有効となったライトのみが有効になります。\n \t FILTER_LIGHTING_STAGE_SIMPLE_\nLAYER_CONFIGURATION \tライティングに必要なサイクル数が最小となるレイヤコンフィグレーションに変更します。\n \t FILTER_DISABLE_DRAW \t描画を無効にします。\n \t FILTER_VISUALIZE_OVERDRAW \t描画されたピクセルが徐々に白くなるようにブレンディングの設定を追加し、重複して描画が行われるピクセルを視覚化します。デプス、ステンシルを無効にするフィルタを併用することで、テストで破棄される（破棄されない）ピクセルを確認することができます。\n \t FILTER_DISABLE_CULLING \tカリングを無効に変更します。\n \t FILTER_ENABLE_CULLING_CLOCKWISE \tカリングを時計回りに変更します。\n \t FILTER_ENABLE_CULLING_COUNTERCLOCKWISE \tカリングを反時計回りに変更します。\n",0]
,["Pages/Page_54693625.html#PageId_54693630","9.3.2. ミップマップレベルの視覚化",
"9.3.2. ミップマップレベルの視覚化\n nn::gd::System::Debug::ColorizeMipmaps() は、テクスチャリソースを指定されたミップマップレベルごとに指定された色で塗りつぶし、ミップマップレベルの視覚化をサポートします。\n コード 9-2. ミップマップレベルの視覚化をサポートする関数\n static nnResult nn::gd::System::Debug::ColorizeMipmaps(\n nn::gd::Texture2DResource* texture2DResource,\n s32 minMipLevelIndex, s32 maxMipLevelIndex, u8 colors[][4]);\n minMipLevelIndex と maxMipLevelIndex にはそれぞれ、塗りつぶすミップマップレベルの最小のインデックスと最大のインデックスを指定します。どちらの引数も、-1 が指定された場合は texture2DResource で指定されたテクスチャリソースが持つ、最大のミップマップレベルを指定したことになります。\n colors で指定されたカラーは、minMipLevelIndex で指定されたミップマップレベルから順に使用されます。つまり、minMipLevelIndex に指定されたミップマップレベルのテクスチャが colors[0] に指定されたカラーで塗りつぶされ、次のミップマップレベルのテクスチャは colors[1] に指定されたカラーで塗りつぶされます。\n colors に NULL を指定したときは、デフォルトのカラー配列を使用して塗りつぶします。デフォルトのカラー配列については、関数リファレンスを参照してください。\n",0]
];
for (var x = 0; x < additionalData.length; x++) Search.indexData.push(additionalData[x]);
Search.additionalData = additionalData;
})();
